import { setInterval, setTimeout } from "@deno/shim-timers";
export { setInterval, setTimeout } from "@deno/shim-timers";
import { WeakRef } from "@deno/sham-weakref";
export { WeakRef } from "@deno/sham-weakref";
import { Blob } from "isomorphic-blob";
export { Blob } from "isomorphic-blob";
import { Request, Response, Headers } from "isomorphic-undici-ponyfill";
export { Request, Response, Headers } from "isomorphic-undici-ponyfill";
import { WritableStream, TransformStream, ReadableStream, TransformStreamDefaultController, WritableStreamDefaultWriter } from "@sgwilym/isomorphic-streams";
export { WritableStream, TransformStream, ReadableStream, TransformStreamDefaultController, WritableStreamDefaultWriter } from "@sgwilym/isomorphic-streams";
import { default as WebSocket } from "isomorphic-ws";
export { default as WebSocket } from "isomorphic-ws";
import { TextEncoder, TextDecoder } from "textencoder-ponyfill";
export { TextEncoder, TextDecoder } from "textencoder-ponyfill";
import { URLPattern as URLPattern } from "@sgwilym/urlpattern-polyfill";
export { URLPattern as URLPattern } from "@sgwilym/urlpattern-polyfill";
const dntGlobals = {
    setInterval,
    setTimeout,
    WeakRef,
    Blob,
    Request,
    Response,
    Headers,
    WritableStream,
    TransformStream,
    ReadableStream,
    TransformStreamDefaultController,
    WritableStreamDefaultWriter,
    WebSocket,
    TextEncoder,
    TextDecoder,
    URLPattern,
};
export const dntGlobalThis = createMergeProxy(globalThis, dntGlobals);
// deno-lint-ignore ban-types
function createMergeProxy(baseObj, extObj) {
    return new Proxy(baseObj, {
        get(_target, prop, _receiver) {
            if (prop in extObj) {
                return extObj[prop];
            }
            else {
                return baseObj[prop];
            }
        },
        set(_target, prop, value) {
            if (prop in extObj) {
                delete extObj[prop];
            }
            baseObj[prop] = value;
            return true;
        },
        deleteProperty(_target, prop) {
            let success = false;
            if (prop in extObj) {
                delete extObj[prop];
                success = true;
            }
            if (prop in baseObj) {
                delete baseObj[prop];
                success = true;
            }
            return success;
        },
        ownKeys(_target) {
            const baseKeys = Reflect.ownKeys(baseObj);
            const extKeys = Reflect.ownKeys(extObj);
            const extKeysSet = new Set(extKeys);
            return [...baseKeys.filter((k) => !extKeysSet.has(k)), ...extKeys];
        },
        defineProperty(_target, prop, desc) {
            if (prop in extObj) {
                delete extObj[prop];
            }
            Reflect.defineProperty(baseObj, prop, desc);
            return true;
        },
        getOwnPropertyDescriptor(_target, prop) {
            if (prop in extObj) {
                return Reflect.getOwnPropertyDescriptor(extObj, prop);
            }
            else {
                return Reflect.getOwnPropertyDescriptor(baseObj, prop);
            }
        },
        has(_target, prop) {
            return prop in extObj || prop in baseObj;
        },
    });
}
