var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _AsyncQueue_instances, _AsyncQueue_queue, _AsyncQueue_resolve, _AsyncQueue_error, _AsyncQueue_handleError, _AsyncQueue_enqueue;
export const END = Symbol("Stream ended.");
export const ERROR = Symbol("Stream errored.");
export class AsyncQueue {
    constructor(streamPromise) {
        _AsyncQueue_instances.add(this);
        _AsyncQueue_queue.set(this, []);
        _AsyncQueue_resolve.set(this, null);
        _AsyncQueue_error.set(this, void 0);
        Object.defineProperty(this, "push", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (...data) => {
                if (data.length)
                    __classPrivateFieldGet(this, _AsyncQueue_instances, "m", _AsyncQueue_enqueue).call(this, false, data);
                else {
                    __classPrivateFieldGet(this, _AsyncQueue_instances, "m", _AsyncQueue_enqueue).call(this, false, [ERROR]);
                    __classPrivateFieldGet(this, _AsyncQueue_instances, "m", _AsyncQueue_handleError).call(this, new Error("AsyncQueueError: queue.push was called with no arguments"));
                }
            }
        });
        Object.defineProperty(this, "close", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ({ immediately = false, withError } = {}) => {
                if (withError)
                    __classPrivateFieldGet(this, _AsyncQueue_instances, "m", _AsyncQueue_handleError).call(this, withError);
                __classPrivateFieldGet(this, _AsyncQueue_instances, "m", _AsyncQueue_enqueue).call(this, immediately, [withError ? ERROR : END]);
                this.push = this.close = () => { };
            }
        });
        streamPromise
            ?.catch?.(err => this.close({ withError: err }))
            ?.finally?.(() => this.close());
    }
    get length() { return __classPrivateFieldGet(this, _AsyncQueue_queue, "f").length; }
    async *[(_AsyncQueue_queue = new WeakMap(), _AsyncQueue_resolve = new WeakMap(), _AsyncQueue_error = new WeakMap(), _AsyncQueue_instances = new WeakSet(), _AsyncQueue_handleError = function _AsyncQueue_handleError(err) {
        if (__classPrivateFieldGet(this, _AsyncQueue_error, "f") instanceof AggregateError)
            __classPrivateFieldGet(this, _AsyncQueue_error, "f").errors.push(err);
        else if (__classPrivateFieldGet(this, _AsyncQueue_error, "f"))
            __classPrivateFieldSet(this, _AsyncQueue_error, new AggregateError([__classPrivateFieldGet(this, _AsyncQueue_error, "f"), err]), "f");
        else
            __classPrivateFieldSet(this, _AsyncQueue_error, err, "f");
    }, _AsyncQueue_enqueue = function _AsyncQueue_enqueue(immediate, data) {
        __classPrivateFieldGet(this, _AsyncQueue_queue, "f")[immediate ? "unshift" : "push"](...data);
        __classPrivateFieldGet(this, _AsyncQueue_resolve, "f")?.call(this, __classPrivateFieldGet(this, _AsyncQueue_queue, "f").shift());
        __classPrivateFieldSet(this, _AsyncQueue_resolve, null, "f");
    }, Symbol.asyncIterator)]() {
        while (true) {
            const value = __classPrivateFieldGet(this, _AsyncQueue_queue, "f").length
                ? __classPrivateFieldGet(this, _AsyncQueue_queue, "f").shift()
                : await new Promise(res => { __classPrivateFieldSet(this, _AsyncQueue_resolve, res, "f"); });
            if (value === ERROR)
                throw __classPrivateFieldGet(this, _AsyncQueue_error, "f");
            if (value === END)
                break;
            yield value;
        }
    }
}
