export const objConfig = {
    encode: {
        emptySet: (canRespond) => ({
            type: "emptySet",
            canRespond,
        }),
        lowerBound: (x) => ({
            type: "lowerBound",
            value: x,
        }),
        payload: (v, end) => ({
            type: "payload",
            payload: v,
            ...(end ? { end } : {}),
        }),
        emptyPayload: (upperBound) => ({
            type: "emptyPayload",
            upperBound,
        }),
        done: (y) => ({
            type: "done",
            upperBound: y,
        }),
        fingerprint: (fp, y) => ({
            type: "fingerprint",
            fingerprint: fp,
            upperBound: y,
        }),
        terminal: () => ({
            type: "terminal",
        }),
    },
    decode: {
        getType: (obj) => {
            if ("type" in obj === false) {
                throw "Can't determine type";
            }
            return obj.type;
        },
        emptySet: (obj) => {
            if (obj.type === "emptySet") {
                return obj.canRespond;
            }
            throw "Couldn't decode";
        },
        lowerBound: (obj) => {
            if (obj.type === "lowerBound") {
                return obj.value;
            }
            throw "Couldn't decode";
        },
        payload: (obj) => {
            if (obj.type === "payload") {
                return {
                    value: obj.payload,
                    ...(obj.end ? { end: obj.end } : {}),
                };
            }
            throw "Couldn't decode";
        },
        emptyPayload: (obj) => {
            if (obj.type === "emptyPayload") {
                return obj.upperBound;
            }
            throw "Couldn't decode";
        },
        done: (obj) => {
            if (obj.type === "done") {
                return obj.upperBound;
            }
            throw "Couldn't decode";
        },
        fingerprint: (obj) => {
            if (obj.type === "fingerprint") {
                return {
                    fingerprint: obj.fingerprint,
                    upperBound: obj.upperBound,
                };
            }
            throw "Couldn't decode";
        },
        terminal: (obj) => {
            if (obj.type === "terminal") {
                return true;
            }
            throw "Couldn't decode";
        },
    },
};
