import { deferred, } from "../../../std@0.158.0/async/deferred.js";
/** A promise which can be teed off into more promises which will resolve when the original does. */
export class TeeableDeferred {
    constructor() {
        Object.defineProperty(this, "deferreds", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        Object.defineProperty(this, "state", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: "pending"
        });
    }
    resolve(value) {
        if (this.state !== "pending") {
            return;
        }
        this.state = "fulfilled";
        for (const deferred of this.deferreds) {
            deferred.resolve(value);
        }
    }
    reject(reason) {
        if (this.state !== "pending") {
            return;
        }
        this.state = "rejected";
        for (const deferred of this.deferreds) {
            deferred.reject(reason);
        }
    }
    tee() {
        const promise = deferred();
        if (this.state === "fulfilled") {
            promise.resolve();
        }
        else if (this.state === "rejected") {
            promise.reject();
        }
        else {
            this.deferreds.add(promise);
        }
        return promise;
    }
}
