export class UpdatableHash {
    constructor(opts) {
        Object.defineProperty(this, "hash", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "internalUpdate", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "internalDigest", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.hash = opts.hash;
        this.internalUpdate = opts.update;
        this.internalDigest = opts.digest;
    }
    update(data) {
        this.hash = this.internalUpdate(this.hash, data);
        return this.hash;
    }
    /** Returns the digest of the hash. **The result is not encoded to base32**. */
    digest() {
        return this.internalDigest(this.hash);
    }
}
