import { AttachmentDriverMemory } from "./attachment_drivers/memory.js";
import { DocDriverMemory } from "./doc_drivers/memory.js";
/** A replica driver which stores data in memory. All data is lost when the replica is closed. */
export class ReplicaDriverMemory {
    constructor(shareAddress) {
        Object.defineProperty(this, "docDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "attachmentDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.docDriver = new DocDriverMemory(shareAddress);
        this.attachmentDriver = new AttachmentDriverMemory();
    }
}
