import { AttachmentDriverIndexedDB } from "./attachment_drivers/indexeddb.js";
import { DocDriverIndexedDB } from "./doc_drivers/indexeddb.js";
/** A replica driver which persists data to IndexedDB. */
export class ReplicaDriverWeb {
    constructor(shareAddress, namespace) {
        Object.defineProperty(this, "docDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "attachmentDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.docDriver = new DocDriverIndexedDB(shareAddress, namespace);
        this.attachmentDriver = new AttachmentDriverIndexedDB(shareAddress, namespace);
    }
}
