/** A timeout which can be 'bumped' manually, restarting the timer. */
import * as dntShim from "../../_dnt.shims.js";
export class BumpingTimeout {
    constructor(cb, ms) {
        Object.defineProperty(this, "timeout", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "cb", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "ms", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "closed", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        this.cb = cb;
        this.ms = ms;
        this.timeout = dntShim.setTimeout(cb, ms);
    }
    bump() {
        if (this.closed) {
            return;
        }
        clearTimeout(this.timeout);
        this.timeout = dntShim.setTimeout(this.cb, this.ms);
    }
    close() {
        this.closed = true;
        clearTimeout(this.timeout);
    }
}
