import { Buffer } from "buffer";
/**
 * This file provides common operations on Buffer.
 * Any util function that uses a Buffer should be here, not in bytes.ts.
 */
//--------------------------------------------------
import { isBuffer, isBytes } from "./bytes.js";
export function bytesToBuffer(bytes) {
    return Buffer.from(bytes);
}
export function bufferToBytes(buf) {
    return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength / Uint8Array.BYTES_PER_ELEMENT);
}
//--------------------------------------------------
export function stringToBuffer(str) {
    return Buffer.from(str, "utf-8");
}
export function bufferToString(buf) {
    return buf.toString("utf-8");
}
export function identifyBufOrBytes(bufOrBytes) {
    if (isBytes(bufOrBytes))
        return "bytes";
    if (isBuffer(bufOrBytes))
        return "buffer";
    return "?";
}
