import * as dntShim from "../../_dnt.shims.js";
import { alphaLower, workspaceKeyChars, } from "../core-validators/characters.js";
//================================================================================
// TIME
export function microsecondNow() {
    return Date.now() * 1000;
}
/** Returns a promise which is fulfilled after a given number of milliseconds. */
export function sleep(ms) {
    return new Promise((res) => {
        dntShim.setTimeout(res, ms);
    });
}
// TODO: better randomness here
export function randomId() {
    return "" + Math.floor(Math.random() * 1000) +
        Math.floor(Math.random() * 1000);
}
// replace all occurrences of substring "from" with "to"
export function replaceAll(str, from, to) {
    return str.split(from).join(to);
}
// how many times does the character occur in the string?
export function countChars(str, char) {
    if (char.length != 1) {
        throw new Error("char must have length 1 but is " + JSON.stringify(char));
    }
    return str.split(char).length - 1;
}
export function isObjectEmpty(obj) {
    return Object.keys(obj).length === 0;
}
//================================================================================
// Share
/** Returns a valid share address generated using a given name.
 * @returns A share address or a validation error resulting from the name given.
 * @deprecated This function only generates valid es.4 addresses. Use Crypto.generateShareKeypair to generate es.5 share addresses.
 */
export function generateShareAddress(name) {
    const randomFromString = (str) => {
        return str[Math.floor(Math.random() * str.length)];
    };
    const firstLetter = randomFromString(alphaLower);
    const rest = Array.from(Array(11), () => randomFromString(workspaceKeyChars))
        .join("");
    const suffix = `${firstLetter}${rest}`;
    const address = `+${name}.${suffix}`;
    return address;
}
