"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dntGlobalThis = exports.URLPattern = exports.TextDecoder = exports.TextEncoder = exports.WebSocket = exports.WritableStreamDefaultWriter = exports.TransformStreamDefaultController = exports.ReadableStream = exports.TransformStream = exports.WritableStream = exports.Headers = exports.Response = exports.Request = exports.Blob = exports.WeakRef = exports.setTimeout = exports.setInterval = void 0;
const shim_timers_1 = require("@deno/shim-timers");
var shim_timers_2 = require("@deno/shim-timers");
Object.defineProperty(exports, "setInterval", { enumerable: true, get: function () { return shim_timers_2.setInterval; } });
Object.defineProperty(exports, "setTimeout", { enumerable: true, get: function () { return shim_timers_2.setTimeout; } });
const sham_weakref_1 = require("@deno/sham-weakref");
var sham_weakref_2 = require("@deno/sham-weakref");
Object.defineProperty(exports, "WeakRef", { enumerable: true, get: function () { return sham_weakref_2.WeakRef; } });
const isomorphic_blob_1 = require("isomorphic-blob");
var isomorphic_blob_2 = require("isomorphic-blob");
Object.defineProperty(exports, "Blob", { enumerable: true, get: function () { return isomorphic_blob_2.Blob; } });
const isomorphic_undici_ponyfill_1 = require("isomorphic-undici-ponyfill");
var isomorphic_undici_ponyfill_2 = require("isomorphic-undici-ponyfill");
Object.defineProperty(exports, "Request", { enumerable: true, get: function () { return isomorphic_undici_ponyfill_2.Request; } });
Object.defineProperty(exports, "Response", { enumerable: true, get: function () { return isomorphic_undici_ponyfill_2.Response; } });
Object.defineProperty(exports, "Headers", { enumerable: true, get: function () { return isomorphic_undici_ponyfill_2.Headers; } });
const isomorphic_streams_1 = require("@sgwilym/isomorphic-streams");
var isomorphic_streams_2 = require("@sgwilym/isomorphic-streams");
Object.defineProperty(exports, "WritableStream", { enumerable: true, get: function () { return isomorphic_streams_2.WritableStream; } });
Object.defineProperty(exports, "TransformStream", { enumerable: true, get: function () { return isomorphic_streams_2.TransformStream; } });
Object.defineProperty(exports, "ReadableStream", { enumerable: true, get: function () { return isomorphic_streams_2.ReadableStream; } });
Object.defineProperty(exports, "TransformStreamDefaultController", { enumerable: true, get: function () { return isomorphic_streams_2.TransformStreamDefaultController; } });
Object.defineProperty(exports, "WritableStreamDefaultWriter", { enumerable: true, get: function () { return isomorphic_streams_2.WritableStreamDefaultWriter; } });
const isomorphic_ws_1 = __importDefault(require("isomorphic-ws"));
var isomorphic_ws_2 = require("isomorphic-ws");
Object.defineProperty(exports, "WebSocket", { enumerable: true, get: function () { return __importDefault(isomorphic_ws_2).default; } });
const textencoder_ponyfill_1 = require("textencoder-ponyfill");
var textencoder_ponyfill_2 = require("textencoder-ponyfill");
Object.defineProperty(exports, "TextEncoder", { enumerable: true, get: function () { return textencoder_ponyfill_2.TextEncoder; } });
Object.defineProperty(exports, "TextDecoder", { enumerable: true, get: function () { return textencoder_ponyfill_2.TextDecoder; } });
const urlpattern_polyfill_1 = require("@sgwilym/urlpattern-polyfill");
var urlpattern_polyfill_2 = require("@sgwilym/urlpattern-polyfill");
Object.defineProperty(exports, "URLPattern", { enumerable: true, get: function () { return urlpattern_polyfill_2.URLPattern; } });
const dntGlobals = {
    setInterval: shim_timers_1.setInterval,
    setTimeout: shim_timers_1.setTimeout,
    WeakRef: sham_weakref_1.WeakRef,
    Blob: isomorphic_blob_1.Blob,
    Request: isomorphic_undici_ponyfill_1.Request,
    Response: isomorphic_undici_ponyfill_1.Response,
    Headers: isomorphic_undici_ponyfill_1.Headers,
    WritableStream: isomorphic_streams_1.WritableStream,
    TransformStream: isomorphic_streams_1.TransformStream,
    ReadableStream: isomorphic_streams_1.ReadableStream,
    TransformStreamDefaultController: isomorphic_streams_1.TransformStreamDefaultController,
    WritableStreamDefaultWriter: isomorphic_streams_1.WritableStreamDefaultWriter,
    WebSocket: isomorphic_ws_1.default,
    TextEncoder: textencoder_ponyfill_1.TextEncoder,
    TextDecoder: textencoder_ponyfill_1.TextDecoder,
    URLPattern: urlpattern_polyfill_1.URLPattern,
};
exports.dntGlobalThis = createMergeProxy(globalThis, dntGlobals);
// deno-lint-ignore ban-types
function createMergeProxy(baseObj, extObj) {
    return new Proxy(baseObj, {
        get(_target, prop, _receiver) {
            if (prop in extObj) {
                return extObj[prop];
            }
            else {
                return baseObj[prop];
            }
        },
        set(_target, prop, value) {
            if (prop in extObj) {
                delete extObj[prop];
            }
            baseObj[prop] = value;
            return true;
        },
        deleteProperty(_target, prop) {
            let success = false;
            if (prop in extObj) {
                delete extObj[prop];
                success = true;
            }
            if (prop in baseObj) {
                delete baseObj[prop];
                success = true;
            }
            return success;
        },
        ownKeys(_target) {
            const baseKeys = Reflect.ownKeys(baseObj);
            const extKeys = Reflect.ownKeys(extObj);
            const extKeysSet = new Set(extKeys);
            return [...baseKeys.filter((k) => !extKeysSet.has(k)), ...extKeys];
        },
        defineProperty(_target, prop, desc) {
            if (prop in extObj) {
                delete extObj[prop];
            }
            Reflect.defineProperty(baseObj, prop, desc);
            return true;
        },
        getOwnPropertyDescriptor(_target, prop) {
            if (prop in extObj) {
                return Reflect.getOwnPropertyDescriptor(extObj, prop);
            }
            else {
                return Reflect.getOwnPropertyDescriptor(baseObj, prop);
            }
        },
        has(_target, prop) {
            return prop in extObj || prop in baseObj;
        },
    });
}
