"use strict";
// Copyright 2018-2022 the Deno authors. All rights reserved. MIT license.
/** This module is browser compatible. */
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedBlackNode = void 0;
const binary_search_node_js_1 = require("./binary_search_node.js");
class RedBlackNode extends binary_search_node_js_1.BinarySearchNode {
    constructor(parent, value) {
        super(parent, value);
        Object.defineProperty(this, "red", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.red = true;
    }
    static from(node) {
        const copy = new RedBlackNode(node.parent, node.value);
        copy.left = node.left;
        copy.right = node.right;
        copy.red = node.red;
        return copy;
    }
}
exports.RedBlackNode = RedBlackNode;
