"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeeableDeferred = void 0;
const deferred_js_1 = require("../../../std@0.158.0/async/deferred.js");
/** A promise which can be teed off into more promises which will resolve when the original does. */
class TeeableDeferred {
    constructor() {
        Object.defineProperty(this, "deferreds", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        Object.defineProperty(this, "state", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: "pending"
        });
    }
    resolve(value) {
        if (this.state !== "pending") {
            return;
        }
        this.state = "fulfilled";
        for (const deferred of this.deferreds) {
            deferred.resolve(value);
        }
    }
    reject(reason) {
        if (this.state !== "pending") {
            return;
        }
        this.state = "rejected";
        for (const deferred of this.deferreds) {
            deferred.reject(reason);
        }
    }
    tee() {
        const promise = (0, deferred_js_1.deferred)();
        if (this.state === "fulfilled") {
            promise.resolve();
        }
        else if (this.state === "rejected") {
            promise.reject();
        }
        else {
            this.deferreds.add(promise);
        }
        return promise;
    }
}
exports.TeeableDeferred = TeeableDeferred;
