"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFormatLookup = exports.getFormatIntersection = exports.getFormatsWithFallback = exports.getFormatWithFallback = exports.DEFAULT_FORMATS = exports.DEFAULT_FORMAT = void 0;
const format_es5_js_1 = require("./format_es5.js");
exports.DEFAULT_FORMAT = format_es5_js_1.FormatEs5;
exports.DEFAULT_FORMATS = [exports.DEFAULT_FORMAT];
/** Returns the default format if no formats are given. */
function getFormatWithFallback(format) {
    return format || exports.DEFAULT_FORMAT;
}
exports.getFormatWithFallback = getFormatWithFallback;
/** Returns the default formats if no formats are given. */
function getFormatsWithFallback(formats) {
    return formats || exports.DEFAULT_FORMATS;
}
exports.getFormatsWithFallback = getFormatsWithFallback;
/** Given an array of format names, and an array of `IFormat`, returns an array of `IFormat` restricted to those with matching names. */
function getFormatIntersection(formatNames, formats) {
    const intersection = [];
    for (const f of formats) {
        if (formatNames.includes(f.id)) {
            intersection.push(f);
        }
    }
    return intersection;
}
exports.getFormatIntersection = getFormatIntersection;
/** Returns an object with format names as keys, and corresponding `IFormat` as values. */
function getFormatLookup(formats) {
    const f = formats || exports.DEFAULT_FORMATS;
    const formatLookup = {};
    for (const format of f) {
        formatLookup[format.id] = format;
    }
    return formatLookup;
}
exports.getFormatLookup = getFormatLookup;
