"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplicaDriverFs = void 0;
const node_path_1 = require("node:path");
const fs_1 = require("fs");
const filesystem_node_js_1 = require("./attachment_drivers/filesystem.node.js");
const sqlite_node_js_1 = require("./doc_drivers/sqlite.node.js");
/** A replica driver which persists data to the filesystem. */
class ReplicaDriverFs {
    constructor(shareAddress, dirPath) {
        Object.defineProperty(this, "docDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "attachmentDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        if (!(0, fs_1.existsSync)(dirPath)) {
            (0, fs_1.mkdirSync)(dirPath);
        }
        this.docDriver = new sqlite_node_js_1.DocDriverSqlite({
            filename: (0, node_path_1.join)(dirPath, `${shareAddress}.sql`),
            mode: "create-or-open",
            share: shareAddress,
        });
        this.attachmentDriver = new filesystem_node_js_1.AttachmentDriverFilesystem((0, node_path_1.join)(dirPath, "attachments"));
    }
}
exports.ReplicaDriverFs = ReplicaDriverFs;
