"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplicaDriverMemory = void 0;
const memory_js_1 = require("./attachment_drivers/memory.js");
const memory_js_2 = require("./doc_drivers/memory.js");
/** A replica driver which stores data in memory. All data is lost when the replica is closed. */
class ReplicaDriverMemory {
    constructor(shareAddress) {
        Object.defineProperty(this, "docDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "attachmentDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.docDriver = new memory_js_2.DocDriverMemory(shareAddress);
        this.attachmentDriver = new memory_js_1.AttachmentDriverMemory();
    }
}
exports.ReplicaDriverMemory = ReplicaDriverMemory;
