"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReplicaDriverWeb = void 0;
const indexeddb_js_1 = require("./attachment_drivers/indexeddb.js");
const indexeddb_js_2 = require("./doc_drivers/indexeddb.js");
/** A replica driver which persists data to IndexedDB. */
class ReplicaDriverWeb {
    constructor(shareAddress, namespace) {
        Object.defineProperty(this, "docDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "attachmentDriver", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.docDriver = new indexeddb_js_2.DocDriverIndexedDB(shareAddress, namespace);
        this.attachmentDriver = new indexeddb_js_1.AttachmentDriverIndexedDB(shareAddress, namespace);
    }
}
exports.ReplicaDriverWeb = ReplicaDriverWeb;
