"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtensionKnownShares = void 0;
const fs = __importStar(require("node:fs/promises"));
/** A server extension for populating a server with known shares. Use this to specify which shares you'd like your server to sync with others.
 *
 * You most likely want to pass this as the first extension to your server.
 */
class ExtensionKnownShares {
    constructor(opts) {
        Object.defineProperty(this, "peer", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: null
        });
        Object.defineProperty(this, "knownSharesPath", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "onCreateReplica", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.knownSharesPath = opts.knownSharesPath;
        this.onCreateReplica = opts.onCreateReplica;
    }
    async register(peer) {
        this.peer = peer;
        const knownSharesRaw = await fs.readFile(this.knownSharesPath, "utf-8");
        const knownShares = JSON.parse(knownSharesRaw);
        for (const shareAddress of knownShares) {
            const replica = this.onCreateReplica(shareAddress);
            await this.peer.addReplica(replica);
        }
    }
    handler() {
        return Promise.resolve(null);
    }
}
exports.ExtensionKnownShares = ExtensionKnownShares;
