"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerCore = void 0;
const dntShim = __importStar(require("../../_dnt.shims.js"));
const peer_js_1 = require("../peer/peer.js");
/** The core server logic. Combine this with a HTTP framework to create a fully-fledged server. */
class ServerCore {
    /**
     * Create a new server with an array of extensions.
     * @param extensions - The extensions used by the server. Extensions will be registered in the order you provide them in, as one extension may depend on the actions of another. For example, the `ExtensionServeContent` may rely on a replica created by `ExtensionKnownShares`.
     */
    constructor(extensions) {
        Object.defineProperty(this, "extensions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "peer", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "isReady", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.peer = new peer_js_1.Peer();
        this.extensions = extensions;
        this.isReady = this.registerExtensions();
        console.log("Your server is running.");
    }
    async registerExtensions() {
        // Extensions must be registered sequentially, one-by-one,
        // As later extensions may depend on the actions of previous ones
        // e.g. The serve content extension using a share added by the known shares extension
        for (const extension of this.extensions) {
            await extension.register(this.peer);
        }
    }
    async handler(req) {
        await this.isReady;
        for (const extension of this.extensions) {
            const response = await extension.handler(req);
            if (response) {
                return response;
            }
        }
        return new dntShim.Response("Not found", { status: 404 });
    }
}
exports.ServerCore = ServerCore;
