"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttachmentStreamInfo = void 0;
const dntShim = __importStar(require("../../_dnt.shims.js"));
const deps_js_1 = require("../../deps.js");
const base32_js_1 = require("../crypto/base32.js");
const crypto_js_1 = require("../crypto/crypto.js");
class AttachmentStreamInfo {
    constructor() {
        Object.defineProperty(this, "transformer", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "updatableHash", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: crypto_js_1.Crypto.updatableSha256()
        });
        Object.defineProperty(this, "size", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (0, deps_js_1.deferred)()
        });
        Object.defineProperty(this, "hash", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: (0, deps_js_1.deferred)()
        });
        const { updatableHash, size, hash } = this;
        let currentSize = 0;
        this.transformer = new dntShim.TransformStream({
            transform(chunk, controller) {
                updatableHash.update(chunk);
                currentSize += chunk.byteLength;
                controller.enqueue(chunk);
            },
            flush() {
                const digest = updatableHash.digest();
                hash.resolve((0, base32_js_1.base32BytesToString)(digest));
                size.resolve(currentSize);
            },
        });
    }
    get writable() {
        return this.transformer.writable;
    }
    get readable() {
        return this.transformer.readable;
    }
}
exports.AttachmentStreamInfo = AttachmentStreamInfo;
