"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.identifyBufOrBytes = exports.bufferToString = exports.stringToBuffer = exports.bufferToBytes = exports.bytesToBuffer = void 0;
const buffer_1 = require("buffer");
/**
 * This file provides common operations on Buffer.
 * Any util function that uses a Buffer should be here, not in bytes.ts.
 */
//--------------------------------------------------
const bytes_js_1 = require("./bytes.js");
function bytesToBuffer(bytes) {
    return buffer_1.Buffer.from(bytes);
}
exports.bytesToBuffer = bytesToBuffer;
function bufferToBytes(buf) {
    return new Uint8Array(buf.buffer, buf.byteOffset, buf.byteLength / Uint8Array.BYTES_PER_ELEMENT);
}
exports.bufferToBytes = bufferToBytes;
//--------------------------------------------------
function stringToBuffer(str) {
    return buffer_1.Buffer.from(str, "utf-8");
}
exports.stringToBuffer = stringToBuffer;
function bufferToString(buf) {
    return buf.toString("utf-8");
}
exports.bufferToString = bufferToString;
function identifyBufOrBytes(bufOrBytes) {
    if ((0, bytes_js_1.isBytes)(bufOrBytes))
        return "bytes";
    if ((0, bytes_js_1.isBuffer)(bufOrBytes))
        return "buffer";
    return "?";
}
exports.identifyBufOrBytes = identifyBufOrBytes;
