"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateShareAddress = exports.isObjectEmpty = exports.countChars = exports.replaceAll = exports.randomId = exports.sleep = exports.microsecondNow = void 0;
const dntShim = __importStar(require("../../_dnt.shims.js"));
const characters_js_1 = require("../core-validators/characters.js");
//================================================================================
// TIME
function microsecondNow() {
    return Date.now() * 1000;
}
exports.microsecondNow = microsecondNow;
/** Returns a promise which is fulfilled after a given number of milliseconds. */
function sleep(ms) {
    return new Promise((res) => {
        dntShim.setTimeout(res, ms);
    });
}
exports.sleep = sleep;
// TODO: better randomness here
function randomId() {
    return "" + Math.floor(Math.random() * 1000) +
        Math.floor(Math.random() * 1000);
}
exports.randomId = randomId;
// replace all occurrences of substring "from" with "to"
function replaceAll(str, from, to) {
    return str.split(from).join(to);
}
exports.replaceAll = replaceAll;
// how many times does the character occur in the string?
function countChars(str, char) {
    if (char.length != 1) {
        throw new Error("char must have length 1 but is " + JSON.stringify(char));
    }
    return str.split(char).length - 1;
}
exports.countChars = countChars;
function isObjectEmpty(obj) {
    return Object.keys(obj).length === 0;
}
exports.isObjectEmpty = isObjectEmpty;
//================================================================================
// Share
/** Returns a valid share address generated using a given name.
 * @returns A share address or a validation error resulting from the name given.
 * @deprecated This function only generates valid es.4 addresses. Use Crypto.generateShareKeypair to generate es.5 share addresses.
 */
function generateShareAddress(name) {
    const randomFromString = (str) => {
        return str[Math.floor(Math.random() * str.length)];
    };
    const firstLetter = randomFromString(characters_js_1.alphaLower);
    const rest = Array.from(Array(11), () => randomFromString(characters_js_1.workspaceKeyChars))
        .join("");
    const suffix = `${firstLetter}${rest}`;
    const address = `+${name}.${suffix}`;
    return address;
}
exports.generateShareAddress = generateShareAddress;
