"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readStream = exports.getStreamSize = exports.streamToBytes = exports.bytesToStream = void 0;
const dntShim = __importStar(require("../../_dnt.shims.js"));
function bytesToStream(bytes) {
    return new dntShim.ReadableStream({
        start(controller) {
            for (let i = 0; i <= bytes.length; i += 8) {
                controller.enqueue(bytes.slice(i, i + 8));
            }
            controller.close();
        },
    });
}
exports.bytesToStream = bytesToStream;
async function streamToBytes(stream) {
    let bytes = new Uint8Array();
    await stream.pipeTo(new dntShim.WritableStream({
        write(chunk) {
            const nextBytes = new Uint8Array(bytes.length + chunk.length);
            nextBytes.set(bytes);
            nextBytes.set(chunk, bytes.length);
            bytes = nextBytes;
        },
    }));
    return bytes;
}
exports.streamToBytes = streamToBytes;
async function getStreamSize(stream) {
    let size = 0;
    const sink = new dntShim.WritableStream({
        write(chunk) {
            size += chunk.byteLength;
        },
    });
    await stream.pipeTo(sink);
    return size;
}
exports.getStreamSize = getStreamSize;
async function readStream(stream) {
    const arr = [];
    const writable = new dntShim.WritableStream({
        write(entry) {
            arr.push(entry);
        },
    });
    await stream.pipeTo(writable);
    return arr;
}
exports.readStream = readStream;
