"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _XXH64_seed, _XXH64_v1, _XXH64_v2, _XXH64_v3, _XXH64_v4, _XXH64_memory, _XXH64_len, _XXH64_memsize;
Object.defineProperty(exports, "__esModule", { value: true });
exports.hash = exports.XXH64 = void 0;
// xxHash64 implementation in JavaScript
//
// Licensed under MIT License
//
// Copyright 2019-2020, Yann Collet <github.com/Cyan4973>
// Copyright 2016, Pierre Curto <github.com/pierrec>
// Copyright 2019, Daniel Lo Nigro <github.com/Daniel15>
// Copyright 2021, intrnl <github.com/intrnl>
const dntShim = __importStar(require("../../_dnt.shims.js"));
const PRIME64_1 = 11400714785074694791n;
const PRIME64_2 = 14029467366897019727n;
const PRIME64_3 = 1609587929392839161n;
const PRIME64_4 = 9650029242287828579n;
const PRIME64_5 = 2870177450012600261n;
const BITS = 64n;
const BITMASK = 2n ** BITS - 1n;
const encoder = new dntShim.TextEncoder();
function bitsToBigInt(a00, a16, a32, a48) {
    return ((BigInt(a00)) |
        (BigInt(a16) << 16n) |
        (BigInt(a32) << 32n) |
        (BigInt(a48) << 48n));
}
function memoryToBigInt(memory, offset) {
    return ((BigInt(memory[offset])) |
        (BigInt(memory[offset + 1]) << 8n) |
        (BigInt(memory[offset + 2]) << 16n) |
        (BigInt(memory[offset + 3]) << 24n) |
        (BigInt(memory[offset + 4]) << 32n) |
        (BigInt(memory[offset + 5]) << 40n) |
        (BigInt(memory[offset + 6]) << 48n) |
        (BigInt(memory[offset + 7]) << 56n));
}
function rotl(value, rotation) {
    return (((value << rotation) & BITMASK) |
        (value >> (BITS - rotation)));
}
function trunc(value) {
    return BigInt.asUintN(64, value);
}
class XXH64 {
    constructor(seed = 0) {
        _XXH64_seed.set(this, void 0);
        _XXH64_v1.set(this, void 0);
        _XXH64_v2.set(this, void 0);
        _XXH64_v3.set(this, void 0);
        _XXH64_v4.set(this, void 0);
        _XXH64_memory.set(this, void 0);
        _XXH64_len.set(this, void 0);
        _XXH64_memsize.set(this, void 0);
        this.reset(seed);
    }
    reset(seed = __classPrivateFieldGet(this, _XXH64_seed, "f")) {
        __classPrivateFieldSet(this, _XXH64_seed, BigInt.asUintN(32, BigInt(seed)), "f");
        __classPrivateFieldSet(this, _XXH64_v1, trunc(__classPrivateFieldGet(this, _XXH64_seed, "f") + PRIME64_1 + PRIME64_2), "f");
        __classPrivateFieldSet(this, _XXH64_v2, trunc(__classPrivateFieldGet(this, _XXH64_seed, "f") + PRIME64_2), "f");
        __classPrivateFieldSet(this, _XXH64_v3, __classPrivateFieldGet(this, _XXH64_seed, "f"), "f");
        __classPrivateFieldSet(this, _XXH64_v4, trunc(__classPrivateFieldGet(this, _XXH64_seed, "f") - PRIME64_1), "f");
        __classPrivateFieldSet(this, _XXH64_memory, null, "f");
        __classPrivateFieldSet(this, _XXH64_len, 0, "f");
        __classPrivateFieldSet(this, _XXH64_memsize, 0, "f");
        return this;
    }
    update(input) {
        if (typeof input === "string") {
            input = encoder.encode(input);
        }
        let p = 0;
        let len = input.length;
        let bEnd = p + len;
        if (len === 0) {
            return this;
        }
        __classPrivateFieldSet(this, _XXH64_len, __classPrivateFieldGet(this, _XXH64_len, "f") + len, "f");
        if (__classPrivateFieldGet(this, _XXH64_memsize, "f") === 0) {
            __classPrivateFieldSet(this, _XXH64_memory, new Uint8Array(32), "f");
        }
        if (__classPrivateFieldGet(this, _XXH64_memsize, "f") + len < 32) {
            __classPrivateFieldGet(this, _XXH64_memory, "f").set(input.subarray(0, len), __classPrivateFieldGet(this, _XXH64_memsize, "f"));
            __classPrivateFieldSet(this, _XXH64_memsize, __classPrivateFieldGet(this, _XXH64_memsize, "f") + len, "f");
            return this;
        }
        if (__classPrivateFieldGet(this, _XXH64_memsize, "f") > 0) {
            __classPrivateFieldGet(this, _XXH64_memory, "f").set(input.subarray(0, 32 - __classPrivateFieldGet(this, _XXH64_memsize, "f")), __classPrivateFieldGet(this, _XXH64_memsize, "f"));
            let p64 = 0;
            let other;
            other = memoryToBigInt(__classPrivateFieldGet(this, _XXH64_memory, "f"), p64);
            __classPrivateFieldSet(this, _XXH64_v1, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v1, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
            p64 += 8;
            other = memoryToBigInt(this.memory, p64);
            __classPrivateFieldSet(this, _XXH64_v2, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v2, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
            p64 += 8;
            other = memoryToBigInt(this.memory, p64);
            __classPrivateFieldSet(this, _XXH64_v3, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v3, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
            p64 += 8;
            other = memoryToBigInt(this.memory, p64);
            __classPrivateFieldSet(this, _XXH64_v4, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v4, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
            p += 32 - __classPrivateFieldGet(this, _XXH64_memsize, "f");
            __classPrivateFieldSet(this, _XXH64_memsize, 0, "f");
        }
        if (p <= bEnd - 32) {
            const limit = bEnd - 32;
            do {
                let other;
                other = memoryToBigInt(input, p);
                __classPrivateFieldSet(this, _XXH64_v1, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v1, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
                p += 8;
                other = memoryToBigInt(input, p);
                __classPrivateFieldSet(this, _XXH64_v2, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v2, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
                p += 8;
                other = memoryToBigInt(input, p);
                __classPrivateFieldSet(this, _XXH64_v3, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v3, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
                p += 8;
                other = memoryToBigInt(input, p);
                __classPrivateFieldSet(this, _XXH64_v4, trunc(rotl(trunc(__classPrivateFieldGet(this, _XXH64_v4, "f") + other * PRIME64_2), 31n) * PRIME64_1), "f");
                p += 8;
            } while (p <= limit);
        }
        if (p < bEnd) {
            __classPrivateFieldGet(this, _XXH64_memory, "f").set(input.subarray(p, bEnd), __classPrivateFieldGet(this, _XXH64_memsize, "f"));
            __classPrivateFieldSet(this, _XXH64_memsize, bEnd - p, "f");
        }
        return this;
    }
    digest() {
        let input = __classPrivateFieldGet(this, _XXH64_memory, "f");
        let bEnd = __classPrivateFieldGet(this, _XXH64_memsize, "f");
        let p = 0;
        let h64 = 0n;
        let h = 0n;
        let u = 0n;
        if (__classPrivateFieldGet(this, _XXH64_len, "f") >= 32) {
            h64 = rotl(__classPrivateFieldGet(this, _XXH64_v1, "f"), 1n) + rotl(__classPrivateFieldGet(this, _XXH64_v2, "f"), 7n) + rotl(__classPrivateFieldGet(this, _XXH64_v3, "f"), 12n) +
                rotl(__classPrivateFieldGet(this, _XXH64_v4, "f"), 18n);
            h64 = trunc(h64 ^ (rotl(trunc(__classPrivateFieldGet(this, _XXH64_v1, "f") * PRIME64_2), 31n) * PRIME64_1));
            h64 = trunc(h64 * PRIME64_1 + PRIME64_4);
            h64 = trunc(h64 ^ (rotl(trunc(__classPrivateFieldGet(this, _XXH64_v2, "f") * PRIME64_2), 31n) * PRIME64_1));
            h64 = trunc(h64 * PRIME64_1 + PRIME64_4);
            h64 = trunc(h64 ^ (rotl(trunc(__classPrivateFieldGet(this, _XXH64_v3, "f") * PRIME64_2), 31n) * PRIME64_1));
            h64 = trunc(h64 * PRIME64_1 + PRIME64_4);
            h64 = trunc(h64 ^ (rotl(trunc(__classPrivateFieldGet(this, _XXH64_v4, "f") * PRIME64_2), 31n) * PRIME64_1));
            h64 = trunc(h64 * PRIME64_1 + PRIME64_4);
        }
        else {
            h64 = trunc(__classPrivateFieldGet(this, _XXH64_seed, "f") + PRIME64_5);
        }
        h64 += BigInt(__classPrivateFieldGet(this, _XXH64_len, "f"));
        while (p <= bEnd - 8) {
            u = memoryToBigInt(input, p);
            u = trunc(rotl(trunc(u * PRIME64_2), 31n) * PRIME64_1);
            h64 = trunc((rotl(h64 ^ u, 27n) * PRIME64_1) + PRIME64_4);
            p += 8;
        }
        if (p + 4 <= bEnd) {
            u = bitsToBigInt((input[p + 1] << 8) | input[p], (input[p + 3] << 8) | input[p + 2], 0, 0);
            h64 = trunc((rotl(h64 ^ trunc(u * PRIME64_1), 23n) * PRIME64_2) + PRIME64_3);
            p += 4;
        }
        while (p < bEnd) {
            u = bitsToBigInt(input[p++], 0, 0, 0);
            h64 = trunc(rotl(h64 ^ trunc(u * PRIME64_5), 11n) * PRIME64_1);
        }
        h = trunc(h64 >> 33n);
        h64 = trunc((h64 ^ h) * PRIME64_2);
        h = trunc(h64 >> 29n);
        h64 = trunc((h64 ^ h) * PRIME64_3);
        h = trunc(h64 >> 32n);
        h64 = trunc(h64 ^ h);
        return h64;
    }
}
exports.XXH64 = XXH64;
_XXH64_seed = new WeakMap(), _XXH64_v1 = new WeakMap(), _XXH64_v2 = new WeakMap(), _XXH64_v3 = new WeakMap(), _XXH64_v4 = new WeakMap(), _XXH64_memory = new WeakMap(), _XXH64_len = new WeakMap(), _XXH64_memsize = new WeakMap();
function hash(input, seed = 0) {
    return new XXH64(seed).update(input).digest();
}
exports.hash = hash;
