export declare const END: unique symbol;
export declare const ERROR: unique symbol;
export type Enqueueable<T> = T | Promise<T> | typeof END | typeof ERROR;
export type Resolver<T> = (value: T | PromiseLike<T>) => void;
export type EndOptions = {
    immediately?: boolean;
    withError?: Error;
};
export declare class AsyncQueue<T = unknown> {
    #private;
    constructor(streamPromise?: Promise<unknown>);
    get length(): number;
    push: (...data: (T | Promise<T>)[]) => void;
    close: ({ immediately, withError }?: EndOptions) => void;
    [Symbol.asyncIterator](): AsyncGenerator<Awaited<T> | Awaited<NonNullable<T>>, void, unknown>;
}
