export type LiftingMonoid<ValueType, LiftedType> = {
    lift: (i: ValueType) => LiftedType;
    combine: (a: LiftedType, b: LiftedType) => LiftedType;
    neutral: LiftedType;
};
/** Combine two lifting monoids into a new one. */
export declare function combineMonoid<V, AL, BL>(a: LiftingMonoid<V, AL>, b: LiftingMonoid<V, BL>): LiftingMonoid<V, [AL, BL]>;
/** A monoid which lifts the member as a string, and combines by concatenating together. */
export declare const concatMonoid: LiftingMonoid<string, string>;
/** A monoid which lifts the member as 1, and combines by adding together. */
export declare const sizeMonoid: LiftingMonoid<unknown, number>;
