/** Check that a string only contains character from a string of allowed characters. */
export declare function onlyHasChars(str: string, allowedChars: string): boolean;
/** Check that a string contains only printable ASCII */
export declare function isOnlyPrintableAscii(s: string): boolean;
export declare function isDigit(ch: string): boolean;
/** Lowercase alphabetical characters. */
export declare const alphaLower = "abcdefghijklmnopqrstuvwxyz";
/** Uppercase alphabetical characters. */
export declare const alphaUpper: string;
/** All digits. */
export declare const digits = "0123456789";
/** All characters allowed in base32. */
export declare const b32chars: string;
/** All characters allowed in an identity's short name. */
export declare const authorNameChars: string;
/** All characters allowed in an identity's pub key. */
export declare const authorKeyChars: string;
/** All characters allowed in an identity's public address. */
export declare const authorAddressChars: string;
/** All characters allowed in a share's name. */
export declare const workspaceNameChars: string;
/** All characters allowed in a share's key. */
export declare const workspaceKeyChars: string;
/** All characters allowed in a share's address. */
export declare const workspaceAddressChars: string;
/** All special characters permitted in a document's path. */
export declare const pathPunctuation = "/'()-._~!$&+,:=@%";
/** All characters permitted in a document's path. */
export declare const pathChars: string;
