type Ob = {
    [k: string]: any;
};
export type Checker = (x: any) => null | string;
export type CheckerSchema = {
    [k: string]: Checker;
};
export declare function isPlainObject(obj: any): obj is Ob;
export declare function checkIsPlainObject(x: any): null | string;
export declare function checkLiteral(val: any): Checker;
export interface CheckStringOpts {
    optional?: boolean;
    minLen?: number;
    maxLen?: number;
    len?: number;
    allowedChars?: string;
}
export declare function checkString(opts?: CheckStringOpts): Checker;
export interface CheckIntOpts {
    optional?: boolean;
    nullable?: boolean;
    min?: number;
    max?: number;
}
export declare function checkInt(opts?: CheckIntOpts): Checker;
export interface CheckObjOpts {
    allowLiteralUndefined?: boolean;
    allowExtraKeys?: boolean;
    objSchema?: CheckerSchema;
}
export declare function checkObj(opts?: CheckObjOpts): Checker;
export {};
