import { AuthorShortname } from "../util/doc-types.js";
import { ValidationError } from "../util/errors.js";
import { AuthorKeypair, KeypairBytes, ShareKeypair } from "./crypto-types.js";
/** Combine a shortname with a raw KeypairBytes to make an AuthorKeypair */
export declare function encodeAuthorKeypairToStrings(shortname: AuthorShortname, pair: KeypairBytes): AuthorKeypair;
/** Combine a name with a raw KeypairBytes to make an ShareKeypair */
export declare function encodeShareKeypairToStrings(name: string, pair: KeypairBytes): {
    address: string;
    secret: string;
};
/** Convert a keypair (author / share) back into a raw KeypairBytes for use in crypto operations. */
export declare function decodeKeypairToBytes(pair: AuthorKeypair | ShareKeypair): KeypairBytes | ValidationError;
export declare function isAuthorKeypair(keypair: AuthorKeypair | ShareKeypair): keypair is AuthorKeypair;
