type UpdatableHashOpts<HashType> = {
    hash: HashType;
    update: (hash: HashType, data: Uint8Array) => HashType;
    digest: (hash: HashType) => Uint8Array;
};
export declare class UpdatableHash<HashType> {
    private hash;
    private internalUpdate;
    private internalDigest;
    constructor(opts: UpdatableHashOpts<HashType>);
    update(data: Uint8Array): HashType;
    /** Returns the digest of the hash. **The result is not encoded to base32**. */
    digest(): Uint8Array;
}
export {};
