import { DefaultFormat, DefaultFormats, FormatArg, FormatsArg } from "./format_types.js";
export declare const DEFAULT_FORMAT: import("./format_types.js").IFormat<"es.5", import("./format_es5.js").DocInputEs5, import("./format_es5.js").DocEs5, import("./format_es5.js").ConfigEs5>;
export declare const DEFAULT_FORMATS: import("./format_types.js").IFormat<"es.5", import("./format_es5.js").DocInputEs5, import("./format_es5.js").DocEs5, import("./format_es5.js").ConfigEs5>[];
/** Returns the default format if no formats are given. */
export declare function getFormatWithFallback<F = DefaultFormat>(format?: FormatArg<F>): FormatArg<F>;
/** Returns the default formats if no formats are given. */
export declare function getFormatsWithFallback<F = DefaultFormats>(formats?: FormatsArg<F>): FormatsArg<F>;
/** Given an array of format names, and an array of `IFormat`, returns an array of `IFormat` restricted to those with matching names. */
export declare function getFormatIntersection<F>(formatNames: string[], formats: FormatsArg<F>): FormatsArg<F>;
/** Returns an object with format names as keys, and corresponding `IFormat` as values. */
export declare function getFormatLookup<F = DefaultFormats>(formats?: FormatsArg<F>): Record<string, FormatArg<F>>;
