import { DocBase } from "../util/doc-types.js";
import { Query, QueryFilter } from "./query-types.js";
export type WillMatch = "all" | "all-latest" | "some" | "nothing";
export interface CleanUpQueryResult {
    query: Query<string[]>;
    isValid: boolean;
    willMatch: WillMatch;
}
export declare function cleanUpQuery(inputQuery: Query<string[]>): CleanUpQueryResult;
export declare function docMatchesFilter<FormatType extends string, DocType extends DocBase<FormatType>>(doc: DocType, filter: QueryFilter): boolean;
/** Return whether a document is expired or not */
export declare function docIsExpired<FormatType extends string, DocType extends DocBase<FormatType>>(doc: DocType, now?: number): boolean;
