import * as dntShim from "../../../_dnt.shims.js";
import { DocAttachment } from "../../util/doc-types.js";
import { ValidationError } from "../../util/errors.js";
import { IReplicaAttachmentDriver } from "../replica-types.js";
/** An attachment driver which persists attachments using the local filesystem.
 * Works with Node.
 */
export declare class AttachmentDriverFilesystem implements IReplicaAttachmentDriver {
    private path;
    private closed;
    /** @param path - The filesystem path all attachments will be stored under. */
    constructor(path: string);
    private ensurePath;
    stage(formatName: string, attachment: dntShim.ReadableStream<Uint8Array> | Uint8Array): Promise<{
        hash: string;
        size: number;
        commit: () => Promise<void>;
        reject: () => Promise<void>;
    }>;
    erase(formatName: string, attachmentHash: string): Promise<true | ValidationError>;
    wipe(): Promise<void>;
    getAttachment(formatName: string, attachmentHash: string): Promise<DocAttachment | undefined>;
    clearStaging(): Promise<void>;
    filter(attachments: Record<string, Set<string>>): Promise<{
        format: string;
        hash: string;
    }[]>;
    isClosed(): boolean;
    close(erase: boolean): Promise<void>;
}
