import * as dntShim from "../../../_dnt.shims.js";
import { DocAttachment, ShareAddress } from "../../util/doc-types.js";
import { IReplicaAttachmentDriver } from "../replica-types.js";
import { ValidationError } from "../../util/errors.js";
export declare class AttachmentDriverIndexedDB implements IReplicaAttachmentDriver {
    private db;
    private share;
    private closed;
    constructor(share: ShareAddress, namespace?: string);
    private getIndexKey;
    getAttachment(formatName: string, attachmentHash: string): Promise<DocAttachment | undefined>;
    erase(formatName: string, attachmentHash: string): Promise<true | ValidationError>;
    stage(formatName: string, attachment: Uint8Array | dntShim.ReadableStream<Uint8Array>): Promise<{
        hash: string;
        size: number;
        commit: () => Promise<void>;
        reject: () => Promise<void>;
    } | ValidationError>;
    wipe(): Promise<void>;
    clearStaging(): Promise<void>;
    filter(attachments: Record<string, Set<string>>): Promise<{
        format: string;
        hash: string;
    }[]>;
    isClosed(): boolean;
    close(erase: boolean): Promise<void>;
}
