import * as dntShim from "../../../_dnt.shims.js";
import { DocAttachment } from "../../util/doc-types.js";
import { ValidationError } from "../../util/errors.js";
import { IReplicaAttachmentDriver } from "../replica-types.js";
/** An attachment driver which persists attachments in memory.
 * Works everywhere.
 */
export declare class AttachmentDriverMemory implements IReplicaAttachmentDriver {
    private stagingMap;
    private attachmentMap;
    private closed;
    private getKey;
    getAttachment(formatName: string, attachmentHash: string): Promise<DocAttachment | undefined>;
    stage(formatName: string, attachment: dntShim.ReadableStream<Uint8Array> | Uint8Array): Promise<{
        hash: string;
        size: number;
        commit: () => Promise<void>;
        reject: () => Promise<void>;
    }>;
    erase(formatName: string, attachmentHash: string): Promise<ValidationError> | Promise<true>;
    wipe(): Promise<void>;
    filter(hashes: Record<string, Set<string>>): Promise<{
        format: string;
        hash: string;
    }[]>;
    clearStaging(): Promise<void>;
    isClosed(): boolean;
    close(erase: boolean): Promise<void>;
}
