import { ShareAddress } from "../../util/doc-types.js";
import { IReplicaDocDriver } from "../replica-types.js";
import { Query } from "../../query/query-types.js";
import { DocBase } from "../../util/doc-types.js";
export declare class DocDriverIndexedDB implements IReplicaDocDriver {
    share: ShareAddress;
    private db;
    private gotInitialMaxLocalIndex;
    private localMaxLocalIndex;
    private closed;
    /**
     * @param share - The address of the share the replica belongs to.
     */
    constructor(share: ShareAddress, namespace?: string);
    isClosed(): boolean;
    close(erase: boolean): Promise<void>;
    getMaxLocalIndex(): Promise<number>;
    queryDocs(queryToClean: Query<string[]>): Promise<DocBase<string>[]>;
    upsert<DocType extends DocBase<string>>(doc: DocType): Promise<DocType>;
    eraseExpiredDocs(): Promise<DocBase<string>[]>;
    getConfig(key: string): Promise<string | undefined>;
    setConfig(key: string, value: string): Promise<void>;
    listConfigKeys(): Promise<string[]>;
    deleteConfig(key: string): Promise<boolean>;
}
