import { DocBase, ShareAddress } from "../../util/doc-types.js";
import { IReplicaDocDriver } from "../replica-types.js";
import { ReplicaSqliteOpts } from "./sqlite.shared.js";
import { Database as SqliteDatabase } from "better-sqlite3";
import { Query } from "../../query/query-types.js";
/** A strorage driver which persists to SQLite. Works in Deno and browsers. */
export declare class DocDriverSqlite implements IReplicaDocDriver {
    share: ShareAddress;
    _filename: string;
    _isClosed: boolean;
    _db: SqliteDatabase;
    _maxLocalIndex: number;
    close(erase: boolean): Promise<void>;
    isClosed(): boolean;
    constructor(opts: ReplicaSqliteOpts);
    setConfig(key: string, content: string): Promise<void>;
    _getConfigSync(key: string): string | undefined;
    _listConfigKeysSync(): string[];
    getConfig(key: string): Promise<string | undefined>;
    listConfigKeys(): Promise<string[]>;
    deleteConfig(key: string): Promise<boolean>;
    getMaxLocalIndex(): Promise<number>;
    queryDocs(queryToClean: Query<string[]>): Promise<DocBase<string>[]>;
    private queryDocsSync;
    upsert<DocType extends DocBase<string>>(doc: DocType): Promise<DocType>;
    private upsertSync;
    eraseExpiredDocs(): Promise<any[]>;
    private ensureTables;
}
