import { Peer } from "../../peer/peer.js";
import { Replica } from "../../replica/replica.js";
import { IServerExtension } from "./extension.js";
interface ExtensionKnownSharesOpts {
    /** The path where the known shares (a JSON array of share addresses) is located. */
    knownSharesPath: string;
    /** A callback used to create the replicas in the known shares list. Mostly useful for choosing how you'd like your shares to be persisted, e.g. probably by Sqlite. */
    onCreateReplica: (shareAddress: string) => Replica;
}
/** A server extension for populating a server with known shares. Use this to specify which shares you'd like your server to sync with others.
 *
 * You most likely want to pass this as the first extension to your server.
 */
export declare class ExtensionKnownShares implements IServerExtension {
    private peer;
    private knownSharesPath;
    private onCreateReplica;
    constructor(opts: ExtensionKnownSharesOpts);
    register(peer: Peer): Promise<void>;
    handler(): Promise<null>;
}
export {};
