import * as dntShim from "../../../_dnt.shims.js";
import { Peer } from "../../peer/peer.js";
import { IServerExtension } from "./extension.js";
export interface ExtensionServeContentOpts {
    /** The share to use as the source of documents. Must have been created by another extension. */
    sourceShare: string;
    /** An optional path prefix for requests. E.g. `/stuff` means a call to `/stuff/blog.md` would fetch `/blog.md` from the replica. */
    path?: string;
    /** A fallback path to use when none is provided. Useful for landing pages. */
    indexPath?: string;
    /** A list of origins allowed by CORS, if you want other sites to be able to request content from your server. */
    allowedOrigins?: string[];
}
/** A server extension for exposing the contents of shares, so that you can request documents by their path and have them served over HTTP. Can be used to create wikis, websites, image galleries, and more. */
export declare class ExtensionServeContent implements IServerExtension {
    private peer;
    private path;
    private replica;
    private sourceShare;
    private indexPath;
    private allowedOrigins;
    constructor(opts: ExtensionServeContentOpts);
    register(peer: Peer): Promise<void>;
    handler(req: dntShim.Request): Promise<dntShim.Response | null>;
}
