import * as dntShim from "../../../_dnt.shims.js";
import { Peer } from "../../peer/peer.js";
import { Replica } from "../../replica/replica.js";
import { ShareAddress } from "../../util/doc-types.js";
import { IServerExtension } from "./extension.js";
interface ExtensionServerSettingsOpts {
    /** The address of the share to read settings from. */
    settingsShare: ShareAddress;
    /** The method used to create the replica for the settings share. */
    onCreateReplica: (settingsShareAddress: string) => Replica;
}
/** A server extension which reads settings from a specified share, e.g. which shares to host on the server. Settings are modified by other peers syncing with this server. */
export declare class ExtensionServerSettings implements IServerExtension {
    private configReplica;
    private onCreateReplica;
    private peer;
    constructor(opts: ExtensionServerSettingsOpts);
    register(peer: Peer): Promise<void>;
    handler(_req: dntShim.Request): Promise<dntShim.Response | null>;
    removeShareWithHash(hash: string): Promise<void>;
    findReplicaForHash(hash: string): Promise<Replica | undefined>;
}
export {};
