/// <reference types="node" />
import * as dntShim from "../../../_dnt.shims.js";
import { FormatsArg } from "../../formats/format_types.js";
import { Peer } from "../../peer/peer.js";
import { IServerExtension } from "./extension.js";
import { createServer } from "node:http";
interface ExtensionSyncOpts<F> {
    /** The path to accept HTTP sync requests from, e.g. `/earthstar-api/v2`. Make sure to set this if you're using other extensions which handle requests, as by default this will match any request to /. */
    path?: string;
    formats?: FormatsArg<F>;
    server: ReturnType<typeof createServer>;
}
/** An extension which enables synchronisation over the web via HTTP. */
export declare class ExtensionSyncWeb<F> implements IServerExtension {
    private path;
    private syncers;
    private peer;
    private formats;
    private wss;
    private server;
    constructor(opts: ExtensionSyncOpts<F>);
    register(peer: Peer): Promise<void>;
    handler(req: dntShim.Request): Promise<dntShim.Response | null>;
}
export {};
