import * as dntShim from "../../_dnt.shims.js";
import { IServerExtension } from "./extensions/extension.js";
/** The core server logic. Combine this with a HTTP framework to create a fully-fledged server. */
export declare class ServerCore {
    private extensions;
    private peer;
    private isReady;
    /**
     * Create a new server with an array of extensions.
     * @param extensions - The extensions used by the server. Extensions will be registered in the order you provide them in, as one extension may depend on the actions of another. For example, the `ExtensionServeContent` may rely on a replica created by `ExtensionKnownShares`.
     */
    constructor(extensions: IServerExtension[]);
    private registerExtensions;
    handler(req: dntShim.Request): Promise<dntShim.Response>;
}
