import { DocBase, ShareAddress } from "../util/doc-types.js";
import { AttachmentTransferOpts, AttachmentTransferProgressEvent, AttachmentTransferStatus } from "./syncer_types.js";
export declare class AttachmentTransfer<F> {
    kind: "download" | "upload";
    status: AttachmentTransferStatus;
    share: ShareAddress;
    loaded: number;
    expectedSize: number;
    private sourceDoc;
    private statusBus;
    private transferOp;
    private abortCb;
    private multiDeferred;
    hash: string;
    requester: "us" | "them";
    constructor({ stream, replica, doc, format, requester, counterpartId }: AttachmentTransferOpts<F>);
    start(): Promise<void>;
    private updateLoaded;
    private changeStatus;
    get doc(): DocBase<string>;
    onProgress(callback: (event: AttachmentTransferProgressEvent) => void): () => void;
    abort(): void;
    isDone(): import("../../deps.js").Deferred<unknown>;
}
