/// <reference types="ws" />
import * as dntShim from "../../_dnt.shims.js";
import { NotSupportedError } from "../util/errors.js";
import { GetTransferOpts, ISyncPartner, SyncAppetite, SyncerEvent } from "./syncer_types.js";
type SyncerDriverWebServerOpts = {
    /** A websocket created from the initial sync request. */
    socket: dntShim.WebSocket;
    appetite: SyncAppetite;
};
/** A syncing partner created from an inbound HTTP connection (i.e. a web client).
 *
 * Works everywhere, but is really meant for servers running on Deno and Node.
 */
export declare class PartnerWebClient<IncomingTransferSourceType extends dntShim.WebSocket> implements ISyncPartner<IncomingTransferSourceType> {
    concurrentTransfers: number;
    payloadThreshold: number;
    rangeDivision: number;
    syncAppetite: SyncAppetite;
    private socket;
    private incomingQueue;
    private socketIsReady;
    constructor({ socket, appetite }: SyncerDriverWebServerOpts);
    sendEvent(event: SyncerEvent): Promise<void>;
    getEvents(): AsyncIterable<SyncerEvent>;
    closeConnection(): Promise<void>;
    getDownload(_opts: GetTransferOpts): Promise<dntShim.ReadableStream<Uint8Array> | NotSupportedError>;
    handleUploadRequest(_opts: GetTransferOpts): Promise<dntShim.WritableStream<Uint8Array> | NotSupportedError>;
    handleTransferRequest(socket: IncomingTransferSourceType, kind: "upload" | "download"): Promise<dntShim.ReadableStream<Uint8Array> | dntShim.WritableStream<Uint8Array> | undefined>;
}
export {};
