import * as dntShim from "../../_dnt.shims.js";
import { NotSupportedError } from "../util/errors.js";
import { GetTransferOpts, ISyncPartner, SyncAppetite, SyncerEvent } from "./syncer_types.js";
type SyncerDriverWebClientOpts = {
    /** The URL of the server to sync with. */
    url: string;
    appetite: SyncAppetite;
};
/** A syncing partner to be used with servers reachable via the internet.
 * Works everywhere.
 */
export declare class PartnerWebServer<IncomingTransferSourceType extends undefined> implements ISyncPartner<undefined> {
    syncAppetite: SyncAppetite;
    concurrentTransfers: number;
    payloadThreshold: number;
    rangeDivision: number;
    private isSecure;
    private wsUrl;
    private socket;
    private incomingQueue;
    private socketIsReady;
    constructor(opts: SyncerDriverWebClientOpts);
    sendEvent(event: SyncerEvent): Promise<void>;
    getEvents(): AsyncIterable<SyncerEvent>;
    closeConnection(): Promise<void>;
    getDownload(opts: GetTransferOpts): Promise<dntShim.ReadableStream<Uint8Array> | undefined>;
    handleUploadRequest(opts: GetTransferOpts): Promise<dntShim.WritableStream<Uint8Array> | NotSupportedError>;
    handleTransferRequest(_source: IncomingTransferSourceType, _kind: "upload" | "download"): Promise<dntShim.ReadableStream<Uint8Array> | dntShim.WritableStream<Uint8Array> | undefined | NotSupportedError>;
}
export {};
