import { AttachmentTransfer } from "./attachment_transfer.js";
import { AttachmentTransferReport } from "./syncer_types.js";
export declare class TransferQueue {
    private waiting;
    private active;
    private failed;
    private completed;
    private activeLimit;
    private transfersRequestedByUsEnroller;
    private reports;
    private reportBus;
    constructor(activeLimit: number);
    private activate;
    private queue;
    private admitNext;
    addTransfer(transfer: AttachmentTransfer<unknown>): Promise<void>;
    gotAllTransfersRequestedByUs(): void;
    cancel(): void;
    private updateTransferStatus;
    getReport(): Record<string, AttachmentTransferReport[]>;
    hasQueuedTransfer(hash: string, kind: "upload" | "download"): boolean;
    onReportUpdate(cb: (report: Record<string, AttachmentTransferReport[]>) => void): () => void;
    transfersRequestedByUsFinished(): import("../../deps.js").Deferred<unknown>;
}
