import { ShareAddress } from "./doc-types.js";
import { ValidationError } from "./errors.js";
/** Creates an invitation URL. Validates the share address, that servers are valid URLs, and the secret against the share address if given. */
export declare function createInvitationURL(shareAddress: ShareAddress, servers: string[], secret?: string): Promise<string | ValidationError>;
type ParsedInvitation = {
    shareAddress: ShareAddress;
    secret?: string;
    servers: string[];
};
/** Parses an invitation URL. Validates the share address, secret (if given), and any server URLs. */
export declare function parseInvitationURL(invitationURL: string): Promise<ParsedInvitation | ValidationError>;
export {};
