import { ValidationError } from "./errors.js";
export declare function microsecondNow(): number;
/** Returns a promise which is fulfilled after a given number of milliseconds. */
export declare function sleep(ms: number): Promise<void>;
export declare function randomId(): string;
export declare function replaceAll(str: string, from: string, to: string): string;
export declare function countChars(str: string, char: string): number;
export declare function isObjectEmpty(obj: Object): Boolean;
/** Returns a valid share address generated using a given name.
 * @returns A share address or a validation error resulting from the name given.
 * @deprecated This function only generates valid es.4 addresses. Use Crypto.generateShareKeypair to generate es.5 share addresses.
 */
export declare function generateShareAddress(name: string): string | ValidationError;
