declare const _default: {
    readonly "application/1d-interleaved-parityfec": {
        readonly source: "iana";
    };
    readonly "application/3gpdash-qoe-report+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/3gpp-ims+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/3gpphal+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/3gpphalforms+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/a2l": {
        readonly source: "iana";
    };
    readonly "application/ace+cbor": {
        readonly source: "iana";
    };
    readonly "application/activemessage": {
        readonly source: "iana";
    };
    readonly "application/activity+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-costmap+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-costmapfilter+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-directory+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-endpointcost+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-endpointcostparams+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-endpointprop+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-endpointpropparams+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-error+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-networkmap+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-networkmapfilter+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-updatestreamcontrol+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/alto-updatestreamparams+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/aml": {
        readonly source: "iana";
    };
    readonly "application/andrew-inset": {
        readonly source: "iana";
        readonly extensions: readonly ["ez"];
    };
    readonly "application/applefile": {
        readonly source: "iana";
    };
    readonly "application/applixware": {
        readonly source: "apache";
        readonly extensions: readonly ["aw"];
    };
    readonly "application/at+jwt": {
        readonly source: "iana";
    };
    readonly "application/atf": {
        readonly source: "iana";
    };
    readonly "application/atfx": {
        readonly source: "iana";
    };
    readonly "application/atom+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["atom"];
    };
    readonly "application/atomcat+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["atomcat"];
    };
    readonly "application/atomdeleted+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["atomdeleted"];
    };
    readonly "application/atomicmail": {
        readonly source: "iana";
    };
    readonly "application/atomsvc+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["atomsvc"];
    };
    readonly "application/atsc-dwd+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["dwd"];
    };
    readonly "application/atsc-dynamic-event-message": {
        readonly source: "iana";
    };
    readonly "application/atsc-held+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["held"];
    };
    readonly "application/atsc-rdt+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/atsc-rsat+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rsat"];
    };
    readonly "application/atxml": {
        readonly source: "iana";
    };
    readonly "application/auth-policy+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/bacnet-xdd+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/batch-smtp": {
        readonly source: "iana";
    };
    readonly "application/bdoc": {
        readonly compressible: false;
        readonly extensions: readonly ["bdoc"];
    };
    readonly "application/beep+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/calendar+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/calendar+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xcs"];
    };
    readonly "application/call-completion": {
        readonly source: "iana";
    };
    readonly "application/cals-1840": {
        readonly source: "iana";
    };
    readonly "application/captive+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cbor": {
        readonly source: "iana";
    };
    readonly "application/cbor-seq": {
        readonly source: "iana";
    };
    readonly "application/cccex": {
        readonly source: "iana";
    };
    readonly "application/ccmp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/ccxml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ccxml"];
    };
    readonly "application/cdfx+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["cdfx"];
    };
    readonly "application/cdmi-capability": {
        readonly source: "iana";
        readonly extensions: readonly ["cdmia"];
    };
    readonly "application/cdmi-container": {
        readonly source: "iana";
        readonly extensions: readonly ["cdmic"];
    };
    readonly "application/cdmi-domain": {
        readonly source: "iana";
        readonly extensions: readonly ["cdmid"];
    };
    readonly "application/cdmi-object": {
        readonly source: "iana";
        readonly extensions: readonly ["cdmio"];
    };
    readonly "application/cdmi-queue": {
        readonly source: "iana";
        readonly extensions: readonly ["cdmiq"];
    };
    readonly "application/cdni": {
        readonly source: "iana";
    };
    readonly "application/cea": {
        readonly source: "iana";
    };
    readonly "application/cea-2018+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cellml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cfw": {
        readonly source: "iana";
    };
    readonly "application/city+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/clr": {
        readonly source: "iana";
    };
    readonly "application/clue+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/clue_info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cms": {
        readonly source: "iana";
    };
    readonly "application/cnrp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/coap-group+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/coap-payload": {
        readonly source: "iana";
    };
    readonly "application/commonground": {
        readonly source: "iana";
    };
    readonly "application/conference-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cose": {
        readonly source: "iana";
    };
    readonly "application/cose-key": {
        readonly source: "iana";
    };
    readonly "application/cose-key-set": {
        readonly source: "iana";
    };
    readonly "application/cpl+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["cpl"];
    };
    readonly "application/csrattrs": {
        readonly source: "iana";
    };
    readonly "application/csta+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cstadata+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/csvm+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/cu-seeme": {
        readonly source: "apache";
        readonly extensions: readonly ["cu"];
    };
    readonly "application/cwt": {
        readonly source: "iana";
    };
    readonly "application/cybercash": {
        readonly source: "iana";
    };
    readonly "application/dart": {
        readonly compressible: true;
    };
    readonly "application/dash+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mpd"];
    };
    readonly "application/dash-patch+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mpp"];
    };
    readonly "application/dashdelta": {
        readonly source: "iana";
    };
    readonly "application/davmount+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["davmount"];
    };
    readonly "application/dca-rft": {
        readonly source: "iana";
    };
    readonly "application/dcd": {
        readonly source: "iana";
    };
    readonly "application/dec-dx": {
        readonly source: "iana";
    };
    readonly "application/dialog-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/dicom": {
        readonly source: "iana";
    };
    readonly "application/dicom+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/dicom+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/dii": {
        readonly source: "iana";
    };
    readonly "application/dit": {
        readonly source: "iana";
    };
    readonly "application/dns": {
        readonly source: "iana";
    };
    readonly "application/dns+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/dns-message": {
        readonly source: "iana";
    };
    readonly "application/docbook+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["dbk"];
    };
    readonly "application/dots+cbor": {
        readonly source: "iana";
    };
    readonly "application/dskpp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/dssc+der": {
        readonly source: "iana";
        readonly extensions: readonly ["dssc"];
    };
    readonly "application/dssc+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xdssc"];
    };
    readonly "application/dvcs": {
        readonly source: "iana";
    };
    readonly "application/ecmascript": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["es", "ecma"];
    };
    readonly "application/edi-consent": {
        readonly source: "iana";
    };
    readonly "application/edi-x12": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/edifact": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/efi": {
        readonly source: "iana";
    };
    readonly "application/elm+json": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/elm+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.cap+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.comment+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.control+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.deviceinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.ecall.msd": {
        readonly source: "iana";
    };
    readonly "application/emergencycalldata.providerinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.serviceinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.subscriberinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emergencycalldata.veds+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/emma+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["emma"];
    };
    readonly "application/emotionml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["emotionml"];
    };
    readonly "application/encaprtp": {
        readonly source: "iana";
    };
    readonly "application/epp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/epub+zip": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["epub"];
    };
    readonly "application/eshop": {
        readonly source: "iana";
    };
    readonly "application/exi": {
        readonly source: "iana";
        readonly extensions: readonly ["exi"];
    };
    readonly "application/expect-ct-report+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/express": {
        readonly source: "iana";
        readonly extensions: readonly ["exp"];
    };
    readonly "application/fastinfoset": {
        readonly source: "iana";
    };
    readonly "application/fastsoap": {
        readonly source: "iana";
    };
    readonly "application/fdt+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["fdt"];
    };
    readonly "application/fhir+json": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/fhir+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/fido.trusted-apps+json": {
        readonly compressible: true;
    };
    readonly "application/fits": {
        readonly source: "iana";
    };
    readonly "application/flexfec": {
        readonly source: "iana";
    };
    readonly "application/font-sfnt": {
        readonly source: "iana";
    };
    readonly "application/font-tdpfr": {
        readonly source: "iana";
        readonly extensions: readonly ["pfr"];
    };
    readonly "application/font-woff": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/framework-attributes+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/geo+json": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["geojson"];
    };
    readonly "application/geo+json-seq": {
        readonly source: "iana";
    };
    readonly "application/geopackage+sqlite3": {
        readonly source: "iana";
    };
    readonly "application/geoxacml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/gltf-buffer": {
        readonly source: "iana";
    };
    readonly "application/gml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["gml"];
    };
    readonly "application/gpx+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["gpx"];
    };
    readonly "application/gxf": {
        readonly source: "apache";
        readonly extensions: readonly ["gxf"];
    };
    readonly "application/gzip": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["gz"];
    };
    readonly "application/h224": {
        readonly source: "iana";
    };
    readonly "application/held+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/hjson": {
        readonly extensions: readonly ["hjson"];
    };
    readonly "application/http": {
        readonly source: "iana";
    };
    readonly "application/hyperstudio": {
        readonly source: "iana";
        readonly extensions: readonly ["stk"];
    };
    readonly "application/ibe-key-request+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/ibe-pkg-reply+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/ibe-pp-data": {
        readonly source: "iana";
    };
    readonly "application/iges": {
        readonly source: "iana";
    };
    readonly "application/im-iscomposing+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/index": {
        readonly source: "iana";
    };
    readonly "application/index.cmd": {
        readonly source: "iana";
    };
    readonly "application/index.obj": {
        readonly source: "iana";
    };
    readonly "application/index.response": {
        readonly source: "iana";
    };
    readonly "application/index.vnd": {
        readonly source: "iana";
    };
    readonly "application/inkml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ink", "inkml"];
    };
    readonly "application/iotp": {
        readonly source: "iana";
    };
    readonly "application/ipfix": {
        readonly source: "iana";
        readonly extensions: readonly ["ipfix"];
    };
    readonly "application/ipp": {
        readonly source: "iana";
    };
    readonly "application/isup": {
        readonly source: "iana";
    };
    readonly "application/its+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["its"];
    };
    readonly "application/java-archive": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["jar", "war", "ear"];
    };
    readonly "application/java-serialized-object": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["ser"];
    };
    readonly "application/java-vm": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["class"];
    };
    readonly "application/javascript": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["js", "mjs"];
    };
    readonly "application/jf2feed+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/jose": {
        readonly source: "iana";
    };
    readonly "application/jose+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/jrd+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/jscalendar+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/json": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["json", "map"];
    };
    readonly "application/json-patch+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/json-seq": {
        readonly source: "iana";
    };
    readonly "application/json5": {
        readonly extensions: readonly ["json5"];
    };
    readonly "application/jsonml+json": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["jsonml"];
    };
    readonly "application/jwk+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/jwk-set+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/jwt": {
        readonly source: "iana";
    };
    readonly "application/kpml-request+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/kpml-response+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/ld+json": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["jsonld"];
    };
    readonly "application/lgr+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["lgr"];
    };
    readonly "application/link-format": {
        readonly source: "iana";
    };
    readonly "application/load-control+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/lost+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["lostxml"];
    };
    readonly "application/lostsync+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/lpf+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/lxf": {
        readonly source: "iana";
    };
    readonly "application/mac-binhex40": {
        readonly source: "iana";
        readonly extensions: readonly ["hqx"];
    };
    readonly "application/mac-compactpro": {
        readonly source: "apache";
        readonly extensions: readonly ["cpt"];
    };
    readonly "application/macwriteii": {
        readonly source: "iana";
    };
    readonly "application/mads+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mads"];
    };
    readonly "application/manifest+json": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["webmanifest"];
    };
    readonly "application/marc": {
        readonly source: "iana";
        readonly extensions: readonly ["mrc"];
    };
    readonly "application/marcxml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mrcx"];
    };
    readonly "application/mathematica": {
        readonly source: "iana";
        readonly extensions: readonly ["ma", "nb", "mb"];
    };
    readonly "application/mathml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mathml"];
    };
    readonly "application/mathml-content+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mathml-presentation+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-associated-procedure-description+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-deregister+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-envelope+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-msk+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-msk-response+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-protection-description+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-reception-report+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-register+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-register-response+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-schedule+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbms-user-service-description+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mbox": {
        readonly source: "iana";
        readonly extensions: readonly ["mbox"];
    };
    readonly "application/media-policy-dataset+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mpf"];
    };
    readonly "application/media_control+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mediaservercontrol+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mscml"];
    };
    readonly "application/merge-patch+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/metalink+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["metalink"];
    };
    readonly "application/metalink4+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["meta4"];
    };
    readonly "application/mets+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mets"];
    };
    readonly "application/mf4": {
        readonly source: "iana";
    };
    readonly "application/mikey": {
        readonly source: "iana";
    };
    readonly "application/mipc": {
        readonly source: "iana";
    };
    readonly "application/missing-blocks+cbor-seq": {
        readonly source: "iana";
    };
    readonly "application/mmt-aei+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["maei"];
    };
    readonly "application/mmt-usd+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["musd"];
    };
    readonly "application/mods+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mods"];
    };
    readonly "application/moss-keys": {
        readonly source: "iana";
    };
    readonly "application/moss-signature": {
        readonly source: "iana";
    };
    readonly "application/mosskey-data": {
        readonly source: "iana";
    };
    readonly "application/mosskey-request": {
        readonly source: "iana";
    };
    readonly "application/mp21": {
        readonly source: "iana";
        readonly extensions: readonly ["m21", "mp21"];
    };
    readonly "application/mp4": {
        readonly source: "iana";
        readonly extensions: readonly ["mp4s", "m4p"];
    };
    readonly "application/mpeg4-generic": {
        readonly source: "iana";
    };
    readonly "application/mpeg4-iod": {
        readonly source: "iana";
    };
    readonly "application/mpeg4-iod-xmt": {
        readonly source: "iana";
    };
    readonly "application/mrb-consumer+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/mrb-publish+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/msc-ivr+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/msc-mixer+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/msword": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["doc", "dot"];
    };
    readonly "application/mud+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/multipart-core": {
        readonly source: "iana";
    };
    readonly "application/mxf": {
        readonly source: "iana";
        readonly extensions: readonly ["mxf"];
    };
    readonly "application/n-quads": {
        readonly source: "iana";
        readonly extensions: readonly ["nq"];
    };
    readonly "application/n-triples": {
        readonly source: "iana";
        readonly extensions: readonly ["nt"];
    };
    readonly "application/nasdata": {
        readonly source: "iana";
    };
    readonly "application/news-checkgroups": {
        readonly source: "iana";
        readonly charset: "US-ASCII";
    };
    readonly "application/news-groupinfo": {
        readonly source: "iana";
        readonly charset: "US-ASCII";
    };
    readonly "application/news-transmission": {
        readonly source: "iana";
    };
    readonly "application/nlsml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/node": {
        readonly source: "iana";
        readonly extensions: readonly ["cjs"];
    };
    readonly "application/nss": {
        readonly source: "iana";
    };
    readonly "application/oauth-authz-req+jwt": {
        readonly source: "iana";
    };
    readonly "application/oblivious-dns-message": {
        readonly source: "iana";
    };
    readonly "application/ocsp-request": {
        readonly source: "iana";
    };
    readonly "application/ocsp-response": {
        readonly source: "iana";
    };
    readonly "application/octet-stream": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"];
    };
    readonly "application/oda": {
        readonly source: "iana";
        readonly extensions: readonly ["oda"];
    };
    readonly "application/odm+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/odx": {
        readonly source: "iana";
    };
    readonly "application/oebps-package+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["opf"];
    };
    readonly "application/ogg": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["ogx"];
    };
    readonly "application/omdoc+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["omdoc"];
    };
    readonly "application/onenote": {
        readonly source: "apache";
        readonly extensions: readonly ["onetoc", "onetoc2", "onetmp", "onepkg"];
    };
    readonly "application/opc-nodeset+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/oscore": {
        readonly source: "iana";
    };
    readonly "application/oxps": {
        readonly source: "iana";
        readonly extensions: readonly ["oxps"];
    };
    readonly "application/p21": {
        readonly source: "iana";
    };
    readonly "application/p21+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/p2p-overlay+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["relo"];
    };
    readonly "application/parityfec": {
        readonly source: "iana";
    };
    readonly "application/passport": {
        readonly source: "iana";
    };
    readonly "application/patch-ops-error+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xer"];
    };
    readonly "application/pdf": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["pdf"];
    };
    readonly "application/pdx": {
        readonly source: "iana";
    };
    readonly "application/pem-certificate-chain": {
        readonly source: "iana";
    };
    readonly "application/pgp-encrypted": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["pgp"];
    };
    readonly "application/pgp-keys": {
        readonly source: "iana";
        readonly extensions: readonly ["asc"];
    };
    readonly "application/pgp-signature": {
        readonly source: "iana";
        readonly extensions: readonly ["asc", "sig"];
    };
    readonly "application/pics-rules": {
        readonly source: "apache";
        readonly extensions: readonly ["prf"];
    };
    readonly "application/pidf+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/pidf-diff+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/pkcs10": {
        readonly source: "iana";
        readonly extensions: readonly ["p10"];
    };
    readonly "application/pkcs12": {
        readonly source: "iana";
    };
    readonly "application/pkcs7-mime": {
        readonly source: "iana";
        readonly extensions: readonly ["p7m", "p7c"];
    };
    readonly "application/pkcs7-signature": {
        readonly source: "iana";
        readonly extensions: readonly ["p7s"];
    };
    readonly "application/pkcs8": {
        readonly source: "iana";
        readonly extensions: readonly ["p8"];
    };
    readonly "application/pkcs8-encrypted": {
        readonly source: "iana";
    };
    readonly "application/pkix-attr-cert": {
        readonly source: "iana";
        readonly extensions: readonly ["ac"];
    };
    readonly "application/pkix-cert": {
        readonly source: "iana";
        readonly extensions: readonly ["cer"];
    };
    readonly "application/pkix-crl": {
        readonly source: "iana";
        readonly extensions: readonly ["crl"];
    };
    readonly "application/pkix-pkipath": {
        readonly source: "iana";
        readonly extensions: readonly ["pkipath"];
    };
    readonly "application/pkixcmp": {
        readonly source: "iana";
        readonly extensions: readonly ["pki"];
    };
    readonly "application/pls+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["pls"];
    };
    readonly "application/poc-settings+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/postscript": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ai", "eps", "ps"];
    };
    readonly "application/ppsp-tracker+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/problem+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/problem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/provenance+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["provx"];
    };
    readonly "application/prs.alvestrand.titrax-sheet": {
        readonly source: "iana";
    };
    readonly "application/prs.cww": {
        readonly source: "iana";
        readonly extensions: readonly ["cww"];
    };
    readonly "application/prs.cyn": {
        readonly source: "iana";
        readonly charset: "7-BIT";
    };
    readonly "application/prs.hpub+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/prs.nprend": {
        readonly source: "iana";
    };
    readonly "application/prs.plucker": {
        readonly source: "iana";
    };
    readonly "application/prs.rdf-xml-crypt": {
        readonly source: "iana";
    };
    readonly "application/prs.xsf+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/pskc+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["pskcxml"];
    };
    readonly "application/pvd+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/qsig": {
        readonly source: "iana";
    };
    readonly "application/raml+yaml": {
        readonly compressible: true;
        readonly extensions: readonly ["raml"];
    };
    readonly "application/raptorfec": {
        readonly source: "iana";
    };
    readonly "application/rdap+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/rdf+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rdf", "owl"];
    };
    readonly "application/reginfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rif"];
    };
    readonly "application/relax-ng-compact-syntax": {
        readonly source: "iana";
        readonly extensions: readonly ["rnc"];
    };
    readonly "application/remote-printing": {
        readonly source: "iana";
    };
    readonly "application/reputon+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/resource-lists+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rl"];
    };
    readonly "application/resource-lists-diff+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rld"];
    };
    readonly "application/rfc+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/riscos": {
        readonly source: "iana";
    };
    readonly "application/rlmi+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/rls-services+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rs"];
    };
    readonly "application/route-apd+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rapd"];
    };
    readonly "application/route-s-tsid+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["sls"];
    };
    readonly "application/route-usd+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rusd"];
    };
    readonly "application/rpki-ghostbusters": {
        readonly source: "iana";
        readonly extensions: readonly ["gbr"];
    };
    readonly "application/rpki-manifest": {
        readonly source: "iana";
        readonly extensions: readonly ["mft"];
    };
    readonly "application/rpki-publication": {
        readonly source: "iana";
    };
    readonly "application/rpki-roa": {
        readonly source: "iana";
        readonly extensions: readonly ["roa"];
    };
    readonly "application/rpki-updown": {
        readonly source: "iana";
    };
    readonly "application/rsd+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["rsd"];
    };
    readonly "application/rss+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["rss"];
    };
    readonly "application/rtf": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rtf"];
    };
    readonly "application/rtploopback": {
        readonly source: "iana";
    };
    readonly "application/rtx": {
        readonly source: "iana";
    };
    readonly "application/samlassertion+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/samlmetadata+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sarif+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sarif-external-properties+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sbe": {
        readonly source: "iana";
    };
    readonly "application/sbml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["sbml"];
    };
    readonly "application/scaip+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/scim+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/scvp-cv-request": {
        readonly source: "iana";
        readonly extensions: readonly ["scq"];
    };
    readonly "application/scvp-cv-response": {
        readonly source: "iana";
        readonly extensions: readonly ["scs"];
    };
    readonly "application/scvp-vp-request": {
        readonly source: "iana";
        readonly extensions: readonly ["spq"];
    };
    readonly "application/scvp-vp-response": {
        readonly source: "iana";
        readonly extensions: readonly ["spp"];
    };
    readonly "application/sdp": {
        readonly source: "iana";
        readonly extensions: readonly ["sdp"];
    };
    readonly "application/secevent+jwt": {
        readonly source: "iana";
    };
    readonly "application/senml+cbor": {
        readonly source: "iana";
    };
    readonly "application/senml+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/senml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["senmlx"];
    };
    readonly "application/senml-etch+cbor": {
        readonly source: "iana";
    };
    readonly "application/senml-etch+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/senml-exi": {
        readonly source: "iana";
    };
    readonly "application/sensml+cbor": {
        readonly source: "iana";
    };
    readonly "application/sensml+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sensml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["sensmlx"];
    };
    readonly "application/sensml-exi": {
        readonly source: "iana";
    };
    readonly "application/sep+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sep-exi": {
        readonly source: "iana";
    };
    readonly "application/session-info": {
        readonly source: "iana";
    };
    readonly "application/set-payment": {
        readonly source: "iana";
    };
    readonly "application/set-payment-initiation": {
        readonly source: "iana";
        readonly extensions: readonly ["setpay"];
    };
    readonly "application/set-registration": {
        readonly source: "iana";
    };
    readonly "application/set-registration-initiation": {
        readonly source: "iana";
        readonly extensions: readonly ["setreg"];
    };
    readonly "application/sgml": {
        readonly source: "iana";
    };
    readonly "application/sgml-open-catalog": {
        readonly source: "iana";
    };
    readonly "application/shf+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["shf"];
    };
    readonly "application/sieve": {
        readonly source: "iana";
        readonly extensions: readonly ["siv", "sieve"];
    };
    readonly "application/simple-filter+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/simple-message-summary": {
        readonly source: "iana";
    };
    readonly "application/simplesymbolcontainer": {
        readonly source: "iana";
    };
    readonly "application/sipc": {
        readonly source: "iana";
    };
    readonly "application/slate": {
        readonly source: "iana";
    };
    readonly "application/smil": {
        readonly source: "iana";
    };
    readonly "application/smil+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["smi", "smil"];
    };
    readonly "application/smpte336m": {
        readonly source: "iana";
    };
    readonly "application/soap+fastinfoset": {
        readonly source: "iana";
    };
    readonly "application/soap+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sparql-query": {
        readonly source: "iana";
        readonly extensions: readonly ["rq"];
    };
    readonly "application/sparql-results+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["srx"];
    };
    readonly "application/spdx+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/spirits-event+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/sql": {
        readonly source: "iana";
    };
    readonly "application/srgs": {
        readonly source: "iana";
        readonly extensions: readonly ["gram"];
    };
    readonly "application/srgs+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["grxml"];
    };
    readonly "application/sru+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["sru"];
    };
    readonly "application/ssdl+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["ssdl"];
    };
    readonly "application/ssml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ssml"];
    };
    readonly "application/stix+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/swid+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["swidtag"];
    };
    readonly "application/tamp-apex-update": {
        readonly source: "iana";
    };
    readonly "application/tamp-apex-update-confirm": {
        readonly source: "iana";
    };
    readonly "application/tamp-community-update": {
        readonly source: "iana";
    };
    readonly "application/tamp-community-update-confirm": {
        readonly source: "iana";
    };
    readonly "application/tamp-error": {
        readonly source: "iana";
    };
    readonly "application/tamp-sequence-adjust": {
        readonly source: "iana";
    };
    readonly "application/tamp-sequence-adjust-confirm": {
        readonly source: "iana";
    };
    readonly "application/tamp-status-query": {
        readonly source: "iana";
    };
    readonly "application/tamp-status-response": {
        readonly source: "iana";
    };
    readonly "application/tamp-update": {
        readonly source: "iana";
    };
    readonly "application/tamp-update-confirm": {
        readonly source: "iana";
    };
    readonly "application/tar": {
        readonly compressible: true;
    };
    readonly "application/taxii+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/td+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/tei+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["tei", "teicorpus"];
    };
    readonly "application/tetra_isi": {
        readonly source: "iana";
    };
    readonly "application/thraud+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["tfi"];
    };
    readonly "application/timestamp-query": {
        readonly source: "iana";
    };
    readonly "application/timestamp-reply": {
        readonly source: "iana";
    };
    readonly "application/timestamped-data": {
        readonly source: "iana";
        readonly extensions: readonly ["tsd"];
    };
    readonly "application/tlsrpt+gzip": {
        readonly source: "iana";
    };
    readonly "application/tlsrpt+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/tnauthlist": {
        readonly source: "iana";
    };
    readonly "application/token-introspection+jwt": {
        readonly source: "iana";
    };
    readonly "application/toml": {
        readonly compressible: true;
        readonly extensions: readonly ["toml"];
    };
    readonly "application/trickle-ice-sdpfrag": {
        readonly source: "iana";
    };
    readonly "application/trig": {
        readonly source: "iana";
        readonly extensions: readonly ["trig"];
    };
    readonly "application/ttml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ttml"];
    };
    readonly "application/tve-trigger": {
        readonly source: "iana";
    };
    readonly "application/tzif": {
        readonly source: "iana";
    };
    readonly "application/tzif-leap": {
        readonly source: "iana";
    };
    readonly "application/ubjson": {
        readonly compressible: false;
        readonly extensions: readonly ["ubj"];
    };
    readonly "application/ulpfec": {
        readonly source: "iana";
    };
    readonly "application/urc-grpsheet+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/urc-ressheet+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rsheet"];
    };
    readonly "application/urc-targetdesc+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["td"];
    };
    readonly "application/urc-uisocketdesc+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vcard+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vcard+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vemmi": {
        readonly source: "iana";
    };
    readonly "application/vividence.scriptfile": {
        readonly source: "apache";
    };
    readonly "application/vnd.1000minds.decision-model+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["1km"];
    };
    readonly "application/vnd.3gpp-prose+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp-prose-pc3ch+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp-v2x-local-service-information": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.5gnas": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.access-transfer-events+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.bsf+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.gmop+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.gtpc": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.interworking-data": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.lpp": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.mc-signalling-ear": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.mcdata-affiliation-command+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcdata-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcdata-payload": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.mcdata-service-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcdata-signalling": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.mcdata-ue-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcdata-user-profile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-affiliation-command+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-floor-request+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-location-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-mbms-usage-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-service-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-signed+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-ue-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-ue-init-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcptt-user-profile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-affiliation-command+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-affiliation-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-location-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-mbms-usage-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-service-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-transmission-request+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-ue-config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mcvideo-user-profile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.mid-call+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.ngap": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.pfcp": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.pic-bw-large": {
        readonly source: "iana";
        readonly extensions: readonly ["plb"];
    };
    readonly "application/vnd.3gpp.pic-bw-small": {
        readonly source: "iana";
        readonly extensions: readonly ["psb"];
    };
    readonly "application/vnd.3gpp.pic-bw-var": {
        readonly source: "iana";
        readonly extensions: readonly ["pvb"];
    };
    readonly "application/vnd.3gpp.s1ap": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.sms": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp.sms+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.srvcc-ext+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.srvcc-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.state-and-event-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp.ussd+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp2.bcmcsinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.3gpp2.sms": {
        readonly source: "iana";
    };
    readonly "application/vnd.3gpp2.tcap": {
        readonly source: "iana";
        readonly extensions: readonly ["tcap"];
    };
    readonly "application/vnd.3lightssoftware.imagescal": {
        readonly source: "iana";
    };
    readonly "application/vnd.3m.post-it-notes": {
        readonly source: "iana";
        readonly extensions: readonly ["pwn"];
    };
    readonly "application/vnd.accpac.simply.aso": {
        readonly source: "iana";
        readonly extensions: readonly ["aso"];
    };
    readonly "application/vnd.accpac.simply.imp": {
        readonly source: "iana";
        readonly extensions: readonly ["imp"];
    };
    readonly "application/vnd.acucobol": {
        readonly source: "iana";
        readonly extensions: readonly ["acu"];
    };
    readonly "application/vnd.acucorp": {
        readonly source: "iana";
        readonly extensions: readonly ["atc", "acutc"];
    };
    readonly "application/vnd.adobe.air-application-installer-package+zip": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["air"];
    };
    readonly "application/vnd.adobe.flash.movie": {
        readonly source: "iana";
    };
    readonly "application/vnd.adobe.formscentral.fcdt": {
        readonly source: "iana";
        readonly extensions: readonly ["fcdt"];
    };
    readonly "application/vnd.adobe.fxp": {
        readonly source: "iana";
        readonly extensions: readonly ["fxp", "fxpl"];
    };
    readonly "application/vnd.adobe.partial-upload": {
        readonly source: "iana";
    };
    readonly "application/vnd.adobe.xdp+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xdp"];
    };
    readonly "application/vnd.adobe.xfdf": {
        readonly source: "iana";
        readonly extensions: readonly ["xfdf"];
    };
    readonly "application/vnd.aether.imp": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.afplinedata": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.afplinedata-pagedef": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.cmoca-cmresource": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.foca-charset": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.foca-codedfont": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.foca-codepage": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca-cmtable": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca-formdef": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca-mediummap": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca-objectcontainer": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca-overlay": {
        readonly source: "iana";
    };
    readonly "application/vnd.afpc.modca-pagesegment": {
        readonly source: "iana";
    };
    readonly "application/vnd.age": {
        readonly source: "iana";
        readonly extensions: readonly ["age"];
    };
    readonly "application/vnd.ah-barcode": {
        readonly source: "iana";
    };
    readonly "application/vnd.ahead.space": {
        readonly source: "iana";
        readonly extensions: readonly ["ahead"];
    };
    readonly "application/vnd.airzip.filesecure.azf": {
        readonly source: "iana";
        readonly extensions: readonly ["azf"];
    };
    readonly "application/vnd.airzip.filesecure.azs": {
        readonly source: "iana";
        readonly extensions: readonly ["azs"];
    };
    readonly "application/vnd.amadeus+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.amazon.ebook": {
        readonly source: "apache";
        readonly extensions: readonly ["azw"];
    };
    readonly "application/vnd.amazon.mobi8-ebook": {
        readonly source: "iana";
    };
    readonly "application/vnd.americandynamics.acc": {
        readonly source: "iana";
        readonly extensions: readonly ["acc"];
    };
    readonly "application/vnd.amiga.ami": {
        readonly source: "iana";
        readonly extensions: readonly ["ami"];
    };
    readonly "application/vnd.amundsen.maze+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.android.ota": {
        readonly source: "iana";
    };
    readonly "application/vnd.android.package-archive": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["apk"];
    };
    readonly "application/vnd.anki": {
        readonly source: "iana";
    };
    readonly "application/vnd.anser-web-certificate-issue-initiation": {
        readonly source: "iana";
        readonly extensions: readonly ["cii"];
    };
    readonly "application/vnd.anser-web-funds-transfer-initiation": {
        readonly source: "apache";
        readonly extensions: readonly ["fti"];
    };
    readonly "application/vnd.antix.game-component": {
        readonly source: "iana";
        readonly extensions: readonly ["atx"];
    };
    readonly "application/vnd.apache.arrow.file": {
        readonly source: "iana";
    };
    readonly "application/vnd.apache.arrow.stream": {
        readonly source: "iana";
    };
    readonly "application/vnd.apache.thrift.binary": {
        readonly source: "iana";
    };
    readonly "application/vnd.apache.thrift.compact": {
        readonly source: "iana";
    };
    readonly "application/vnd.apache.thrift.json": {
        readonly source: "iana";
    };
    readonly "application/vnd.api+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.aplextor.warrp+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.apothekende.reservation+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.apple.installer+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mpkg"];
    };
    readonly "application/vnd.apple.keynote": {
        readonly source: "iana";
        readonly extensions: readonly ["key"];
    };
    readonly "application/vnd.apple.mpegurl": {
        readonly source: "iana";
        readonly extensions: readonly ["m3u8"];
    };
    readonly "application/vnd.apple.numbers": {
        readonly source: "iana";
        readonly extensions: readonly ["numbers"];
    };
    readonly "application/vnd.apple.pages": {
        readonly source: "iana";
        readonly extensions: readonly ["pages"];
    };
    readonly "application/vnd.apple.pkpass": {
        readonly compressible: false;
        readonly extensions: readonly ["pkpass"];
    };
    readonly "application/vnd.arastra.swi": {
        readonly source: "iana";
    };
    readonly "application/vnd.aristanetworks.swi": {
        readonly source: "iana";
        readonly extensions: readonly ["swi"];
    };
    readonly "application/vnd.artisan+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.artsquare": {
        readonly source: "iana";
    };
    readonly "application/vnd.astraea-software.iota": {
        readonly source: "iana";
        readonly extensions: readonly ["iota"];
    };
    readonly "application/vnd.audiograph": {
        readonly source: "iana";
        readonly extensions: readonly ["aep"];
    };
    readonly "application/vnd.autopackage": {
        readonly source: "iana";
    };
    readonly "application/vnd.avalon+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.avistar+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.balsamiq.bmml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["bmml"];
    };
    readonly "application/vnd.balsamiq.bmpr": {
        readonly source: "iana";
    };
    readonly "application/vnd.banana-accounting": {
        readonly source: "iana";
    };
    readonly "application/vnd.bbf.usp.error": {
        readonly source: "iana";
    };
    readonly "application/vnd.bbf.usp.msg": {
        readonly source: "iana";
    };
    readonly "application/vnd.bbf.usp.msg+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.bekitzur-stech+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.bint.med-content": {
        readonly source: "iana";
    };
    readonly "application/vnd.biopax.rdf+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.blink-idb-value-wrapper": {
        readonly source: "iana";
    };
    readonly "application/vnd.blueice.multipass": {
        readonly source: "iana";
        readonly extensions: readonly ["mpm"];
    };
    readonly "application/vnd.bluetooth.ep.oob": {
        readonly source: "iana";
    };
    readonly "application/vnd.bluetooth.le.oob": {
        readonly source: "iana";
    };
    readonly "application/vnd.bmi": {
        readonly source: "iana";
        readonly extensions: readonly ["bmi"];
    };
    readonly "application/vnd.bpf": {
        readonly source: "iana";
    };
    readonly "application/vnd.bpf3": {
        readonly source: "iana";
    };
    readonly "application/vnd.businessobjects": {
        readonly source: "iana";
        readonly extensions: readonly ["rep"];
    };
    readonly "application/vnd.byu.uapi+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.cab-jscript": {
        readonly source: "iana";
    };
    readonly "application/vnd.canon-cpdl": {
        readonly source: "iana";
    };
    readonly "application/vnd.canon-lips": {
        readonly source: "iana";
    };
    readonly "application/vnd.capasystems-pg+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.cendio.thinlinc.clientconf": {
        readonly source: "iana";
    };
    readonly "application/vnd.century-systems.tcp_stream": {
        readonly source: "iana";
    };
    readonly "application/vnd.chemdraw+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["cdxml"];
    };
    readonly "application/vnd.chess-pgn": {
        readonly source: "iana";
    };
    readonly "application/vnd.chipnuts.karaoke-mmd": {
        readonly source: "iana";
        readonly extensions: readonly ["mmd"];
    };
    readonly "application/vnd.ciedi": {
        readonly source: "iana";
    };
    readonly "application/vnd.cinderella": {
        readonly source: "iana";
        readonly extensions: readonly ["cdy"];
    };
    readonly "application/vnd.cirpack.isdn-ext": {
        readonly source: "iana";
    };
    readonly "application/vnd.citationstyles.style+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["csl"];
    };
    readonly "application/vnd.claymore": {
        readonly source: "iana";
        readonly extensions: readonly ["cla"];
    };
    readonly "application/vnd.cloanto.rp9": {
        readonly source: "iana";
        readonly extensions: readonly ["rp9"];
    };
    readonly "application/vnd.clonk.c4group": {
        readonly source: "iana";
        readonly extensions: readonly ["c4g", "c4d", "c4f", "c4p", "c4u"];
    };
    readonly "application/vnd.cluetrust.cartomobile-config": {
        readonly source: "iana";
        readonly extensions: readonly ["c11amc"];
    };
    readonly "application/vnd.cluetrust.cartomobile-config-pkg": {
        readonly source: "iana";
        readonly extensions: readonly ["c11amz"];
    };
    readonly "application/vnd.coffeescript": {
        readonly source: "iana";
    };
    readonly "application/vnd.collabio.xodocuments.document": {
        readonly source: "iana";
    };
    readonly "application/vnd.collabio.xodocuments.document-template": {
        readonly source: "iana";
    };
    readonly "application/vnd.collabio.xodocuments.presentation": {
        readonly source: "iana";
    };
    readonly "application/vnd.collabio.xodocuments.presentation-template": {
        readonly source: "iana";
    };
    readonly "application/vnd.collabio.xodocuments.spreadsheet": {
        readonly source: "iana";
    };
    readonly "application/vnd.collabio.xodocuments.spreadsheet-template": {
        readonly source: "iana";
    };
    readonly "application/vnd.collection+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.collection.doc+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.collection.next+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.comicbook+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.comicbook-rar": {
        readonly source: "iana";
    };
    readonly "application/vnd.commerce-battelle": {
        readonly source: "iana";
    };
    readonly "application/vnd.commonspace": {
        readonly source: "iana";
        readonly extensions: readonly ["csp"];
    };
    readonly "application/vnd.contact.cmsg": {
        readonly source: "iana";
        readonly extensions: readonly ["cdbcmsg"];
    };
    readonly "application/vnd.coreos.ignition+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.cosmocaller": {
        readonly source: "iana";
        readonly extensions: readonly ["cmc"];
    };
    readonly "application/vnd.crick.clicker": {
        readonly source: "iana";
        readonly extensions: readonly ["clkx"];
    };
    readonly "application/vnd.crick.clicker.keyboard": {
        readonly source: "iana";
        readonly extensions: readonly ["clkk"];
    };
    readonly "application/vnd.crick.clicker.palette": {
        readonly source: "iana";
        readonly extensions: readonly ["clkp"];
    };
    readonly "application/vnd.crick.clicker.template": {
        readonly source: "iana";
        readonly extensions: readonly ["clkt"];
    };
    readonly "application/vnd.crick.clicker.wordbank": {
        readonly source: "iana";
        readonly extensions: readonly ["clkw"];
    };
    readonly "application/vnd.criticaltools.wbs+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["wbs"];
    };
    readonly "application/vnd.cryptii.pipe+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.crypto-shade-file": {
        readonly source: "iana";
    };
    readonly "application/vnd.cryptomator.encrypted": {
        readonly source: "iana";
    };
    readonly "application/vnd.cryptomator.vault": {
        readonly source: "iana";
    };
    readonly "application/vnd.ctc-posml": {
        readonly source: "iana";
        readonly extensions: readonly ["pml"];
    };
    readonly "application/vnd.ctct.ws+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.cups-pdf": {
        readonly source: "iana";
    };
    readonly "application/vnd.cups-postscript": {
        readonly source: "iana";
    };
    readonly "application/vnd.cups-ppd": {
        readonly source: "iana";
        readonly extensions: readonly ["ppd"];
    };
    readonly "application/vnd.cups-raster": {
        readonly source: "iana";
    };
    readonly "application/vnd.cups-raw": {
        readonly source: "iana";
    };
    readonly "application/vnd.curl": {
        readonly source: "iana";
    };
    readonly "application/vnd.curl.car": {
        readonly source: "apache";
        readonly extensions: readonly ["car"];
    };
    readonly "application/vnd.curl.pcurl": {
        readonly source: "apache";
        readonly extensions: readonly ["pcurl"];
    };
    readonly "application/vnd.cyan.dean.root+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.cybank": {
        readonly source: "iana";
    };
    readonly "application/vnd.cyclonedx+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.cyclonedx+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.d2l.coursepackage1p0+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.d3m-dataset": {
        readonly source: "iana";
    };
    readonly "application/vnd.d3m-problem": {
        readonly source: "iana";
    };
    readonly "application/vnd.dart": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["dart"];
    };
    readonly "application/vnd.data-vision.rdz": {
        readonly source: "iana";
        readonly extensions: readonly ["rdz"];
    };
    readonly "application/vnd.datapackage+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dataresource+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dbf": {
        readonly source: "iana";
        readonly extensions: readonly ["dbf"];
    };
    readonly "application/vnd.debian.binary-package": {
        readonly source: "iana";
    };
    readonly "application/vnd.dece.data": {
        readonly source: "iana";
        readonly extensions: readonly ["uvf", "uvvf", "uvd", "uvvd"];
    };
    readonly "application/vnd.dece.ttml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["uvt", "uvvt"];
    };
    readonly "application/vnd.dece.unspecified": {
        readonly source: "iana";
        readonly extensions: readonly ["uvx", "uvvx"];
    };
    readonly "application/vnd.dece.zip": {
        readonly source: "iana";
        readonly extensions: readonly ["uvz", "uvvz"];
    };
    readonly "application/vnd.denovo.fcselayout-link": {
        readonly source: "iana";
        readonly extensions: readonly ["fe_launch"];
    };
    readonly "application/vnd.desmume.movie": {
        readonly source: "iana";
    };
    readonly "application/vnd.dir-bi.plate-dl-nosuffix": {
        readonly source: "iana";
    };
    readonly "application/vnd.dm.delegation+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dna": {
        readonly source: "iana";
        readonly extensions: readonly ["dna"];
    };
    readonly "application/vnd.document+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dolby.mlp": {
        readonly source: "apache";
        readonly extensions: readonly ["mlp"];
    };
    readonly "application/vnd.dolby.mobile.1": {
        readonly source: "iana";
    };
    readonly "application/vnd.dolby.mobile.2": {
        readonly source: "iana";
    };
    readonly "application/vnd.doremir.scorecloud-binary-document": {
        readonly source: "iana";
    };
    readonly "application/vnd.dpgraph": {
        readonly source: "iana";
        readonly extensions: readonly ["dpg"];
    };
    readonly "application/vnd.dreamfactory": {
        readonly source: "iana";
        readonly extensions: readonly ["dfac"];
    };
    readonly "application/vnd.drive+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ds-keypoint": {
        readonly source: "apache";
        readonly extensions: readonly ["kpxx"];
    };
    readonly "application/vnd.dtg.local": {
        readonly source: "iana";
    };
    readonly "application/vnd.dtg.local.flash": {
        readonly source: "iana";
    };
    readonly "application/vnd.dtg.local.html": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.ait": {
        readonly source: "iana";
        readonly extensions: readonly ["ait"];
    };
    readonly "application/vnd.dvb.dvbisl+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.dvbj": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.esgcontainer": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.ipdcdftnotifaccess": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.ipdcesgaccess": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.ipdcesgaccess2": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.ipdcesgpdd": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.ipdcroaming": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.iptv.alfec-base": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.iptv.alfec-enhancement": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.notif-aggregate-root+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.notif-container+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.notif-generic+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.notif-ia-msglist+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.notif-ia-registration-request+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.notif-ia-registration-response+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.notif-init+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.dvb.pfr": {
        readonly source: "iana";
    };
    readonly "application/vnd.dvb.service": {
        readonly source: "iana";
        readonly extensions: readonly ["svc"];
    };
    readonly "application/vnd.dxr": {
        readonly source: "iana";
    };
    readonly "application/vnd.dynageo": {
        readonly source: "iana";
        readonly extensions: readonly ["geo"];
    };
    readonly "application/vnd.dzr": {
        readonly source: "iana";
    };
    readonly "application/vnd.easykaraoke.cdgdownload": {
        readonly source: "iana";
    };
    readonly "application/vnd.ecdis-update": {
        readonly source: "iana";
    };
    readonly "application/vnd.ecip.rlp": {
        readonly source: "iana";
    };
    readonly "application/vnd.eclipse.ditto+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ecowin.chart": {
        readonly source: "iana";
        readonly extensions: readonly ["mag"];
    };
    readonly "application/vnd.ecowin.filerequest": {
        readonly source: "iana";
    };
    readonly "application/vnd.ecowin.fileupdate": {
        readonly source: "iana";
    };
    readonly "application/vnd.ecowin.series": {
        readonly source: "iana";
    };
    readonly "application/vnd.ecowin.seriesrequest": {
        readonly source: "iana";
    };
    readonly "application/vnd.ecowin.seriesupdate": {
        readonly source: "iana";
    };
    readonly "application/vnd.efi.img": {
        readonly source: "iana";
    };
    readonly "application/vnd.efi.iso": {
        readonly source: "iana";
    };
    readonly "application/vnd.emclient.accessrequest+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.enliven": {
        readonly source: "iana";
        readonly extensions: readonly ["nml"];
    };
    readonly "application/vnd.enphase.envoy": {
        readonly source: "iana";
    };
    readonly "application/vnd.eprints.data+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.epson.esf": {
        readonly source: "iana";
        readonly extensions: readonly ["esf"];
    };
    readonly "application/vnd.epson.msf": {
        readonly source: "iana";
        readonly extensions: readonly ["msf"];
    };
    readonly "application/vnd.epson.quickanime": {
        readonly source: "iana";
        readonly extensions: readonly ["qam"];
    };
    readonly "application/vnd.epson.salt": {
        readonly source: "iana";
        readonly extensions: readonly ["slt"];
    };
    readonly "application/vnd.epson.ssf": {
        readonly source: "iana";
        readonly extensions: readonly ["ssf"];
    };
    readonly "application/vnd.ericsson.quickcall": {
        readonly source: "iana";
    };
    readonly "application/vnd.espass-espass+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.eszigno3+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["es3", "et3"];
    };
    readonly "application/vnd.etsi.aoc+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.asic-e+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.etsi.asic-s+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.etsi.cug+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvcommand+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvdiscovery+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvprofile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvsad-bc+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvsad-cod+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvsad-npvr+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvservice+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvsync+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.iptvueprofile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.mcid+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.mheg5": {
        readonly source: "iana";
    };
    readonly "application/vnd.etsi.overload-control-policy-dataset+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.pstn+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.sci+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.simservs+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.timestamp-token": {
        readonly source: "iana";
    };
    readonly "application/vnd.etsi.tsl+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.etsi.tsl.der": {
        readonly source: "iana";
    };
    readonly "application/vnd.eu.kasparian.car+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.eudora.data": {
        readonly source: "iana";
    };
    readonly "application/vnd.evolv.ecig.profile": {
        readonly source: "iana";
    };
    readonly "application/vnd.evolv.ecig.settings": {
        readonly source: "iana";
    };
    readonly "application/vnd.evolv.ecig.theme": {
        readonly source: "iana";
    };
    readonly "application/vnd.exstream-empower+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.exstream-package": {
        readonly source: "iana";
    };
    readonly "application/vnd.ezpix-album": {
        readonly source: "iana";
        readonly extensions: readonly ["ez2"];
    };
    readonly "application/vnd.ezpix-package": {
        readonly source: "iana";
        readonly extensions: readonly ["ez3"];
    };
    readonly "application/vnd.f-secure.mobile": {
        readonly source: "iana";
    };
    readonly "application/vnd.familysearch.gedcom+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.fastcopy-disk-image": {
        readonly source: "iana";
    };
    readonly "application/vnd.fdf": {
        readonly source: "iana";
        readonly extensions: readonly ["fdf"];
    };
    readonly "application/vnd.fdsn.mseed": {
        readonly source: "iana";
        readonly extensions: readonly ["mseed"];
    };
    readonly "application/vnd.fdsn.seed": {
        readonly source: "iana";
        readonly extensions: readonly ["seed", "dataless"];
    };
    readonly "application/vnd.ffsns": {
        readonly source: "iana";
    };
    readonly "application/vnd.ficlab.flb+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.filmit.zfc": {
        readonly source: "iana";
    };
    readonly "application/vnd.fints": {
        readonly source: "iana";
    };
    readonly "application/vnd.firemonkeys.cloudcell": {
        readonly source: "iana";
    };
    readonly "application/vnd.flographit": {
        readonly source: "iana";
        readonly extensions: readonly ["gph"];
    };
    readonly "application/vnd.fluxtime.clip": {
        readonly source: "iana";
        readonly extensions: readonly ["ftc"];
    };
    readonly "application/vnd.font-fontforge-sfd": {
        readonly source: "iana";
    };
    readonly "application/vnd.framemaker": {
        readonly source: "iana";
        readonly extensions: readonly ["fm", "frame", "maker", "book"];
    };
    readonly "application/vnd.frogans.fnc": {
        readonly source: "iana";
        readonly extensions: readonly ["fnc"];
    };
    readonly "application/vnd.frogans.ltf": {
        readonly source: "iana";
        readonly extensions: readonly ["ltf"];
    };
    readonly "application/vnd.fsc.weblaunch": {
        readonly source: "iana";
        readonly extensions: readonly ["fsc"];
    };
    readonly "application/vnd.fujifilm.fb.docuworks": {
        readonly source: "iana";
    };
    readonly "application/vnd.fujifilm.fb.docuworks.binder": {
        readonly source: "iana";
    };
    readonly "application/vnd.fujifilm.fb.docuworks.container": {
        readonly source: "iana";
    };
    readonly "application/vnd.fujifilm.fb.jfi+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.fujitsu.oasys": {
        readonly source: "iana";
        readonly extensions: readonly ["oas"];
    };
    readonly "application/vnd.fujitsu.oasys2": {
        readonly source: "iana";
        readonly extensions: readonly ["oa2"];
    };
    readonly "application/vnd.fujitsu.oasys3": {
        readonly source: "iana";
        readonly extensions: readonly ["oa3"];
    };
    readonly "application/vnd.fujitsu.oasysgp": {
        readonly source: "iana";
        readonly extensions: readonly ["fg5"];
    };
    readonly "application/vnd.fujitsu.oasysprs": {
        readonly source: "iana";
        readonly extensions: readonly ["bh2"];
    };
    readonly "application/vnd.fujixerox.art-ex": {
        readonly source: "iana";
    };
    readonly "application/vnd.fujixerox.art4": {
        readonly source: "iana";
    };
    readonly "application/vnd.fujixerox.ddd": {
        readonly source: "iana";
        readonly extensions: readonly ["ddd"];
    };
    readonly "application/vnd.fujixerox.docuworks": {
        readonly source: "iana";
        readonly extensions: readonly ["xdw"];
    };
    readonly "application/vnd.fujixerox.docuworks.binder": {
        readonly source: "iana";
        readonly extensions: readonly ["xbd"];
    };
    readonly "application/vnd.fujixerox.docuworks.container": {
        readonly source: "iana";
    };
    readonly "application/vnd.fujixerox.hbpl": {
        readonly source: "iana";
    };
    readonly "application/vnd.fut-misnet": {
        readonly source: "iana";
    };
    readonly "application/vnd.futoin+cbor": {
        readonly source: "iana";
    };
    readonly "application/vnd.futoin+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.fuzzysheet": {
        readonly source: "iana";
        readonly extensions: readonly ["fzs"];
    };
    readonly "application/vnd.genomatix.tuxedo": {
        readonly source: "iana";
        readonly extensions: readonly ["txd"];
    };
    readonly "application/vnd.gentics.grd+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.geo+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.geocube+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.geogebra.file": {
        readonly source: "iana";
        readonly extensions: readonly ["ggb"];
    };
    readonly "application/vnd.geogebra.slides": {
        readonly source: "iana";
    };
    readonly "application/vnd.geogebra.tool": {
        readonly source: "iana";
        readonly extensions: readonly ["ggt"];
    };
    readonly "application/vnd.geometry-explorer": {
        readonly source: "iana";
        readonly extensions: readonly ["gex", "gre"];
    };
    readonly "application/vnd.geonext": {
        readonly source: "iana";
        readonly extensions: readonly ["gxt"];
    };
    readonly "application/vnd.geoplan": {
        readonly source: "iana";
        readonly extensions: readonly ["g2w"];
    };
    readonly "application/vnd.geospace": {
        readonly source: "iana";
        readonly extensions: readonly ["g3w"];
    };
    readonly "application/vnd.gerber": {
        readonly source: "iana";
    };
    readonly "application/vnd.globalplatform.card-content-mgt": {
        readonly source: "iana";
    };
    readonly "application/vnd.globalplatform.card-content-mgt-response": {
        readonly source: "iana";
    };
    readonly "application/vnd.gmx": {
        readonly source: "iana";
        readonly extensions: readonly ["gmx"];
    };
    readonly "application/vnd.google-apps.document": {
        readonly compressible: false;
        readonly extensions: readonly ["gdoc"];
    };
    readonly "application/vnd.google-apps.presentation": {
        readonly compressible: false;
        readonly extensions: readonly ["gslides"];
    };
    readonly "application/vnd.google-apps.spreadsheet": {
        readonly compressible: false;
        readonly extensions: readonly ["gsheet"];
    };
    readonly "application/vnd.google-earth.kml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["kml"];
    };
    readonly "application/vnd.google-earth.kmz": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["kmz"];
    };
    readonly "application/vnd.gov.sk.e-form+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.gov.sk.e-form+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.gov.sk.xmldatacontainer+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.grafeq": {
        readonly source: "iana";
        readonly extensions: readonly ["gqf", "gqs"];
    };
    readonly "application/vnd.gridmp": {
        readonly source: "iana";
    };
    readonly "application/vnd.groove-account": {
        readonly source: "iana";
        readonly extensions: readonly ["gac"];
    };
    readonly "application/vnd.groove-help": {
        readonly source: "iana";
        readonly extensions: readonly ["ghf"];
    };
    readonly "application/vnd.groove-identity-message": {
        readonly source: "iana";
        readonly extensions: readonly ["gim"];
    };
    readonly "application/vnd.groove-injector": {
        readonly source: "iana";
        readonly extensions: readonly ["grv"];
    };
    readonly "application/vnd.groove-tool-message": {
        readonly source: "iana";
        readonly extensions: readonly ["gtm"];
    };
    readonly "application/vnd.groove-tool-template": {
        readonly source: "iana";
        readonly extensions: readonly ["tpl"];
    };
    readonly "application/vnd.groove-vcard": {
        readonly source: "iana";
        readonly extensions: readonly ["vcg"];
    };
    readonly "application/vnd.hal+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.hal+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["hal"];
    };
    readonly "application/vnd.handheld-entertainment+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["zmm"];
    };
    readonly "application/vnd.hbci": {
        readonly source: "iana";
        readonly extensions: readonly ["hbci"];
    };
    readonly "application/vnd.hc+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.hcl-bireports": {
        readonly source: "iana";
    };
    readonly "application/vnd.hdt": {
        readonly source: "iana";
    };
    readonly "application/vnd.heroku+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.hhe.lesson-player": {
        readonly source: "iana";
        readonly extensions: readonly ["les"];
    };
    readonly "application/vnd.hl7cda+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/vnd.hl7v2+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/vnd.hp-hpgl": {
        readonly source: "iana";
        readonly extensions: readonly ["hpgl"];
    };
    readonly "application/vnd.hp-hpid": {
        readonly source: "iana";
        readonly extensions: readonly ["hpid"];
    };
    readonly "application/vnd.hp-hps": {
        readonly source: "iana";
        readonly extensions: readonly ["hps"];
    };
    readonly "application/vnd.hp-jlyt": {
        readonly source: "iana";
        readonly extensions: readonly ["jlt"];
    };
    readonly "application/vnd.hp-pcl": {
        readonly source: "iana";
        readonly extensions: readonly ["pcl"];
    };
    readonly "application/vnd.hp-pclxl": {
        readonly source: "iana";
        readonly extensions: readonly ["pclxl"];
    };
    readonly "application/vnd.httphone": {
        readonly source: "iana";
    };
    readonly "application/vnd.hydrostatix.sof-data": {
        readonly source: "iana";
        readonly extensions: readonly ["sfd-hdstx"];
    };
    readonly "application/vnd.hyper+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.hyper-item+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.hyperdrive+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.hzn-3d-crossword": {
        readonly source: "iana";
    };
    readonly "application/vnd.ibm.afplinedata": {
        readonly source: "iana";
    };
    readonly "application/vnd.ibm.electronic-media": {
        readonly source: "iana";
    };
    readonly "application/vnd.ibm.minipay": {
        readonly source: "iana";
        readonly extensions: readonly ["mpy"];
    };
    readonly "application/vnd.ibm.modcap": {
        readonly source: "iana";
        readonly extensions: readonly ["afp", "listafp", "list3820"];
    };
    readonly "application/vnd.ibm.rights-management": {
        readonly source: "iana";
        readonly extensions: readonly ["irm"];
    };
    readonly "application/vnd.ibm.secure-container": {
        readonly source: "iana";
        readonly extensions: readonly ["sc"];
    };
    readonly "application/vnd.iccprofile": {
        readonly source: "iana";
        readonly extensions: readonly ["icc", "icm"];
    };
    readonly "application/vnd.ieee.1905": {
        readonly source: "iana";
    };
    readonly "application/vnd.igloader": {
        readonly source: "iana";
        readonly extensions: readonly ["igl"];
    };
    readonly "application/vnd.imagemeter.folder+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.imagemeter.image+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.immervision-ivp": {
        readonly source: "iana";
        readonly extensions: readonly ["ivp"];
    };
    readonly "application/vnd.immervision-ivu": {
        readonly source: "iana";
        readonly extensions: readonly ["ivu"];
    };
    readonly "application/vnd.ims.imsccv1p1": {
        readonly source: "iana";
    };
    readonly "application/vnd.ims.imsccv1p2": {
        readonly source: "iana";
    };
    readonly "application/vnd.ims.imsccv1p3": {
        readonly source: "iana";
    };
    readonly "application/vnd.ims.lis.v2.result+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ims.lti.v2.toolconsumerprofile+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ims.lti.v2.toolproxy+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ims.lti.v2.toolproxy.id+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ims.lti.v2.toolsettings+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ims.lti.v2.toolsettings.simple+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.informedcontrol.rms+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.informix-visionary": {
        readonly source: "iana";
    };
    readonly "application/vnd.infotech.project": {
        readonly source: "iana";
    };
    readonly "application/vnd.infotech.project+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.innopath.wamp.notification": {
        readonly source: "iana";
    };
    readonly "application/vnd.insors.igm": {
        readonly source: "iana";
        readonly extensions: readonly ["igm"];
    };
    readonly "application/vnd.intercon.formnet": {
        readonly source: "iana";
        readonly extensions: readonly ["xpw", "xpx"];
    };
    readonly "application/vnd.intergeo": {
        readonly source: "iana";
        readonly extensions: readonly ["i2g"];
    };
    readonly "application/vnd.intertrust.digibox": {
        readonly source: "iana";
    };
    readonly "application/vnd.intertrust.nncp": {
        readonly source: "iana";
    };
    readonly "application/vnd.intu.qbo": {
        readonly source: "iana";
        readonly extensions: readonly ["qbo"];
    };
    readonly "application/vnd.intu.qfx": {
        readonly source: "iana";
        readonly extensions: readonly ["qfx"];
    };
    readonly "application/vnd.iptc.g2.catalogitem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.iptc.g2.conceptitem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.iptc.g2.knowledgeitem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.iptc.g2.newsitem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.iptc.g2.newsmessage+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.iptc.g2.packageitem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.iptc.g2.planningitem+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ipunplugged.rcprofile": {
        readonly source: "iana";
        readonly extensions: readonly ["rcprofile"];
    };
    readonly "application/vnd.irepository.package+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["irp"];
    };
    readonly "application/vnd.is-xpr": {
        readonly source: "iana";
        readonly extensions: readonly ["xpr"];
    };
    readonly "application/vnd.isac.fcs": {
        readonly source: "iana";
        readonly extensions: readonly ["fcs"];
    };
    readonly "application/vnd.iso11783-10+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.jam": {
        readonly source: "iana";
        readonly extensions: readonly ["jam"];
    };
    readonly "application/vnd.japannet-directory-service": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-jpnstore-wakeup": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-payment-wakeup": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-registration": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-registration-wakeup": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-setstore-wakeup": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-verification": {
        readonly source: "iana";
    };
    readonly "application/vnd.japannet-verification-wakeup": {
        readonly source: "iana";
    };
    readonly "application/vnd.jcp.javame.midlet-rms": {
        readonly source: "iana";
        readonly extensions: readonly ["rms"];
    };
    readonly "application/vnd.jisp": {
        readonly source: "iana";
        readonly extensions: readonly ["jisp"];
    };
    readonly "application/vnd.joost.joda-archive": {
        readonly source: "iana";
        readonly extensions: readonly ["joda"];
    };
    readonly "application/vnd.jsk.isdn-ngn": {
        readonly source: "iana";
    };
    readonly "application/vnd.kahootz": {
        readonly source: "iana";
        readonly extensions: readonly ["ktz", "ktr"];
    };
    readonly "application/vnd.kde.karbon": {
        readonly source: "iana";
        readonly extensions: readonly ["karbon"];
    };
    readonly "application/vnd.kde.kchart": {
        readonly source: "iana";
        readonly extensions: readonly ["chrt"];
    };
    readonly "application/vnd.kde.kformula": {
        readonly source: "iana";
        readonly extensions: readonly ["kfo"];
    };
    readonly "application/vnd.kde.kivio": {
        readonly source: "iana";
        readonly extensions: readonly ["flw"];
    };
    readonly "application/vnd.kde.kontour": {
        readonly source: "iana";
        readonly extensions: readonly ["kon"];
    };
    readonly "application/vnd.kde.kpresenter": {
        readonly source: "iana";
        readonly extensions: readonly ["kpr", "kpt"];
    };
    readonly "application/vnd.kde.kspread": {
        readonly source: "iana";
        readonly extensions: readonly ["ksp"];
    };
    readonly "application/vnd.kde.kword": {
        readonly source: "iana";
        readonly extensions: readonly ["kwd", "kwt"];
    };
    readonly "application/vnd.kenameaapp": {
        readonly source: "iana";
        readonly extensions: readonly ["htke"];
    };
    readonly "application/vnd.kidspiration": {
        readonly source: "iana";
        readonly extensions: readonly ["kia"];
    };
    readonly "application/vnd.kinar": {
        readonly source: "iana";
        readonly extensions: readonly ["kne", "knp"];
    };
    readonly "application/vnd.koan": {
        readonly source: "iana";
        readonly extensions: readonly ["skp", "skd", "skt", "skm"];
    };
    readonly "application/vnd.kodak-descriptor": {
        readonly source: "iana";
        readonly extensions: readonly ["sse"];
    };
    readonly "application/vnd.las": {
        readonly source: "iana";
    };
    readonly "application/vnd.las.las+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.las.las+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["lasxml"];
    };
    readonly "application/vnd.laszip": {
        readonly source: "iana";
    };
    readonly "application/vnd.leap+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.liberty-request+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.llamagraphics.life-balance.desktop": {
        readonly source: "iana";
        readonly extensions: readonly ["lbd"];
    };
    readonly "application/vnd.llamagraphics.life-balance.exchange+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["lbe"];
    };
    readonly "application/vnd.logipipe.circuit+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.loom": {
        readonly source: "iana";
    };
    readonly "application/vnd.lotus-1-2-3": {
        readonly source: "iana";
        readonly extensions: readonly ["123"];
    };
    readonly "application/vnd.lotus-approach": {
        readonly source: "iana";
        readonly extensions: readonly ["apr"];
    };
    readonly "application/vnd.lotus-freelance": {
        readonly source: "iana";
        readonly extensions: readonly ["pre"];
    };
    readonly "application/vnd.lotus-notes": {
        readonly source: "iana";
        readonly extensions: readonly ["nsf"];
    };
    readonly "application/vnd.lotus-organizer": {
        readonly source: "iana";
        readonly extensions: readonly ["org"];
    };
    readonly "application/vnd.lotus-screencam": {
        readonly source: "iana";
        readonly extensions: readonly ["scm"];
    };
    readonly "application/vnd.lotus-wordpro": {
        readonly source: "iana";
        readonly extensions: readonly ["lwp"];
    };
    readonly "application/vnd.macports.portpkg": {
        readonly source: "iana";
        readonly extensions: readonly ["portpkg"];
    };
    readonly "application/vnd.mapbox-vector-tile": {
        readonly source: "iana";
        readonly extensions: readonly ["mvt"];
    };
    readonly "application/vnd.marlin.drm.actiontoken+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.marlin.drm.conftoken+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.marlin.drm.license+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.marlin.drm.mdcf": {
        readonly source: "iana";
    };
    readonly "application/vnd.mason+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.maxar.archive.3tz+zip": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "application/vnd.maxmind.maxmind-db": {
        readonly source: "iana";
    };
    readonly "application/vnd.mcd": {
        readonly source: "iana";
        readonly extensions: readonly ["mcd"];
    };
    readonly "application/vnd.medcalcdata": {
        readonly source: "iana";
        readonly extensions: readonly ["mc1"];
    };
    readonly "application/vnd.mediastation.cdkey": {
        readonly source: "iana";
        readonly extensions: readonly ["cdkey"];
    };
    readonly "application/vnd.meridian-slingshot": {
        readonly source: "iana";
    };
    readonly "application/vnd.mfer": {
        readonly source: "iana";
        readonly extensions: readonly ["mwf"];
    };
    readonly "application/vnd.mfmp": {
        readonly source: "iana";
        readonly extensions: readonly ["mfm"];
    };
    readonly "application/vnd.micro+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.micrografx.flo": {
        readonly source: "iana";
        readonly extensions: readonly ["flo"];
    };
    readonly "application/vnd.micrografx.igx": {
        readonly source: "iana";
        readonly extensions: readonly ["igx"];
    };
    readonly "application/vnd.microsoft.portable-executable": {
        readonly source: "iana";
    };
    readonly "application/vnd.microsoft.windows.thumbnail-cache": {
        readonly source: "iana";
    };
    readonly "application/vnd.miele+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.mif": {
        readonly source: "iana";
        readonly extensions: readonly ["mif"];
    };
    readonly "application/vnd.minisoft-hp3000-save": {
        readonly source: "iana";
    };
    readonly "application/vnd.mitsubishi.misty-guard.trustweb": {
        readonly source: "iana";
    };
    readonly "application/vnd.mobius.daf": {
        readonly source: "iana";
        readonly extensions: readonly ["daf"];
    };
    readonly "application/vnd.mobius.dis": {
        readonly source: "iana";
        readonly extensions: readonly ["dis"];
    };
    readonly "application/vnd.mobius.mbk": {
        readonly source: "iana";
        readonly extensions: readonly ["mbk"];
    };
    readonly "application/vnd.mobius.mqy": {
        readonly source: "iana";
        readonly extensions: readonly ["mqy"];
    };
    readonly "application/vnd.mobius.msl": {
        readonly source: "iana";
        readonly extensions: readonly ["msl"];
    };
    readonly "application/vnd.mobius.plc": {
        readonly source: "iana";
        readonly extensions: readonly ["plc"];
    };
    readonly "application/vnd.mobius.txf": {
        readonly source: "iana";
        readonly extensions: readonly ["txf"];
    };
    readonly "application/vnd.mophun.application": {
        readonly source: "iana";
        readonly extensions: readonly ["mpn"];
    };
    readonly "application/vnd.mophun.certificate": {
        readonly source: "iana";
        readonly extensions: readonly ["mpc"];
    };
    readonly "application/vnd.motorola.flexsuite": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.flexsuite.adsi": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.flexsuite.fis": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.flexsuite.gotap": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.flexsuite.kmr": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.flexsuite.ttc": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.flexsuite.wem": {
        readonly source: "iana";
    };
    readonly "application/vnd.motorola.iprm": {
        readonly source: "iana";
    };
    readonly "application/vnd.mozilla.xul+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xul"];
    };
    readonly "application/vnd.ms-3mfdocument": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-artgalry": {
        readonly source: "iana";
        readonly extensions: readonly ["cil"];
    };
    readonly "application/vnd.ms-asf": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-cab-compressed": {
        readonly source: "iana";
        readonly extensions: readonly ["cab"];
    };
    readonly "application/vnd.ms-color.iccprofile": {
        readonly source: "apache";
    };
    readonly "application/vnd.ms-excel": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["xls", "xlm", "xla", "xlc", "xlt", "xlw"];
    };
    readonly "application/vnd.ms-excel.addin.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["xlam"];
    };
    readonly "application/vnd.ms-excel.sheet.binary.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["xlsb"];
    };
    readonly "application/vnd.ms-excel.sheet.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["xlsm"];
    };
    readonly "application/vnd.ms-excel.template.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["xltm"];
    };
    readonly "application/vnd.ms-fontobject": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["eot"];
    };
    readonly "application/vnd.ms-htmlhelp": {
        readonly source: "iana";
        readonly extensions: readonly ["chm"];
    };
    readonly "application/vnd.ms-ims": {
        readonly source: "iana";
        readonly extensions: readonly ["ims"];
    };
    readonly "application/vnd.ms-lrm": {
        readonly source: "iana";
        readonly extensions: readonly ["lrm"];
    };
    readonly "application/vnd.ms-office.activex+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ms-officetheme": {
        readonly source: "iana";
        readonly extensions: readonly ["thmx"];
    };
    readonly "application/vnd.ms-opentype": {
        readonly source: "apache";
        readonly compressible: true;
    };
    readonly "application/vnd.ms-outlook": {
        readonly compressible: false;
        readonly extensions: readonly ["msg"];
    };
    readonly "application/vnd.ms-package.obfuscated-opentype": {
        readonly source: "apache";
    };
    readonly "application/vnd.ms-pki.seccat": {
        readonly source: "apache";
        readonly extensions: readonly ["cat"];
    };
    readonly "application/vnd.ms-pki.stl": {
        readonly source: "apache";
        readonly extensions: readonly ["stl"];
    };
    readonly "application/vnd.ms-playready.initiator+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ms-powerpoint": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["ppt", "pps", "pot"];
    };
    readonly "application/vnd.ms-powerpoint.addin.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["ppam"];
    };
    readonly "application/vnd.ms-powerpoint.presentation.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["pptm"];
    };
    readonly "application/vnd.ms-powerpoint.slide.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["sldm"];
    };
    readonly "application/vnd.ms-powerpoint.slideshow.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["ppsm"];
    };
    readonly "application/vnd.ms-powerpoint.template.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["potm"];
    };
    readonly "application/vnd.ms-printdevicecapabilities+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ms-printing.printticket+xml": {
        readonly source: "apache";
        readonly compressible: true;
    };
    readonly "application/vnd.ms-printschematicket+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ms-project": {
        readonly source: "iana";
        readonly extensions: readonly ["mpp", "mpt"];
    };
    readonly "application/vnd.ms-tnef": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-windows.devicepairing": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-windows.nwprinting.oob": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-windows.printerpairing": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-windows.wsd.oob": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-wmdrm.lic-chlg-req": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-wmdrm.lic-resp": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-wmdrm.meter-chlg-req": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-wmdrm.meter-resp": {
        readonly source: "iana";
    };
    readonly "application/vnd.ms-word.document.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["docm"];
    };
    readonly "application/vnd.ms-word.template.macroenabled.12": {
        readonly source: "iana";
        readonly extensions: readonly ["dotm"];
    };
    readonly "application/vnd.ms-works": {
        readonly source: "iana";
        readonly extensions: readonly ["wps", "wks", "wcm", "wdb"];
    };
    readonly "application/vnd.ms-wpl": {
        readonly source: "iana";
        readonly extensions: readonly ["wpl"];
    };
    readonly "application/vnd.ms-xpsdocument": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["xps"];
    };
    readonly "application/vnd.msa-disk-image": {
        readonly source: "iana";
    };
    readonly "application/vnd.mseq": {
        readonly source: "iana";
        readonly extensions: readonly ["mseq"];
    };
    readonly "application/vnd.msign": {
        readonly source: "iana";
    };
    readonly "application/vnd.multiad.creator": {
        readonly source: "iana";
    };
    readonly "application/vnd.multiad.creator.cif": {
        readonly source: "iana";
    };
    readonly "application/vnd.music-niff": {
        readonly source: "iana";
    };
    readonly "application/vnd.musician": {
        readonly source: "iana";
        readonly extensions: readonly ["mus"];
    };
    readonly "application/vnd.muvee.style": {
        readonly source: "iana";
        readonly extensions: readonly ["msty"];
    };
    readonly "application/vnd.mynfc": {
        readonly source: "iana";
        readonly extensions: readonly ["taglet"];
    };
    readonly "application/vnd.nacamar.ybrid+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.ncd.control": {
        readonly source: "iana";
    };
    readonly "application/vnd.ncd.reference": {
        readonly source: "iana";
    };
    readonly "application/vnd.nearst.inv+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.nebumind.line": {
        readonly source: "iana";
    };
    readonly "application/vnd.nervana": {
        readonly source: "iana";
    };
    readonly "application/vnd.netfpx": {
        readonly source: "iana";
    };
    readonly "application/vnd.neurolanguage.nlu": {
        readonly source: "iana";
        readonly extensions: readonly ["nlu"];
    };
    readonly "application/vnd.nimn": {
        readonly source: "iana";
    };
    readonly "application/vnd.nintendo.nitro.rom": {
        readonly source: "iana";
    };
    readonly "application/vnd.nintendo.snes.rom": {
        readonly source: "iana";
    };
    readonly "application/vnd.nitf": {
        readonly source: "iana";
        readonly extensions: readonly ["ntf", "nitf"];
    };
    readonly "application/vnd.noblenet-directory": {
        readonly source: "iana";
        readonly extensions: readonly ["nnd"];
    };
    readonly "application/vnd.noblenet-sealer": {
        readonly source: "iana";
        readonly extensions: readonly ["nns"];
    };
    readonly "application/vnd.noblenet-web": {
        readonly source: "iana";
        readonly extensions: readonly ["nnw"];
    };
    readonly "application/vnd.nokia.catalogs": {
        readonly source: "iana";
    };
    readonly "application/vnd.nokia.conml+wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.nokia.conml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.nokia.iptv.config+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.nokia.isds-radio-presets": {
        readonly source: "iana";
    };
    readonly "application/vnd.nokia.landmark+wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.nokia.landmark+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.nokia.landmarkcollection+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.nokia.n-gage.ac+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ac"];
    };
    readonly "application/vnd.nokia.n-gage.data": {
        readonly source: "iana";
        readonly extensions: readonly ["ngdat"];
    };
    readonly "application/vnd.nokia.n-gage.symbian.install": {
        readonly source: "iana";
        readonly extensions: readonly ["n-gage"];
    };
    readonly "application/vnd.nokia.ncd": {
        readonly source: "iana";
    };
    readonly "application/vnd.nokia.pcd+wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.nokia.pcd+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.nokia.radio-preset": {
        readonly source: "iana";
        readonly extensions: readonly ["rpst"];
    };
    readonly "application/vnd.nokia.radio-presets": {
        readonly source: "iana";
        readonly extensions: readonly ["rpss"];
    };
    readonly "application/vnd.novadigm.edm": {
        readonly source: "iana";
        readonly extensions: readonly ["edm"];
    };
    readonly "application/vnd.novadigm.edx": {
        readonly source: "iana";
        readonly extensions: readonly ["edx"];
    };
    readonly "application/vnd.novadigm.ext": {
        readonly source: "iana";
        readonly extensions: readonly ["ext"];
    };
    readonly "application/vnd.ntt-local.content-share": {
        readonly source: "iana";
    };
    readonly "application/vnd.ntt-local.file-transfer": {
        readonly source: "iana";
    };
    readonly "application/vnd.ntt-local.ogw_remote-access": {
        readonly source: "iana";
    };
    readonly "application/vnd.ntt-local.sip-ta_remote": {
        readonly source: "iana";
    };
    readonly "application/vnd.ntt-local.sip-ta_tcp_stream": {
        readonly source: "iana";
    };
    readonly "application/vnd.oasis.opendocument.chart": {
        readonly source: "iana";
        readonly extensions: readonly ["odc"];
    };
    readonly "application/vnd.oasis.opendocument.chart-template": {
        readonly source: "iana";
        readonly extensions: readonly ["otc"];
    };
    readonly "application/vnd.oasis.opendocument.database": {
        readonly source: "iana";
        readonly extensions: readonly ["odb"];
    };
    readonly "application/vnd.oasis.opendocument.formula": {
        readonly source: "iana";
        readonly extensions: readonly ["odf"];
    };
    readonly "application/vnd.oasis.opendocument.formula-template": {
        readonly source: "iana";
        readonly extensions: readonly ["odft"];
    };
    readonly "application/vnd.oasis.opendocument.graphics": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["odg"];
    };
    readonly "application/vnd.oasis.opendocument.graphics-template": {
        readonly source: "iana";
        readonly extensions: readonly ["otg"];
    };
    readonly "application/vnd.oasis.opendocument.image": {
        readonly source: "iana";
        readonly extensions: readonly ["odi"];
    };
    readonly "application/vnd.oasis.opendocument.image-template": {
        readonly source: "iana";
        readonly extensions: readonly ["oti"];
    };
    readonly "application/vnd.oasis.opendocument.presentation": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["odp"];
    };
    readonly "application/vnd.oasis.opendocument.presentation-template": {
        readonly source: "iana";
        readonly extensions: readonly ["otp"];
    };
    readonly "application/vnd.oasis.opendocument.spreadsheet": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["ods"];
    };
    readonly "application/vnd.oasis.opendocument.spreadsheet-template": {
        readonly source: "iana";
        readonly extensions: readonly ["ots"];
    };
    readonly "application/vnd.oasis.opendocument.text": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["odt"];
    };
    readonly "application/vnd.oasis.opendocument.text-master": {
        readonly source: "iana";
        readonly extensions: readonly ["odm"];
    };
    readonly "application/vnd.oasis.opendocument.text-template": {
        readonly source: "iana";
        readonly extensions: readonly ["ott"];
    };
    readonly "application/vnd.oasis.opendocument.text-web": {
        readonly source: "iana";
        readonly extensions: readonly ["oth"];
    };
    readonly "application/vnd.obn": {
        readonly source: "iana";
    };
    readonly "application/vnd.ocf+cbor": {
        readonly source: "iana";
    };
    readonly "application/vnd.oci.image.manifest.v1+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oftn.l10n+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.contentaccessdownload+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.contentaccessstreaming+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.cspg-hexbinary": {
        readonly source: "iana";
    };
    readonly "application/vnd.oipf.dae.svg+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.dae.xhtml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.mippvcontrolmessage+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.pae.gem": {
        readonly source: "iana";
    };
    readonly "application/vnd.oipf.spdiscovery+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.spdlist+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.ueprofile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oipf.userprofile+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.olpc-sugar": {
        readonly source: "iana";
        readonly extensions: readonly ["xo"];
    };
    readonly "application/vnd.oma-scws-config": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma-scws-http-request": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma-scws-http-response": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.bcast.associated-procedure-parameter+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.drm-trigger+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.imd+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.ltkm": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.bcast.notification+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.provisioningtrigger": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.bcast.sgboot": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.bcast.sgdd+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.sgdu": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.bcast.simple-symbol-container": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.bcast.smartcard-trigger+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.sprov+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.bcast.stkm": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.cab-address-book+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.cab-feature-handler+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.cab-pcc+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.cab-subs-invite+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.cab-user-prefs+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.dcd": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.dcdc": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.dd2+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["dd2"];
    };
    readonly "application/vnd.oma.drm.risd+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.group-usage-list+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.lwm2m+cbor": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.lwm2m+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.lwm2m+tlv": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.pal+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.poc.detailed-progress-report+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.poc.final-report+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.poc.groups+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.poc.invocation-descriptor+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.poc.optimized-progress-report+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.push": {
        readonly source: "iana";
    };
    readonly "application/vnd.oma.scidm.messages+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oma.xcap-directory+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.omads-email+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/vnd.omads-file+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/vnd.omads-folder+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/vnd.omaloc-supl-init": {
        readonly source: "iana";
    };
    readonly "application/vnd.onepager": {
        readonly source: "iana";
    };
    readonly "application/vnd.onepagertamp": {
        readonly source: "iana";
    };
    readonly "application/vnd.onepagertamx": {
        readonly source: "iana";
    };
    readonly "application/vnd.onepagertat": {
        readonly source: "iana";
    };
    readonly "application/vnd.onepagertatp": {
        readonly source: "iana";
    };
    readonly "application/vnd.onepagertatx": {
        readonly source: "iana";
    };
    readonly "application/vnd.openblox.game+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["obgx"];
    };
    readonly "application/vnd.openblox.game-binary": {
        readonly source: "iana";
    };
    readonly "application/vnd.openeye.oeb": {
        readonly source: "iana";
    };
    readonly "application/vnd.openofficeorg.extension": {
        readonly source: "apache";
        readonly extensions: readonly ["oxt"];
    };
    readonly "application/vnd.openstreetmap.data+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["osm"];
    };
    readonly "application/vnd.opentimestamps.ots": {
        readonly source: "iana";
    };
    readonly "application/vnd.openxmlformats-officedocument.custom-properties+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.customxmlproperties+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawing+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawingml.chart+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawingml.chartshapes+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawingml.diagramcolors+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawingml.diagramdata+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawingml.diagramlayout+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.drawingml.diagramstyle+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.extended-properties+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.commentauthors+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.comments+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.handoutmaster+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.notesmaster+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.notesslide+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.presentation": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["pptx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.presentation.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.presprops+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slide": {
        readonly source: "iana";
        readonly extensions: readonly ["sldx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slide+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slidelayout+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slidemaster+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slideshow": {
        readonly source: "iana";
        readonly extensions: readonly ["ppsx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slideshow.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.slideupdateinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.tablestyles+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.tags+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.template": {
        readonly source: "iana";
        readonly extensions: readonly ["potx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.template.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.presentationml.viewprops+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.calcchain+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.chartsheet+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.comments+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.connections+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.dialogsheet+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.externallink+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotcachedefinition+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.pivotcacherecords+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.pivottable+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.querytable+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionheaders+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.revisionlog+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.sharedstrings+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["xlsx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.sheetmetadata+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.styles+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.table+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.tablesinglecells+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.template": {
        readonly source: "iana";
        readonly extensions: readonly ["xltx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.template.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.usernames+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.volatiledependencies+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.spreadsheetml.worksheet+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.theme+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.themeoverride+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.vmldrawing": {
        readonly source: "iana";
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.comments+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.document": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["docx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.document.glossary+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.endnotes+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.fonttable+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.footer+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.footnotes+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.numbering+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.template": {
        readonly source: "iana";
        readonly extensions: readonly ["dotx"];
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.template.main+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-officedocument.wordprocessingml.websettings+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-package.core-properties+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-package.digital-signature-xmlsignature+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.openxmlformats-package.relationships+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oracle.resource+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.orange.indata": {
        readonly source: "iana";
    };
    readonly "application/vnd.osa.netdeploy": {
        readonly source: "iana";
    };
    readonly "application/vnd.osgeo.mapguide.package": {
        readonly source: "iana";
        readonly extensions: readonly ["mgp"];
    };
    readonly "application/vnd.osgi.bundle": {
        readonly source: "iana";
    };
    readonly "application/vnd.osgi.dp": {
        readonly source: "iana";
        readonly extensions: readonly ["dp"];
    };
    readonly "application/vnd.osgi.subsystem": {
        readonly source: "iana";
        readonly extensions: readonly ["esa"];
    };
    readonly "application/vnd.otps.ct-kip+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.oxli.countgraph": {
        readonly source: "iana";
    };
    readonly "application/vnd.pagerduty+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.palm": {
        readonly source: "iana";
        readonly extensions: readonly ["pdb", "pqa", "oprc"];
    };
    readonly "application/vnd.panoply": {
        readonly source: "iana";
    };
    readonly "application/vnd.paos.xml": {
        readonly source: "iana";
    };
    readonly "application/vnd.patentdive": {
        readonly source: "iana";
    };
    readonly "application/vnd.patientecommsdoc": {
        readonly source: "iana";
    };
    readonly "application/vnd.pawaafile": {
        readonly source: "iana";
        readonly extensions: readonly ["paw"];
    };
    readonly "application/vnd.pcos": {
        readonly source: "iana";
    };
    readonly "application/vnd.pg.format": {
        readonly source: "iana";
        readonly extensions: readonly ["str"];
    };
    readonly "application/vnd.pg.osasli": {
        readonly source: "iana";
        readonly extensions: readonly ["ei6"];
    };
    readonly "application/vnd.piaccess.application-licence": {
        readonly source: "iana";
    };
    readonly "application/vnd.picsel": {
        readonly source: "iana";
        readonly extensions: readonly ["efif"];
    };
    readonly "application/vnd.pmi.widget": {
        readonly source: "iana";
        readonly extensions: readonly ["wg"];
    };
    readonly "application/vnd.poc.group-advertisement+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.pocketlearn": {
        readonly source: "iana";
        readonly extensions: readonly ["plf"];
    };
    readonly "application/vnd.powerbuilder6": {
        readonly source: "iana";
        readonly extensions: readonly ["pbd"];
    };
    readonly "application/vnd.powerbuilder6-s": {
        readonly source: "iana";
    };
    readonly "application/vnd.powerbuilder7": {
        readonly source: "iana";
    };
    readonly "application/vnd.powerbuilder7-s": {
        readonly source: "iana";
    };
    readonly "application/vnd.powerbuilder75": {
        readonly source: "iana";
    };
    readonly "application/vnd.powerbuilder75-s": {
        readonly source: "iana";
    };
    readonly "application/vnd.preminet": {
        readonly source: "iana";
    };
    readonly "application/vnd.previewsystems.box": {
        readonly source: "iana";
        readonly extensions: readonly ["box"];
    };
    readonly "application/vnd.proteus.magazine": {
        readonly source: "iana";
        readonly extensions: readonly ["mgz"];
    };
    readonly "application/vnd.psfs": {
        readonly source: "iana";
    };
    readonly "application/vnd.publishare-delta-tree": {
        readonly source: "iana";
        readonly extensions: readonly ["qps"];
    };
    readonly "application/vnd.pvi.ptid1": {
        readonly source: "iana";
        readonly extensions: readonly ["ptid"];
    };
    readonly "application/vnd.pwg-multiplexed": {
        readonly source: "iana";
    };
    readonly "application/vnd.pwg-xhtml-print+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.qualcomm.brew-app-res": {
        readonly source: "iana";
    };
    readonly "application/vnd.quarantainenet": {
        readonly source: "iana";
    };
    readonly "application/vnd.quark.quarkxpress": {
        readonly source: "iana";
        readonly extensions: readonly ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"];
    };
    readonly "application/vnd.quobject-quoxdocument": {
        readonly source: "iana";
    };
    readonly "application/vnd.radisys.moml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-audit+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-audit-conf+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-audit-conn+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-audit-dialog+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-audit-stream+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-conf+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog-base+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog-fax-detect+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog-fax-sendrecv+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog-group+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog-speech+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.radisys.msml-dialog-transform+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.rainstor.data": {
        readonly source: "iana";
    };
    readonly "application/vnd.rapid": {
        readonly source: "iana";
    };
    readonly "application/vnd.rar": {
        readonly source: "iana";
        readonly extensions: readonly ["rar"];
    };
    readonly "application/vnd.realvnc.bed": {
        readonly source: "iana";
        readonly extensions: readonly ["bed"];
    };
    readonly "application/vnd.recordare.musicxml": {
        readonly source: "iana";
        readonly extensions: readonly ["mxl"];
    };
    readonly "application/vnd.recordare.musicxml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["musicxml"];
    };
    readonly "application/vnd.renlearn.rlprint": {
        readonly source: "iana";
    };
    readonly "application/vnd.resilient.logic": {
        readonly source: "iana";
    };
    readonly "application/vnd.restful+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.rig.cryptonote": {
        readonly source: "iana";
        readonly extensions: readonly ["cryptonote"];
    };
    readonly "application/vnd.rim.cod": {
        readonly source: "apache";
        readonly extensions: readonly ["cod"];
    };
    readonly "application/vnd.rn-realmedia": {
        readonly source: "apache";
        readonly extensions: readonly ["rm"];
    };
    readonly "application/vnd.rn-realmedia-vbr": {
        readonly source: "apache";
        readonly extensions: readonly ["rmvb"];
    };
    readonly "application/vnd.route66.link66+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["link66"];
    };
    readonly "application/vnd.rs-274x": {
        readonly source: "iana";
    };
    readonly "application/vnd.ruckus.download": {
        readonly source: "iana";
    };
    readonly "application/vnd.s3sms": {
        readonly source: "iana";
    };
    readonly "application/vnd.sailingtracker.track": {
        readonly source: "iana";
        readonly extensions: readonly ["st"];
    };
    readonly "application/vnd.sar": {
        readonly source: "iana";
    };
    readonly "application/vnd.sbm.cid": {
        readonly source: "iana";
    };
    readonly "application/vnd.sbm.mid2": {
        readonly source: "iana";
    };
    readonly "application/vnd.scribus": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.3df": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.csf": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.doc": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.eml": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.mht": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.net": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.ppt": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.tiff": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealed.xls": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealedmedia.softseal.html": {
        readonly source: "iana";
    };
    readonly "application/vnd.sealedmedia.softseal.pdf": {
        readonly source: "iana";
    };
    readonly "application/vnd.seemail": {
        readonly source: "iana";
        readonly extensions: readonly ["see"];
    };
    readonly "application/vnd.seis+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.sema": {
        readonly source: "iana";
        readonly extensions: readonly ["sema"];
    };
    readonly "application/vnd.semd": {
        readonly source: "iana";
        readonly extensions: readonly ["semd"];
    };
    readonly "application/vnd.semf": {
        readonly source: "iana";
        readonly extensions: readonly ["semf"];
    };
    readonly "application/vnd.shade-save-file": {
        readonly source: "iana";
    };
    readonly "application/vnd.shana.informed.formdata": {
        readonly source: "iana";
        readonly extensions: readonly ["ifm"];
    };
    readonly "application/vnd.shana.informed.formtemplate": {
        readonly source: "iana";
        readonly extensions: readonly ["itp"];
    };
    readonly "application/vnd.shana.informed.interchange": {
        readonly source: "iana";
        readonly extensions: readonly ["iif"];
    };
    readonly "application/vnd.shana.informed.package": {
        readonly source: "iana";
        readonly extensions: readonly ["ipk"];
    };
    readonly "application/vnd.shootproof+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.shopkick+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.shp": {
        readonly source: "iana";
    };
    readonly "application/vnd.shx": {
        readonly source: "iana";
    };
    readonly "application/vnd.sigrok.session": {
        readonly source: "iana";
    };
    readonly "application/vnd.simtech-mindmapper": {
        readonly source: "iana";
        readonly extensions: readonly ["twd", "twds"];
    };
    readonly "application/vnd.siren+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.smaf": {
        readonly source: "iana";
        readonly extensions: readonly ["mmf"];
    };
    readonly "application/vnd.smart.notebook": {
        readonly source: "iana";
    };
    readonly "application/vnd.smart.teacher": {
        readonly source: "iana";
        readonly extensions: readonly ["teacher"];
    };
    readonly "application/vnd.snesdev-page-table": {
        readonly source: "iana";
    };
    readonly "application/vnd.software602.filler.form+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["fo"];
    };
    readonly "application/vnd.software602.filler.form-xml-zip": {
        readonly source: "iana";
    };
    readonly "application/vnd.solent.sdkm+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["sdkm", "sdkd"];
    };
    readonly "application/vnd.spotfire.dxp": {
        readonly source: "iana";
        readonly extensions: readonly ["dxp"];
    };
    readonly "application/vnd.spotfire.sfs": {
        readonly source: "iana";
        readonly extensions: readonly ["sfs"];
    };
    readonly "application/vnd.sqlite3": {
        readonly source: "iana";
    };
    readonly "application/vnd.sss-cod": {
        readonly source: "iana";
    };
    readonly "application/vnd.sss-dtf": {
        readonly source: "iana";
    };
    readonly "application/vnd.sss-ntf": {
        readonly source: "iana";
    };
    readonly "application/vnd.stardivision.calc": {
        readonly source: "apache";
        readonly extensions: readonly ["sdc"];
    };
    readonly "application/vnd.stardivision.draw": {
        readonly source: "apache";
        readonly extensions: readonly ["sda"];
    };
    readonly "application/vnd.stardivision.impress": {
        readonly source: "apache";
        readonly extensions: readonly ["sdd"];
    };
    readonly "application/vnd.stardivision.math": {
        readonly source: "apache";
        readonly extensions: readonly ["smf"];
    };
    readonly "application/vnd.stardivision.writer": {
        readonly source: "apache";
        readonly extensions: readonly ["sdw", "vor"];
    };
    readonly "application/vnd.stardivision.writer-global": {
        readonly source: "apache";
        readonly extensions: readonly ["sgl"];
    };
    readonly "application/vnd.stepmania.package": {
        readonly source: "iana";
        readonly extensions: readonly ["smzip"];
    };
    readonly "application/vnd.stepmania.stepchart": {
        readonly source: "iana";
        readonly extensions: readonly ["sm"];
    };
    readonly "application/vnd.street-stream": {
        readonly source: "iana";
    };
    readonly "application/vnd.sun.wadl+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["wadl"];
    };
    readonly "application/vnd.sun.xml.calc": {
        readonly source: "apache";
        readonly extensions: readonly ["sxc"];
    };
    readonly "application/vnd.sun.xml.calc.template": {
        readonly source: "apache";
        readonly extensions: readonly ["stc"];
    };
    readonly "application/vnd.sun.xml.draw": {
        readonly source: "apache";
        readonly extensions: readonly ["sxd"];
    };
    readonly "application/vnd.sun.xml.draw.template": {
        readonly source: "apache";
        readonly extensions: readonly ["std"];
    };
    readonly "application/vnd.sun.xml.impress": {
        readonly source: "apache";
        readonly extensions: readonly ["sxi"];
    };
    readonly "application/vnd.sun.xml.impress.template": {
        readonly source: "apache";
        readonly extensions: readonly ["sti"];
    };
    readonly "application/vnd.sun.xml.math": {
        readonly source: "apache";
        readonly extensions: readonly ["sxm"];
    };
    readonly "application/vnd.sun.xml.writer": {
        readonly source: "apache";
        readonly extensions: readonly ["sxw"];
    };
    readonly "application/vnd.sun.xml.writer.global": {
        readonly source: "apache";
        readonly extensions: readonly ["sxg"];
    };
    readonly "application/vnd.sun.xml.writer.template": {
        readonly source: "apache";
        readonly extensions: readonly ["stw"];
    };
    readonly "application/vnd.sus-calendar": {
        readonly source: "iana";
        readonly extensions: readonly ["sus", "susp"];
    };
    readonly "application/vnd.svd": {
        readonly source: "iana";
        readonly extensions: readonly ["svd"];
    };
    readonly "application/vnd.swiftview-ics": {
        readonly source: "iana";
    };
    readonly "application/vnd.sycle+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.syft+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.symbian.install": {
        readonly source: "apache";
        readonly extensions: readonly ["sis", "sisx"];
    };
    readonly "application/vnd.syncml+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["xsm"];
    };
    readonly "application/vnd.syncml.dm+wbxml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly extensions: readonly ["bdm"];
    };
    readonly "application/vnd.syncml.dm+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["xdm"];
    };
    readonly "application/vnd.syncml.dm.notification": {
        readonly source: "iana";
    };
    readonly "application/vnd.syncml.dmddf+wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.syncml.dmddf+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["ddf"];
    };
    readonly "application/vnd.syncml.dmtnds+wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.syncml.dmtnds+xml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
    };
    readonly "application/vnd.syncml.ds.notification": {
        readonly source: "iana";
    };
    readonly "application/vnd.tableschema+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.tao.intent-module-archive": {
        readonly source: "iana";
        readonly extensions: readonly ["tao"];
    };
    readonly "application/vnd.tcpdump.pcap": {
        readonly source: "iana";
        readonly extensions: readonly ["pcap", "cap", "dmp"];
    };
    readonly "application/vnd.think-cell.ppttc+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.tmd.mediaflex.api+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.tml": {
        readonly source: "iana";
    };
    readonly "application/vnd.tmobile-livetv": {
        readonly source: "iana";
        readonly extensions: readonly ["tmo"];
    };
    readonly "application/vnd.tri.onesource": {
        readonly source: "iana";
    };
    readonly "application/vnd.trid.tpt": {
        readonly source: "iana";
        readonly extensions: readonly ["tpt"];
    };
    readonly "application/vnd.triscape.mxs": {
        readonly source: "iana";
        readonly extensions: readonly ["mxs"];
    };
    readonly "application/vnd.trueapp": {
        readonly source: "iana";
        readonly extensions: readonly ["tra"];
    };
    readonly "application/vnd.truedoc": {
        readonly source: "iana";
    };
    readonly "application/vnd.ubisoft.webplayer": {
        readonly source: "iana";
    };
    readonly "application/vnd.ufdl": {
        readonly source: "iana";
        readonly extensions: readonly ["ufd", "ufdl"];
    };
    readonly "application/vnd.uiq.theme": {
        readonly source: "iana";
        readonly extensions: readonly ["utz"];
    };
    readonly "application/vnd.umajin": {
        readonly source: "iana";
        readonly extensions: readonly ["umj"];
    };
    readonly "application/vnd.unity": {
        readonly source: "iana";
        readonly extensions: readonly ["unityweb"];
    };
    readonly "application/vnd.uoml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["uoml"];
    };
    readonly "application/vnd.uplanet.alert": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.alert-wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.bearer-choice": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.bearer-choice-wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.cacheop": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.cacheop-wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.channel": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.channel-wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.list": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.list-wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.listcmd": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.listcmd-wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.uplanet.signal": {
        readonly source: "iana";
    };
    readonly "application/vnd.uri-map": {
        readonly source: "iana";
    };
    readonly "application/vnd.valve.source.material": {
        readonly source: "iana";
    };
    readonly "application/vnd.vcx": {
        readonly source: "iana";
        readonly extensions: readonly ["vcx"];
    };
    readonly "application/vnd.vd-study": {
        readonly source: "iana";
    };
    readonly "application/vnd.vectorworks": {
        readonly source: "iana";
    };
    readonly "application/vnd.vel+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.verimatrix.vcas": {
        readonly source: "iana";
    };
    readonly "application/vnd.veritone.aion+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.veryant.thin": {
        readonly source: "iana";
    };
    readonly "application/vnd.ves.encrypted": {
        readonly source: "iana";
    };
    readonly "application/vnd.vidsoft.vidconference": {
        readonly source: "iana";
    };
    readonly "application/vnd.visio": {
        readonly source: "iana";
        readonly extensions: readonly ["vsd", "vst", "vss", "vsw"];
    };
    readonly "application/vnd.visionary": {
        readonly source: "iana";
        readonly extensions: readonly ["vis"];
    };
    readonly "application/vnd.vividence.scriptfile": {
        readonly source: "iana";
    };
    readonly "application/vnd.vsf": {
        readonly source: "iana";
        readonly extensions: readonly ["vsf"];
    };
    readonly "application/vnd.wap.sic": {
        readonly source: "iana";
    };
    readonly "application/vnd.wap.slc": {
        readonly source: "iana";
    };
    readonly "application/vnd.wap.wbxml": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly extensions: readonly ["wbxml"];
    };
    readonly "application/vnd.wap.wmlc": {
        readonly source: "iana";
        readonly extensions: readonly ["wmlc"];
    };
    readonly "application/vnd.wap.wmlscriptc": {
        readonly source: "iana";
        readonly extensions: readonly ["wmlsc"];
    };
    readonly "application/vnd.webturbo": {
        readonly source: "iana";
        readonly extensions: readonly ["wtb"];
    };
    readonly "application/vnd.wfa.dpp": {
        readonly source: "iana";
    };
    readonly "application/vnd.wfa.p2p": {
        readonly source: "iana";
    };
    readonly "application/vnd.wfa.wsc": {
        readonly source: "iana";
    };
    readonly "application/vnd.windows.devicepairing": {
        readonly source: "iana";
    };
    readonly "application/vnd.wmc": {
        readonly source: "iana";
    };
    readonly "application/vnd.wmf.bootstrap": {
        readonly source: "iana";
    };
    readonly "application/vnd.wolfram.mathematica": {
        readonly source: "iana";
    };
    readonly "application/vnd.wolfram.mathematica.package": {
        readonly source: "iana";
    };
    readonly "application/vnd.wolfram.player": {
        readonly source: "iana";
        readonly extensions: readonly ["nbp"];
    };
    readonly "application/vnd.wordperfect": {
        readonly source: "iana";
        readonly extensions: readonly ["wpd"];
    };
    readonly "application/vnd.wqd": {
        readonly source: "iana";
        readonly extensions: readonly ["wqd"];
    };
    readonly "application/vnd.wrq-hp3000-labelled": {
        readonly source: "iana";
    };
    readonly "application/vnd.wt.stf": {
        readonly source: "iana";
        readonly extensions: readonly ["stf"];
    };
    readonly "application/vnd.wv.csp+wbxml": {
        readonly source: "iana";
    };
    readonly "application/vnd.wv.csp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.wv.ssp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.xacml+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.xara": {
        readonly source: "iana";
        readonly extensions: readonly ["xar"];
    };
    readonly "application/vnd.xfdl": {
        readonly source: "iana";
        readonly extensions: readonly ["xfdl"];
    };
    readonly "application/vnd.xfdl.webform": {
        readonly source: "iana";
    };
    readonly "application/vnd.xmi+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vnd.xmpie.cpkg": {
        readonly source: "iana";
    };
    readonly "application/vnd.xmpie.dpkg": {
        readonly source: "iana";
    };
    readonly "application/vnd.xmpie.plan": {
        readonly source: "iana";
    };
    readonly "application/vnd.xmpie.ppkg": {
        readonly source: "iana";
    };
    readonly "application/vnd.xmpie.xlim": {
        readonly source: "iana";
    };
    readonly "application/vnd.yamaha.hv-dic": {
        readonly source: "iana";
        readonly extensions: readonly ["hvd"];
    };
    readonly "application/vnd.yamaha.hv-script": {
        readonly source: "iana";
        readonly extensions: readonly ["hvs"];
    };
    readonly "application/vnd.yamaha.hv-voice": {
        readonly source: "iana";
        readonly extensions: readonly ["hvp"];
    };
    readonly "application/vnd.yamaha.openscoreformat": {
        readonly source: "iana";
        readonly extensions: readonly ["osf"];
    };
    readonly "application/vnd.yamaha.openscoreformat.osfpvg+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["osfpvg"];
    };
    readonly "application/vnd.yamaha.remote-setup": {
        readonly source: "iana";
    };
    readonly "application/vnd.yamaha.smaf-audio": {
        readonly source: "iana";
        readonly extensions: readonly ["saf"];
    };
    readonly "application/vnd.yamaha.smaf-phrase": {
        readonly source: "iana";
        readonly extensions: readonly ["spf"];
    };
    readonly "application/vnd.yamaha.through-ngn": {
        readonly source: "iana";
    };
    readonly "application/vnd.yamaha.tunnel-udpencap": {
        readonly source: "iana";
    };
    readonly "application/vnd.yaoweme": {
        readonly source: "iana";
    };
    readonly "application/vnd.yellowriver-custom-menu": {
        readonly source: "iana";
        readonly extensions: readonly ["cmp"];
    };
    readonly "application/vnd.youtube.yt": {
        readonly source: "iana";
    };
    readonly "application/vnd.zul": {
        readonly source: "iana";
        readonly extensions: readonly ["zir", "zirz"];
    };
    readonly "application/vnd.zzazz.deck+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["zaz"];
    };
    readonly "application/voicexml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["vxml"];
    };
    readonly "application/voucher-cms+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/vq-rtcpxr": {
        readonly source: "iana";
    };
    readonly "application/wasm": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["wasm"];
    };
    readonly "application/watcherinfo+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["wif"];
    };
    readonly "application/webpush-options+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/whoispp-query": {
        readonly source: "iana";
    };
    readonly "application/whoispp-response": {
        readonly source: "iana";
    };
    readonly "application/widget": {
        readonly source: "iana";
        readonly extensions: readonly ["wgt"];
    };
    readonly "application/winhlp": {
        readonly source: "apache";
        readonly extensions: readonly ["hlp"];
    };
    readonly "application/wita": {
        readonly source: "iana";
    };
    readonly "application/wordperfect5.1": {
        readonly source: "iana";
    };
    readonly "application/wsdl+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["wsdl"];
    };
    readonly "application/wspolicy+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["wspolicy"];
    };
    readonly "application/x-7z-compressed": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["7z"];
    };
    readonly "application/x-abiword": {
        readonly source: "apache";
        readonly extensions: readonly ["abw"];
    };
    readonly "application/x-ace-compressed": {
        readonly source: "apache";
        readonly extensions: readonly ["ace"];
    };
    readonly "application/x-amf": {
        readonly source: "apache";
    };
    readonly "application/x-apple-diskimage": {
        readonly source: "apache";
        readonly extensions: readonly ["dmg"];
    };
    readonly "application/x-arj": {
        readonly compressible: false;
        readonly extensions: readonly ["arj"];
    };
    readonly "application/x-authorware-bin": {
        readonly source: "apache";
        readonly extensions: readonly ["aab", "x32", "u32", "vox"];
    };
    readonly "application/x-authorware-map": {
        readonly source: "apache";
        readonly extensions: readonly ["aam"];
    };
    readonly "application/x-authorware-seg": {
        readonly source: "apache";
        readonly extensions: readonly ["aas"];
    };
    readonly "application/x-bcpio": {
        readonly source: "apache";
        readonly extensions: readonly ["bcpio"];
    };
    readonly "application/x-bdoc": {
        readonly compressible: false;
        readonly extensions: readonly ["bdoc"];
    };
    readonly "application/x-bittorrent": {
        readonly source: "apache";
        readonly extensions: readonly ["torrent"];
    };
    readonly "application/x-blorb": {
        readonly source: "apache";
        readonly extensions: readonly ["blb", "blorb"];
    };
    readonly "application/x-bzip": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["bz"];
    };
    readonly "application/x-bzip2": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["bz2", "boz"];
    };
    readonly "application/x-cbr": {
        readonly source: "apache";
        readonly extensions: readonly ["cbr", "cba", "cbt", "cbz", "cb7"];
    };
    readonly "application/x-cdlink": {
        readonly source: "apache";
        readonly extensions: readonly ["vcd"];
    };
    readonly "application/x-cfs-compressed": {
        readonly source: "apache";
        readonly extensions: readonly ["cfs"];
    };
    readonly "application/x-chat": {
        readonly source: "apache";
        readonly extensions: readonly ["chat"];
    };
    readonly "application/x-chess-pgn": {
        readonly source: "apache";
        readonly extensions: readonly ["pgn"];
    };
    readonly "application/x-chrome-extension": {
        readonly extensions: readonly ["crx"];
    };
    readonly "application/x-cocoa": {
        readonly source: "nginx";
        readonly extensions: readonly ["cco"];
    };
    readonly "application/x-compress": {
        readonly source: "apache";
    };
    readonly "application/x-conference": {
        readonly source: "apache";
        readonly extensions: readonly ["nsc"];
    };
    readonly "application/x-cpio": {
        readonly source: "apache";
        readonly extensions: readonly ["cpio"];
    };
    readonly "application/x-csh": {
        readonly source: "apache";
        readonly extensions: readonly ["csh"];
    };
    readonly "application/x-deb": {
        readonly compressible: false;
    };
    readonly "application/x-debian-package": {
        readonly source: "apache";
        readonly extensions: readonly ["deb", "udeb"];
    };
    readonly "application/x-dgc-compressed": {
        readonly source: "apache";
        readonly extensions: readonly ["dgc"];
    };
    readonly "application/x-director": {
        readonly source: "apache";
        readonly extensions: readonly ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"];
    };
    readonly "application/x-doom": {
        readonly source: "apache";
        readonly extensions: readonly ["wad"];
    };
    readonly "application/x-dtbncx+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["ncx"];
    };
    readonly "application/x-dtbook+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["dtb"];
    };
    readonly "application/x-dtbresource+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["res"];
    };
    readonly "application/x-dvi": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["dvi"];
    };
    readonly "application/x-envoy": {
        readonly source: "apache";
        readonly extensions: readonly ["evy"];
    };
    readonly "application/x-eva": {
        readonly source: "apache";
        readonly extensions: readonly ["eva"];
    };
    readonly "application/x-font-bdf": {
        readonly source: "apache";
        readonly extensions: readonly ["bdf"];
    };
    readonly "application/x-font-dos": {
        readonly source: "apache";
    };
    readonly "application/x-font-framemaker": {
        readonly source: "apache";
    };
    readonly "application/x-font-ghostscript": {
        readonly source: "apache";
        readonly extensions: readonly ["gsf"];
    };
    readonly "application/x-font-libgrx": {
        readonly source: "apache";
    };
    readonly "application/x-font-linux-psf": {
        readonly source: "apache";
        readonly extensions: readonly ["psf"];
    };
    readonly "application/x-font-pcf": {
        readonly source: "apache";
        readonly extensions: readonly ["pcf"];
    };
    readonly "application/x-font-snf": {
        readonly source: "apache";
        readonly extensions: readonly ["snf"];
    };
    readonly "application/x-font-speedo": {
        readonly source: "apache";
    };
    readonly "application/x-font-sunos-news": {
        readonly source: "apache";
    };
    readonly "application/x-font-type1": {
        readonly source: "apache";
        readonly extensions: readonly ["pfa", "pfb", "pfm", "afm"];
    };
    readonly "application/x-font-vfont": {
        readonly source: "apache";
    };
    readonly "application/x-freearc": {
        readonly source: "apache";
        readonly extensions: readonly ["arc"];
    };
    readonly "application/x-futuresplash": {
        readonly source: "apache";
        readonly extensions: readonly ["spl"];
    };
    readonly "application/x-gca-compressed": {
        readonly source: "apache";
        readonly extensions: readonly ["gca"];
    };
    readonly "application/x-glulx": {
        readonly source: "apache";
        readonly extensions: readonly ["ulx"];
    };
    readonly "application/x-gnumeric": {
        readonly source: "apache";
        readonly extensions: readonly ["gnumeric"];
    };
    readonly "application/x-gramps-xml": {
        readonly source: "apache";
        readonly extensions: readonly ["gramps"];
    };
    readonly "application/x-gtar": {
        readonly source: "apache";
        readonly extensions: readonly ["gtar"];
    };
    readonly "application/x-gzip": {
        readonly source: "apache";
    };
    readonly "application/x-hdf": {
        readonly source: "apache";
        readonly extensions: readonly ["hdf"];
    };
    readonly "application/x-httpd-php": {
        readonly compressible: true;
        readonly extensions: readonly ["php"];
    };
    readonly "application/x-install-instructions": {
        readonly source: "apache";
        readonly extensions: readonly ["install"];
    };
    readonly "application/x-iso9660-image": {
        readonly source: "apache";
        readonly extensions: readonly ["iso"];
    };
    readonly "application/x-iwork-keynote-sffkey": {
        readonly extensions: readonly ["key"];
    };
    readonly "application/x-iwork-numbers-sffnumbers": {
        readonly extensions: readonly ["numbers"];
    };
    readonly "application/x-iwork-pages-sffpages": {
        readonly extensions: readonly ["pages"];
    };
    readonly "application/x-java-archive-diff": {
        readonly source: "nginx";
        readonly extensions: readonly ["jardiff"];
    };
    readonly "application/x-java-jnlp-file": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["jnlp"];
    };
    readonly "application/x-javascript": {
        readonly compressible: true;
    };
    readonly "application/x-keepass2": {
        readonly extensions: readonly ["kdbx"];
    };
    readonly "application/x-latex": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["latex"];
    };
    readonly "application/x-lua-bytecode": {
        readonly extensions: readonly ["luac"];
    };
    readonly "application/x-lzh-compressed": {
        readonly source: "apache";
        readonly extensions: readonly ["lzh", "lha"];
    };
    readonly "application/x-makeself": {
        readonly source: "nginx";
        readonly extensions: readonly ["run"];
    };
    readonly "application/x-mie": {
        readonly source: "apache";
        readonly extensions: readonly ["mie"];
    };
    readonly "application/x-mobipocket-ebook": {
        readonly source: "apache";
        readonly extensions: readonly ["prc", "mobi"];
    };
    readonly "application/x-mpegurl": {
        readonly compressible: false;
    };
    readonly "application/x-ms-application": {
        readonly source: "apache";
        readonly extensions: readonly ["application"];
    };
    readonly "application/x-ms-shortcut": {
        readonly source: "apache";
        readonly extensions: readonly ["lnk"];
    };
    readonly "application/x-ms-wmd": {
        readonly source: "apache";
        readonly extensions: readonly ["wmd"];
    };
    readonly "application/x-ms-wmz": {
        readonly source: "apache";
        readonly extensions: readonly ["wmz"];
    };
    readonly "application/x-ms-xbap": {
        readonly source: "apache";
        readonly extensions: readonly ["xbap"];
    };
    readonly "application/x-msaccess": {
        readonly source: "apache";
        readonly extensions: readonly ["mdb"];
    };
    readonly "application/x-msbinder": {
        readonly source: "apache";
        readonly extensions: readonly ["obd"];
    };
    readonly "application/x-mscardfile": {
        readonly source: "apache";
        readonly extensions: readonly ["crd"];
    };
    readonly "application/x-msclip": {
        readonly source: "apache";
        readonly extensions: readonly ["clp"];
    };
    readonly "application/x-msdos-program": {
        readonly extensions: readonly ["exe"];
    };
    readonly "application/x-msdownload": {
        readonly source: "apache";
        readonly extensions: readonly ["exe", "dll", "com", "bat", "msi"];
    };
    readonly "application/x-msmediaview": {
        readonly source: "apache";
        readonly extensions: readonly ["mvb", "m13", "m14"];
    };
    readonly "application/x-msmetafile": {
        readonly source: "apache";
        readonly extensions: readonly ["wmf", "wmz", "emf", "emz"];
    };
    readonly "application/x-msmoney": {
        readonly source: "apache";
        readonly extensions: readonly ["mny"];
    };
    readonly "application/x-mspublisher": {
        readonly source: "apache";
        readonly extensions: readonly ["pub"];
    };
    readonly "application/x-msschedule": {
        readonly source: "apache";
        readonly extensions: readonly ["scd"];
    };
    readonly "application/x-msterminal": {
        readonly source: "apache";
        readonly extensions: readonly ["trm"];
    };
    readonly "application/x-mswrite": {
        readonly source: "apache";
        readonly extensions: readonly ["wri"];
    };
    readonly "application/x-netcdf": {
        readonly source: "apache";
        readonly extensions: readonly ["nc", "cdf"];
    };
    readonly "application/x-ns-proxy-autoconfig": {
        readonly compressible: true;
        readonly extensions: readonly ["pac"];
    };
    readonly "application/x-nzb": {
        readonly source: "apache";
        readonly extensions: readonly ["nzb"];
    };
    readonly "application/x-perl": {
        readonly source: "nginx";
        readonly extensions: readonly ["pl", "pm"];
    };
    readonly "application/x-pilot": {
        readonly source: "nginx";
        readonly extensions: readonly ["prc", "pdb"];
    };
    readonly "application/x-pkcs12": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["p12", "pfx"];
    };
    readonly "application/x-pkcs7-certificates": {
        readonly source: "apache";
        readonly extensions: readonly ["p7b", "spc"];
    };
    readonly "application/x-pkcs7-certreqresp": {
        readonly source: "apache";
        readonly extensions: readonly ["p7r"];
    };
    readonly "application/x-pki-message": {
        readonly source: "iana";
    };
    readonly "application/x-rar-compressed": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["rar"];
    };
    readonly "application/x-redhat-package-manager": {
        readonly source: "nginx";
        readonly extensions: readonly ["rpm"];
    };
    readonly "application/x-research-info-systems": {
        readonly source: "apache";
        readonly extensions: readonly ["ris"];
    };
    readonly "application/x-sea": {
        readonly source: "nginx";
        readonly extensions: readonly ["sea"];
    };
    readonly "application/x-sh": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["sh"];
    };
    readonly "application/x-shar": {
        readonly source: "apache";
        readonly extensions: readonly ["shar"];
    };
    readonly "application/x-shockwave-flash": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["swf"];
    };
    readonly "application/x-silverlight-app": {
        readonly source: "apache";
        readonly extensions: readonly ["xap"];
    };
    readonly "application/x-sql": {
        readonly source: "apache";
        readonly extensions: readonly ["sql"];
    };
    readonly "application/x-stuffit": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["sit"];
    };
    readonly "application/x-stuffitx": {
        readonly source: "apache";
        readonly extensions: readonly ["sitx"];
    };
    readonly "application/x-subrip": {
        readonly source: "apache";
        readonly extensions: readonly ["srt"];
    };
    readonly "application/x-sv4cpio": {
        readonly source: "apache";
        readonly extensions: readonly ["sv4cpio"];
    };
    readonly "application/x-sv4crc": {
        readonly source: "apache";
        readonly extensions: readonly ["sv4crc"];
    };
    readonly "application/x-t3vm-image": {
        readonly source: "apache";
        readonly extensions: readonly ["t3"];
    };
    readonly "application/x-tads": {
        readonly source: "apache";
        readonly extensions: readonly ["gam"];
    };
    readonly "application/x-tar": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["tar"];
    };
    readonly "application/x-tcl": {
        readonly source: "apache";
        readonly extensions: readonly ["tcl", "tk"];
    };
    readonly "application/x-tex": {
        readonly source: "apache";
        readonly extensions: readonly ["tex"];
    };
    readonly "application/x-tex-tfm": {
        readonly source: "apache";
        readonly extensions: readonly ["tfm"];
    };
    readonly "application/x-texinfo": {
        readonly source: "apache";
        readonly extensions: readonly ["texinfo", "texi"];
    };
    readonly "application/x-tgif": {
        readonly source: "apache";
        readonly extensions: readonly ["obj"];
    };
    readonly "application/x-ustar": {
        readonly source: "apache";
        readonly extensions: readonly ["ustar"];
    };
    readonly "application/x-virtualbox-hdd": {
        readonly compressible: true;
        readonly extensions: readonly ["hdd"];
    };
    readonly "application/x-virtualbox-ova": {
        readonly compressible: true;
        readonly extensions: readonly ["ova"];
    };
    readonly "application/x-virtualbox-ovf": {
        readonly compressible: true;
        readonly extensions: readonly ["ovf"];
    };
    readonly "application/x-virtualbox-vbox": {
        readonly compressible: true;
        readonly extensions: readonly ["vbox"];
    };
    readonly "application/x-virtualbox-vbox-extpack": {
        readonly compressible: false;
        readonly extensions: readonly ["vbox-extpack"];
    };
    readonly "application/x-virtualbox-vdi": {
        readonly compressible: true;
        readonly extensions: readonly ["vdi"];
    };
    readonly "application/x-virtualbox-vhd": {
        readonly compressible: true;
        readonly extensions: readonly ["vhd"];
    };
    readonly "application/x-virtualbox-vmdk": {
        readonly compressible: true;
        readonly extensions: readonly ["vmdk"];
    };
    readonly "application/x-wais-source": {
        readonly source: "apache";
        readonly extensions: readonly ["src"];
    };
    readonly "application/x-web-app-manifest+json": {
        readonly compressible: true;
        readonly extensions: readonly ["webapp"];
    };
    readonly "application/x-www-form-urlencoded": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/x-x509-ca-cert": {
        readonly source: "iana";
        readonly extensions: readonly ["der", "crt", "pem"];
    };
    readonly "application/x-x509-ca-ra-cert": {
        readonly source: "iana";
    };
    readonly "application/x-x509-next-ca-cert": {
        readonly source: "iana";
    };
    readonly "application/x-xfig": {
        readonly source: "apache";
        readonly extensions: readonly ["fig"];
    };
    readonly "application/x-xliff+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["xlf"];
    };
    readonly "application/x-xpinstall": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["xpi"];
    };
    readonly "application/x-xz": {
        readonly source: "apache";
        readonly extensions: readonly ["xz"];
    };
    readonly "application/x-zmachine": {
        readonly source: "apache";
        readonly extensions: readonly ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"];
    };
    readonly "application/x400-bp": {
        readonly source: "iana";
    };
    readonly "application/xacml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/xaml+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["xaml"];
    };
    readonly "application/xcap-att+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xav"];
    };
    readonly "application/xcap-caps+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xca"];
    };
    readonly "application/xcap-diff+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xdf"];
    };
    readonly "application/xcap-el+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xel"];
    };
    readonly "application/xcap-error+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/xcap-ns+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xns"];
    };
    readonly "application/xcon-conference-info+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/xcon-conference-info-diff+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/xenc+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xenc"];
    };
    readonly "application/xhtml+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xhtml", "xht"];
    };
    readonly "application/xhtml-voice+xml": {
        readonly source: "apache";
        readonly compressible: true;
    };
    readonly "application/xliff+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xlf"];
    };
    readonly "application/xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xml", "xsl", "xsd", "rng"];
    };
    readonly "application/xml-dtd": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["dtd"];
    };
    readonly "application/xml-external-parsed-entity": {
        readonly source: "iana";
    };
    readonly "application/xml-patch+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/xmpp+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/xop+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xop"];
    };
    readonly "application/xproc+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["xpl"];
    };
    readonly "application/xslt+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xsl", "xslt"];
    };
    readonly "application/xspf+xml": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["xspf"];
    };
    readonly "application/xv+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["mxml", "xhvml", "xvml", "xvm"];
    };
    readonly "application/yang": {
        readonly source: "iana";
        readonly extensions: readonly ["yang"];
    };
    readonly "application/yang-data+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/yang-data+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/yang-patch+json": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/yang-patch+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "application/yin+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["yin"];
    };
    readonly "application/zip": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["zip"];
    };
    readonly "application/zlib": {
        readonly source: "iana";
    };
    readonly "application/zstd": {
        readonly source: "iana";
    };
    readonly "audio/1d-interleaved-parityfec": {
        readonly source: "iana";
    };
    readonly "audio/32kadpcm": {
        readonly source: "iana";
    };
    readonly "audio/3gpp": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["3gpp"];
    };
    readonly "audio/3gpp2": {
        readonly source: "iana";
    };
    readonly "audio/aac": {
        readonly source: "iana";
    };
    readonly "audio/ac3": {
        readonly source: "iana";
    };
    readonly "audio/adpcm": {
        readonly source: "apache";
        readonly extensions: readonly ["adp"];
    };
    readonly "audio/amr": {
        readonly source: "iana";
        readonly extensions: readonly ["amr"];
    };
    readonly "audio/amr-wb": {
        readonly source: "iana";
    };
    readonly "audio/amr-wb+": {
        readonly source: "iana";
    };
    readonly "audio/aptx": {
        readonly source: "iana";
    };
    readonly "audio/asc": {
        readonly source: "iana";
    };
    readonly "audio/atrac-advanced-lossless": {
        readonly source: "iana";
    };
    readonly "audio/atrac-x": {
        readonly source: "iana";
    };
    readonly "audio/atrac3": {
        readonly source: "iana";
    };
    readonly "audio/basic": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["au", "snd"];
    };
    readonly "audio/bv16": {
        readonly source: "iana";
    };
    readonly "audio/bv32": {
        readonly source: "iana";
    };
    readonly "audio/clearmode": {
        readonly source: "iana";
    };
    readonly "audio/cn": {
        readonly source: "iana";
    };
    readonly "audio/dat12": {
        readonly source: "iana";
    };
    readonly "audio/dls": {
        readonly source: "iana";
    };
    readonly "audio/dsr-es201108": {
        readonly source: "iana";
    };
    readonly "audio/dsr-es202050": {
        readonly source: "iana";
    };
    readonly "audio/dsr-es202211": {
        readonly source: "iana";
    };
    readonly "audio/dsr-es202212": {
        readonly source: "iana";
    };
    readonly "audio/dv": {
        readonly source: "iana";
    };
    readonly "audio/dvi4": {
        readonly source: "iana";
    };
    readonly "audio/eac3": {
        readonly source: "iana";
    };
    readonly "audio/encaprtp": {
        readonly source: "iana";
    };
    readonly "audio/evrc": {
        readonly source: "iana";
    };
    readonly "audio/evrc-qcp": {
        readonly source: "iana";
    };
    readonly "audio/evrc0": {
        readonly source: "iana";
    };
    readonly "audio/evrc1": {
        readonly source: "iana";
    };
    readonly "audio/evrcb": {
        readonly source: "iana";
    };
    readonly "audio/evrcb0": {
        readonly source: "iana";
    };
    readonly "audio/evrcb1": {
        readonly source: "iana";
    };
    readonly "audio/evrcnw": {
        readonly source: "iana";
    };
    readonly "audio/evrcnw0": {
        readonly source: "iana";
    };
    readonly "audio/evrcnw1": {
        readonly source: "iana";
    };
    readonly "audio/evrcwb": {
        readonly source: "iana";
    };
    readonly "audio/evrcwb0": {
        readonly source: "iana";
    };
    readonly "audio/evrcwb1": {
        readonly source: "iana";
    };
    readonly "audio/evs": {
        readonly source: "iana";
    };
    readonly "audio/flexfec": {
        readonly source: "iana";
    };
    readonly "audio/fwdred": {
        readonly source: "iana";
    };
    readonly "audio/g711-0": {
        readonly source: "iana";
    };
    readonly "audio/g719": {
        readonly source: "iana";
    };
    readonly "audio/g722": {
        readonly source: "iana";
    };
    readonly "audio/g7221": {
        readonly source: "iana";
    };
    readonly "audio/g723": {
        readonly source: "iana";
    };
    readonly "audio/g726-16": {
        readonly source: "iana";
    };
    readonly "audio/g726-24": {
        readonly source: "iana";
    };
    readonly "audio/g726-32": {
        readonly source: "iana";
    };
    readonly "audio/g726-40": {
        readonly source: "iana";
    };
    readonly "audio/g728": {
        readonly source: "iana";
    };
    readonly "audio/g729": {
        readonly source: "iana";
    };
    readonly "audio/g7291": {
        readonly source: "iana";
    };
    readonly "audio/g729d": {
        readonly source: "iana";
    };
    readonly "audio/g729e": {
        readonly source: "iana";
    };
    readonly "audio/gsm": {
        readonly source: "iana";
    };
    readonly "audio/gsm-efr": {
        readonly source: "iana";
    };
    readonly "audio/gsm-hr-08": {
        readonly source: "iana";
    };
    readonly "audio/ilbc": {
        readonly source: "iana";
    };
    readonly "audio/ip-mr_v2.5": {
        readonly source: "iana";
    };
    readonly "audio/isac": {
        readonly source: "apache";
    };
    readonly "audio/l16": {
        readonly source: "iana";
    };
    readonly "audio/l20": {
        readonly source: "iana";
    };
    readonly "audio/l24": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "audio/l8": {
        readonly source: "iana";
    };
    readonly "audio/lpc": {
        readonly source: "iana";
    };
    readonly "audio/melp": {
        readonly source: "iana";
    };
    readonly "audio/melp1200": {
        readonly source: "iana";
    };
    readonly "audio/melp2400": {
        readonly source: "iana";
    };
    readonly "audio/melp600": {
        readonly source: "iana";
    };
    readonly "audio/mhas": {
        readonly source: "iana";
    };
    readonly "audio/midi": {
        readonly source: "apache";
        readonly extensions: readonly ["mid", "midi", "kar", "rmi"];
    };
    readonly "audio/mobile-xmf": {
        readonly source: "iana";
        readonly extensions: readonly ["mxmf"];
    };
    readonly "audio/mp3": {
        readonly compressible: false;
        readonly extensions: readonly ["mp3"];
    };
    readonly "audio/mp4": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["m4a", "mp4a"];
    };
    readonly "audio/mp4a-latm": {
        readonly source: "iana";
    };
    readonly "audio/mpa": {
        readonly source: "iana";
    };
    readonly "audio/mpa-robust": {
        readonly source: "iana";
    };
    readonly "audio/mpeg": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"];
    };
    readonly "audio/mpeg4-generic": {
        readonly source: "iana";
    };
    readonly "audio/musepack": {
        readonly source: "apache";
    };
    readonly "audio/ogg": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["oga", "ogg", "spx", "opus"];
    };
    readonly "audio/opus": {
        readonly source: "iana";
    };
    readonly "audio/parityfec": {
        readonly source: "iana";
    };
    readonly "audio/pcma": {
        readonly source: "iana";
    };
    readonly "audio/pcma-wb": {
        readonly source: "iana";
    };
    readonly "audio/pcmu": {
        readonly source: "iana";
    };
    readonly "audio/pcmu-wb": {
        readonly source: "iana";
    };
    readonly "audio/prs.sid": {
        readonly source: "iana";
    };
    readonly "audio/qcelp": {
        readonly source: "iana";
    };
    readonly "audio/raptorfec": {
        readonly source: "iana";
    };
    readonly "audio/red": {
        readonly source: "iana";
    };
    readonly "audio/rtp-enc-aescm128": {
        readonly source: "iana";
    };
    readonly "audio/rtp-midi": {
        readonly source: "iana";
    };
    readonly "audio/rtploopback": {
        readonly source: "iana";
    };
    readonly "audio/rtx": {
        readonly source: "iana";
    };
    readonly "audio/s3m": {
        readonly source: "apache";
        readonly extensions: readonly ["s3m"];
    };
    readonly "audio/scip": {
        readonly source: "iana";
    };
    readonly "audio/silk": {
        readonly source: "apache";
        readonly extensions: readonly ["sil"];
    };
    readonly "audio/smv": {
        readonly source: "iana";
    };
    readonly "audio/smv-qcp": {
        readonly source: "iana";
    };
    readonly "audio/smv0": {
        readonly source: "iana";
    };
    readonly "audio/sofa": {
        readonly source: "iana";
    };
    readonly "audio/sp-midi": {
        readonly source: "iana";
    };
    readonly "audio/speex": {
        readonly source: "iana";
    };
    readonly "audio/t140c": {
        readonly source: "iana";
    };
    readonly "audio/t38": {
        readonly source: "iana";
    };
    readonly "audio/telephone-event": {
        readonly source: "iana";
    };
    readonly "audio/tetra_acelp": {
        readonly source: "iana";
    };
    readonly "audio/tetra_acelp_bb": {
        readonly source: "iana";
    };
    readonly "audio/tone": {
        readonly source: "iana";
    };
    readonly "audio/tsvcis": {
        readonly source: "iana";
    };
    readonly "audio/uemclip": {
        readonly source: "iana";
    };
    readonly "audio/ulpfec": {
        readonly source: "iana";
    };
    readonly "audio/usac": {
        readonly source: "iana";
    };
    readonly "audio/vdvi": {
        readonly source: "iana";
    };
    readonly "audio/vmr-wb": {
        readonly source: "iana";
    };
    readonly "audio/vnd.3gpp.iufp": {
        readonly source: "iana";
    };
    readonly "audio/vnd.4sb": {
        readonly source: "iana";
    };
    readonly "audio/vnd.audiokoz": {
        readonly source: "iana";
    };
    readonly "audio/vnd.celp": {
        readonly source: "iana";
    };
    readonly "audio/vnd.cisco.nse": {
        readonly source: "iana";
    };
    readonly "audio/vnd.cmles.radio-events": {
        readonly source: "iana";
    };
    readonly "audio/vnd.cns.anp1": {
        readonly source: "iana";
    };
    readonly "audio/vnd.cns.inf1": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dece.audio": {
        readonly source: "iana";
        readonly extensions: readonly ["uva", "uvva"];
    };
    readonly "audio/vnd.digital-winds": {
        readonly source: "iana";
        readonly extensions: readonly ["eol"];
    };
    readonly "audio/vnd.dlna.adts": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.heaac.1": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.heaac.2": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.mlp": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.mps": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.pl2": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.pl2x": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.pl2z": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dolby.pulse.1": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dra": {
        readonly source: "iana";
        readonly extensions: readonly ["dra"];
    };
    readonly "audio/vnd.dts": {
        readonly source: "iana";
        readonly extensions: readonly ["dts"];
    };
    readonly "audio/vnd.dts.hd": {
        readonly source: "iana";
        readonly extensions: readonly ["dtshd"];
    };
    readonly "audio/vnd.dts.uhd": {
        readonly source: "iana";
    };
    readonly "audio/vnd.dvb.file": {
        readonly source: "iana";
    };
    readonly "audio/vnd.everad.plj": {
        readonly source: "iana";
    };
    readonly "audio/vnd.hns.audio": {
        readonly source: "iana";
    };
    readonly "audio/vnd.lucent.voice": {
        readonly source: "iana";
        readonly extensions: readonly ["lvp"];
    };
    readonly "audio/vnd.ms-playready.media.pya": {
        readonly source: "iana";
        readonly extensions: readonly ["pya"];
    };
    readonly "audio/vnd.nokia.mobile-xmf": {
        readonly source: "iana";
    };
    readonly "audio/vnd.nortel.vbk": {
        readonly source: "iana";
    };
    readonly "audio/vnd.nuera.ecelp4800": {
        readonly source: "iana";
        readonly extensions: readonly ["ecelp4800"];
    };
    readonly "audio/vnd.nuera.ecelp7470": {
        readonly source: "iana";
        readonly extensions: readonly ["ecelp7470"];
    };
    readonly "audio/vnd.nuera.ecelp9600": {
        readonly source: "iana";
        readonly extensions: readonly ["ecelp9600"];
    };
    readonly "audio/vnd.octel.sbc": {
        readonly source: "iana";
    };
    readonly "audio/vnd.presonus.multitrack": {
        readonly source: "iana";
    };
    readonly "audio/vnd.qcelp": {
        readonly source: "iana";
    };
    readonly "audio/vnd.rhetorex.32kadpcm": {
        readonly source: "iana";
    };
    readonly "audio/vnd.rip": {
        readonly source: "iana";
        readonly extensions: readonly ["rip"];
    };
    readonly "audio/vnd.rn-realaudio": {
        readonly compressible: false;
    };
    readonly "audio/vnd.sealedmedia.softseal.mpeg": {
        readonly source: "iana";
    };
    readonly "audio/vnd.vmx.cvsd": {
        readonly source: "iana";
    };
    readonly "audio/vnd.wave": {
        readonly compressible: false;
    };
    readonly "audio/vorbis": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "audio/vorbis-config": {
        readonly source: "iana";
    };
    readonly "audio/wav": {
        readonly compressible: false;
        readonly extensions: readonly ["wav"];
    };
    readonly "audio/wave": {
        readonly compressible: false;
        readonly extensions: readonly ["wav"];
    };
    readonly "audio/webm": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["weba"];
    };
    readonly "audio/x-aac": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["aac"];
    };
    readonly "audio/x-aiff": {
        readonly source: "apache";
        readonly extensions: readonly ["aif", "aiff", "aifc"];
    };
    readonly "audio/x-caf": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["caf"];
    };
    readonly "audio/x-flac": {
        readonly source: "apache";
        readonly extensions: readonly ["flac"];
    };
    readonly "audio/x-m4a": {
        readonly source: "nginx";
        readonly extensions: readonly ["m4a"];
    };
    readonly "audio/x-matroska": {
        readonly source: "apache";
        readonly extensions: readonly ["mka"];
    };
    readonly "audio/x-mpegurl": {
        readonly source: "apache";
        readonly extensions: readonly ["m3u"];
    };
    readonly "audio/x-ms-wax": {
        readonly source: "apache";
        readonly extensions: readonly ["wax"];
    };
    readonly "audio/x-ms-wma": {
        readonly source: "apache";
        readonly extensions: readonly ["wma"];
    };
    readonly "audio/x-pn-realaudio": {
        readonly source: "apache";
        readonly extensions: readonly ["ram", "ra"];
    };
    readonly "audio/x-pn-realaudio-plugin": {
        readonly source: "apache";
        readonly extensions: readonly ["rmp"];
    };
    readonly "audio/x-realaudio": {
        readonly source: "nginx";
        readonly extensions: readonly ["ra"];
    };
    readonly "audio/x-tta": {
        readonly source: "apache";
    };
    readonly "audio/x-wav": {
        readonly source: "apache";
        readonly extensions: readonly ["wav"];
    };
    readonly "audio/xm": {
        readonly source: "apache";
        readonly extensions: readonly ["xm"];
    };
    readonly "chemical/x-cdx": {
        readonly source: "apache";
        readonly extensions: readonly ["cdx"];
    };
    readonly "chemical/x-cif": {
        readonly source: "apache";
        readonly extensions: readonly ["cif"];
    };
    readonly "chemical/x-cmdf": {
        readonly source: "apache";
        readonly extensions: readonly ["cmdf"];
    };
    readonly "chemical/x-cml": {
        readonly source: "apache";
        readonly extensions: readonly ["cml"];
    };
    readonly "chemical/x-csml": {
        readonly source: "apache";
        readonly extensions: readonly ["csml"];
    };
    readonly "chemical/x-pdb": {
        readonly source: "apache";
    };
    readonly "chemical/x-xyz": {
        readonly source: "apache";
        readonly extensions: readonly ["xyz"];
    };
    readonly "font/collection": {
        readonly source: "iana";
        readonly extensions: readonly ["ttc"];
    };
    readonly "font/otf": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["otf"];
    };
    readonly "font/sfnt": {
        readonly source: "iana";
    };
    readonly "font/ttf": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ttf"];
    };
    readonly "font/woff": {
        readonly source: "iana";
        readonly extensions: readonly ["woff"];
    };
    readonly "font/woff2": {
        readonly source: "iana";
        readonly extensions: readonly ["woff2"];
    };
    readonly "image/aces": {
        readonly source: "iana";
        readonly extensions: readonly ["exr"];
    };
    readonly "image/apng": {
        readonly compressible: false;
        readonly extensions: readonly ["apng"];
    };
    readonly "image/avci": {
        readonly source: "iana";
        readonly extensions: readonly ["avci"];
    };
    readonly "image/avcs": {
        readonly source: "iana";
        readonly extensions: readonly ["avcs"];
    };
    readonly "image/avif": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["avif"];
    };
    readonly "image/bmp": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["bmp"];
    };
    readonly "image/cgm": {
        readonly source: "iana";
        readonly extensions: readonly ["cgm"];
    };
    readonly "image/dicom-rle": {
        readonly source: "iana";
        readonly extensions: readonly ["drle"];
    };
    readonly "image/emf": {
        readonly source: "iana";
        readonly extensions: readonly ["emf"];
    };
    readonly "image/fits": {
        readonly source: "iana";
        readonly extensions: readonly ["fits"];
    };
    readonly "image/g3fax": {
        readonly source: "iana";
        readonly extensions: readonly ["g3"];
    };
    readonly "image/gif": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["gif"];
    };
    readonly "image/heic": {
        readonly source: "iana";
        readonly extensions: readonly ["heic"];
    };
    readonly "image/heic-sequence": {
        readonly source: "iana";
        readonly extensions: readonly ["heics"];
    };
    readonly "image/heif": {
        readonly source: "iana";
        readonly extensions: readonly ["heif"];
    };
    readonly "image/heif-sequence": {
        readonly source: "iana";
        readonly extensions: readonly ["heifs"];
    };
    readonly "image/hej2k": {
        readonly source: "iana";
        readonly extensions: readonly ["hej2"];
    };
    readonly "image/hsj2": {
        readonly source: "iana";
        readonly extensions: readonly ["hsj2"];
    };
    readonly "image/ief": {
        readonly source: "iana";
        readonly extensions: readonly ["ief"];
    };
    readonly "image/jls": {
        readonly source: "iana";
        readonly extensions: readonly ["jls"];
    };
    readonly "image/jp2": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["jp2", "jpg2"];
    };
    readonly "image/jpeg": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["jpeg", "jpg", "jpe"];
    };
    readonly "image/jph": {
        readonly source: "iana";
        readonly extensions: readonly ["jph"];
    };
    readonly "image/jphc": {
        readonly source: "iana";
        readonly extensions: readonly ["jhc"];
    };
    readonly "image/jpm": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["jpm"];
    };
    readonly "image/jpx": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["jpx", "jpf"];
    };
    readonly "image/jxr": {
        readonly source: "iana";
        readonly extensions: readonly ["jxr"];
    };
    readonly "image/jxra": {
        readonly source: "iana";
        readonly extensions: readonly ["jxra"];
    };
    readonly "image/jxrs": {
        readonly source: "iana";
        readonly extensions: readonly ["jxrs"];
    };
    readonly "image/jxs": {
        readonly source: "iana";
        readonly extensions: readonly ["jxs"];
    };
    readonly "image/jxsc": {
        readonly source: "iana";
        readonly extensions: readonly ["jxsc"];
    };
    readonly "image/jxsi": {
        readonly source: "iana";
        readonly extensions: readonly ["jxsi"];
    };
    readonly "image/jxss": {
        readonly source: "iana";
        readonly extensions: readonly ["jxss"];
    };
    readonly "image/ktx": {
        readonly source: "iana";
        readonly extensions: readonly ["ktx"];
    };
    readonly "image/ktx2": {
        readonly source: "iana";
        readonly extensions: readonly ["ktx2"];
    };
    readonly "image/naplps": {
        readonly source: "iana";
    };
    readonly "image/pjpeg": {
        readonly compressible: false;
    };
    readonly "image/png": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["png"];
    };
    readonly "image/prs.btif": {
        readonly source: "iana";
        readonly extensions: readonly ["btif"];
    };
    readonly "image/prs.pti": {
        readonly source: "iana";
        readonly extensions: readonly ["pti"];
    };
    readonly "image/pwg-raster": {
        readonly source: "iana";
    };
    readonly "image/sgi": {
        readonly source: "apache";
        readonly extensions: readonly ["sgi"];
    };
    readonly "image/svg+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["svg", "svgz"];
    };
    readonly "image/t38": {
        readonly source: "iana";
        readonly extensions: readonly ["t38"];
    };
    readonly "image/tiff": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["tif", "tiff"];
    };
    readonly "image/tiff-fx": {
        readonly source: "iana";
        readonly extensions: readonly ["tfx"];
    };
    readonly "image/vnd.adobe.photoshop": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["psd"];
    };
    readonly "image/vnd.airzip.accelerator.azv": {
        readonly source: "iana";
        readonly extensions: readonly ["azv"];
    };
    readonly "image/vnd.cns.inf2": {
        readonly source: "iana";
    };
    readonly "image/vnd.dece.graphic": {
        readonly source: "iana";
        readonly extensions: readonly ["uvi", "uvvi", "uvg", "uvvg"];
    };
    readonly "image/vnd.djvu": {
        readonly source: "iana";
        readonly extensions: readonly ["djvu", "djv"];
    };
    readonly "image/vnd.dvb.subtitle": {
        readonly source: "iana";
        readonly extensions: readonly ["sub"];
    };
    readonly "image/vnd.dwg": {
        readonly source: "iana";
        readonly extensions: readonly ["dwg"];
    };
    readonly "image/vnd.dxf": {
        readonly source: "iana";
        readonly extensions: readonly ["dxf"];
    };
    readonly "image/vnd.fastbidsheet": {
        readonly source: "iana";
        readonly extensions: readonly ["fbs"];
    };
    readonly "image/vnd.fpx": {
        readonly source: "iana";
        readonly extensions: readonly ["fpx"];
    };
    readonly "image/vnd.fst": {
        readonly source: "iana";
        readonly extensions: readonly ["fst"];
    };
    readonly "image/vnd.fujixerox.edmics-mmr": {
        readonly source: "iana";
        readonly extensions: readonly ["mmr"];
    };
    readonly "image/vnd.fujixerox.edmics-rlc": {
        readonly source: "iana";
        readonly extensions: readonly ["rlc"];
    };
    readonly "image/vnd.globalgraphics.pgb": {
        readonly source: "iana";
    };
    readonly "image/vnd.microsoft.icon": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["ico"];
    };
    readonly "image/vnd.mix": {
        readonly source: "iana";
    };
    readonly "image/vnd.mozilla.apng": {
        readonly source: "iana";
    };
    readonly "image/vnd.ms-dds": {
        readonly compressible: true;
        readonly extensions: readonly ["dds"];
    };
    readonly "image/vnd.ms-modi": {
        readonly source: "iana";
        readonly extensions: readonly ["mdi"];
    };
    readonly "image/vnd.ms-photo": {
        readonly source: "apache";
        readonly extensions: readonly ["wdp"];
    };
    readonly "image/vnd.net-fpx": {
        readonly source: "iana";
        readonly extensions: readonly ["npx"];
    };
    readonly "image/vnd.pco.b16": {
        readonly source: "iana";
        readonly extensions: readonly ["b16"];
    };
    readonly "image/vnd.radiance": {
        readonly source: "iana";
    };
    readonly "image/vnd.sealed.png": {
        readonly source: "iana";
    };
    readonly "image/vnd.sealedmedia.softseal.gif": {
        readonly source: "iana";
    };
    readonly "image/vnd.sealedmedia.softseal.jpg": {
        readonly source: "iana";
    };
    readonly "image/vnd.svf": {
        readonly source: "iana";
    };
    readonly "image/vnd.tencent.tap": {
        readonly source: "iana";
        readonly extensions: readonly ["tap"];
    };
    readonly "image/vnd.valve.source.texture": {
        readonly source: "iana";
        readonly extensions: readonly ["vtf"];
    };
    readonly "image/vnd.wap.wbmp": {
        readonly source: "iana";
        readonly extensions: readonly ["wbmp"];
    };
    readonly "image/vnd.xiff": {
        readonly source: "iana";
        readonly extensions: readonly ["xif"];
    };
    readonly "image/vnd.zbrush.pcx": {
        readonly source: "iana";
        readonly extensions: readonly ["pcx"];
    };
    readonly "image/webp": {
        readonly source: "apache";
        readonly extensions: readonly ["webp"];
    };
    readonly "image/wmf": {
        readonly source: "iana";
        readonly extensions: readonly ["wmf"];
    };
    readonly "image/x-3ds": {
        readonly source: "apache";
        readonly extensions: readonly ["3ds"];
    };
    readonly "image/x-cmu-raster": {
        readonly source: "apache";
        readonly extensions: readonly ["ras"];
    };
    readonly "image/x-cmx": {
        readonly source: "apache";
        readonly extensions: readonly ["cmx"];
    };
    readonly "image/x-freehand": {
        readonly source: "apache";
        readonly extensions: readonly ["fh", "fhc", "fh4", "fh5", "fh7"];
    };
    readonly "image/x-icon": {
        readonly source: "apache";
        readonly compressible: true;
        readonly extensions: readonly ["ico"];
    };
    readonly "image/x-jng": {
        readonly source: "nginx";
        readonly extensions: readonly ["jng"];
    };
    readonly "image/x-mrsid-image": {
        readonly source: "apache";
        readonly extensions: readonly ["sid"];
    };
    readonly "image/x-ms-bmp": {
        readonly source: "nginx";
        readonly compressible: true;
        readonly extensions: readonly ["bmp"];
    };
    readonly "image/x-pcx": {
        readonly source: "apache";
        readonly extensions: readonly ["pcx"];
    };
    readonly "image/x-pict": {
        readonly source: "apache";
        readonly extensions: readonly ["pic", "pct"];
    };
    readonly "image/x-portable-anymap": {
        readonly source: "apache";
        readonly extensions: readonly ["pnm"];
    };
    readonly "image/x-portable-bitmap": {
        readonly source: "apache";
        readonly extensions: readonly ["pbm"];
    };
    readonly "image/x-portable-graymap": {
        readonly source: "apache";
        readonly extensions: readonly ["pgm"];
    };
    readonly "image/x-portable-pixmap": {
        readonly source: "apache";
        readonly extensions: readonly ["ppm"];
    };
    readonly "image/x-rgb": {
        readonly source: "apache";
        readonly extensions: readonly ["rgb"];
    };
    readonly "image/x-tga": {
        readonly source: "apache";
        readonly extensions: readonly ["tga"];
    };
    readonly "image/x-xbitmap": {
        readonly source: "apache";
        readonly extensions: readonly ["xbm"];
    };
    readonly "image/x-xcf": {
        readonly compressible: false;
    };
    readonly "image/x-xpixmap": {
        readonly source: "apache";
        readonly extensions: readonly ["xpm"];
    };
    readonly "image/x-xwindowdump": {
        readonly source: "apache";
        readonly extensions: readonly ["xwd"];
    };
    readonly "message/cpim": {
        readonly source: "iana";
    };
    readonly "message/delivery-status": {
        readonly source: "iana";
    };
    readonly "message/disposition-notification": {
        readonly source: "iana";
        readonly extensions: readonly ["disposition-notification"];
    };
    readonly "message/external-body": {
        readonly source: "iana";
    };
    readonly "message/feedback-report": {
        readonly source: "iana";
    };
    readonly "message/global": {
        readonly source: "iana";
        readonly extensions: readonly ["u8msg"];
    };
    readonly "message/global-delivery-status": {
        readonly source: "iana";
        readonly extensions: readonly ["u8dsn"];
    };
    readonly "message/global-disposition-notification": {
        readonly source: "iana";
        readonly extensions: readonly ["u8mdn"];
    };
    readonly "message/global-headers": {
        readonly source: "iana";
        readonly extensions: readonly ["u8hdr"];
    };
    readonly "message/http": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "message/imdn+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "message/news": {
        readonly source: "iana";
    };
    readonly "message/partial": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "message/rfc822": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["eml", "mime"];
    };
    readonly "message/s-http": {
        readonly source: "iana";
    };
    readonly "message/sip": {
        readonly source: "iana";
    };
    readonly "message/sipfrag": {
        readonly source: "iana";
    };
    readonly "message/tracking-status": {
        readonly source: "iana";
    };
    readonly "message/vnd.si.simp": {
        readonly source: "iana";
    };
    readonly "message/vnd.wfa.wsc": {
        readonly source: "iana";
        readonly extensions: readonly ["wsc"];
    };
    readonly "model/3mf": {
        readonly source: "iana";
        readonly extensions: readonly ["3mf"];
    };
    readonly "model/e57": {
        readonly source: "iana";
    };
    readonly "model/gltf+json": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["gltf"];
    };
    readonly "model/gltf-binary": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["glb"];
    };
    readonly "model/iges": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["igs", "iges"];
    };
    readonly "model/mesh": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["msh", "mesh", "silo"];
    };
    readonly "model/mtl": {
        readonly source: "iana";
        readonly extensions: readonly ["mtl"];
    };
    readonly "model/obj": {
        readonly source: "iana";
        readonly extensions: readonly ["obj"];
    };
    readonly "model/step": {
        readonly source: "iana";
    };
    readonly "model/step+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["stpx"];
    };
    readonly "model/step+zip": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["stpz"];
    };
    readonly "model/step-xml+zip": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["stpxz"];
    };
    readonly "model/stl": {
        readonly source: "iana";
        readonly extensions: readonly ["stl"];
    };
    readonly "model/vnd.collada+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["dae"];
    };
    readonly "model/vnd.dwf": {
        readonly source: "iana";
        readonly extensions: readonly ["dwf"];
    };
    readonly "model/vnd.flatland.3dml": {
        readonly source: "iana";
    };
    readonly "model/vnd.gdl": {
        readonly source: "iana";
        readonly extensions: readonly ["gdl"];
    };
    readonly "model/vnd.gs-gdl": {
        readonly source: "apache";
    };
    readonly "model/vnd.gs.gdl": {
        readonly source: "iana";
    };
    readonly "model/vnd.gtw": {
        readonly source: "iana";
        readonly extensions: readonly ["gtw"];
    };
    readonly "model/vnd.moml+xml": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "model/vnd.mts": {
        readonly source: "iana";
        readonly extensions: readonly ["mts"];
    };
    readonly "model/vnd.opengex": {
        readonly source: "iana";
        readonly extensions: readonly ["ogex"];
    };
    readonly "model/vnd.parasolid.transmit.binary": {
        readonly source: "iana";
        readonly extensions: readonly ["x_b"];
    };
    readonly "model/vnd.parasolid.transmit.text": {
        readonly source: "iana";
        readonly extensions: readonly ["x_t"];
    };
    readonly "model/vnd.pytha.pyox": {
        readonly source: "iana";
    };
    readonly "model/vnd.rosette.annotated-data-model": {
        readonly source: "iana";
    };
    readonly "model/vnd.sap.vds": {
        readonly source: "iana";
        readonly extensions: readonly ["vds"];
    };
    readonly "model/vnd.usdz+zip": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["usdz"];
    };
    readonly "model/vnd.valve.source.compiled-map": {
        readonly source: "iana";
        readonly extensions: readonly ["bsp"];
    };
    readonly "model/vnd.vtu": {
        readonly source: "iana";
        readonly extensions: readonly ["vtu"];
    };
    readonly "model/vrml": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["wrl", "vrml"];
    };
    readonly "model/x3d+binary": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["x3db", "x3dbz"];
    };
    readonly "model/x3d+fastinfoset": {
        readonly source: "iana";
        readonly extensions: readonly ["x3db"];
    };
    readonly "model/x3d+vrml": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["x3dv", "x3dvz"];
    };
    readonly "model/x3d+xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["x3d", "x3dz"];
    };
    readonly "model/x3d-vrml": {
        readonly source: "iana";
        readonly extensions: readonly ["x3dv"];
    };
    readonly "multipart/alternative": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "multipart/appledouble": {
        readonly source: "iana";
    };
    readonly "multipart/byteranges": {
        readonly source: "iana";
    };
    readonly "multipart/digest": {
        readonly source: "iana";
    };
    readonly "multipart/encrypted": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "multipart/form-data": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "multipart/header-set": {
        readonly source: "iana";
    };
    readonly "multipart/mixed": {
        readonly source: "iana";
    };
    readonly "multipart/multilingual": {
        readonly source: "iana";
    };
    readonly "multipart/parallel": {
        readonly source: "iana";
    };
    readonly "multipart/related": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "multipart/report": {
        readonly source: "iana";
    };
    readonly "multipart/signed": {
        readonly source: "iana";
        readonly compressible: false;
    };
    readonly "multipart/vnd.bint.med-plus": {
        readonly source: "iana";
    };
    readonly "multipart/voice-message": {
        readonly source: "iana";
    };
    readonly "multipart/x-mixed-replace": {
        readonly source: "iana";
    };
    readonly "text/1d-interleaved-parityfec": {
        readonly source: "iana";
    };
    readonly "text/cache-manifest": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["appcache", "manifest"];
    };
    readonly "text/calendar": {
        readonly source: "iana";
        readonly extensions: readonly ["ics", "ifb"];
    };
    readonly "text/calender": {
        readonly compressible: true;
    };
    readonly "text/cmd": {
        readonly compressible: true;
    };
    readonly "text/coffeescript": {
        readonly extensions: readonly ["coffee", "litcoffee"];
    };
    readonly "text/cql": {
        readonly source: "iana";
    };
    readonly "text/cql-expression": {
        readonly source: "iana";
    };
    readonly "text/cql-identifier": {
        readonly source: "iana";
    };
    readonly "text/css": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["css"];
    };
    readonly "text/csv": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["csv"];
    };
    readonly "text/csv-schema": {
        readonly source: "iana";
    };
    readonly "text/directory": {
        readonly source: "iana";
    };
    readonly "text/dns": {
        readonly source: "iana";
    };
    readonly "text/ecmascript": {
        readonly source: "iana";
    };
    readonly "text/encaprtp": {
        readonly source: "iana";
    };
    readonly "text/enriched": {
        readonly source: "iana";
    };
    readonly "text/fhirpath": {
        readonly source: "iana";
    };
    readonly "text/flexfec": {
        readonly source: "iana";
    };
    readonly "text/fwdred": {
        readonly source: "iana";
    };
    readonly "text/gff3": {
        readonly source: "iana";
    };
    readonly "text/grammar-ref-list": {
        readonly source: "iana";
    };
    readonly "text/html": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["html", "htm", "shtml"];
    };
    readonly "text/jade": {
        readonly extensions: readonly ["jade"];
    };
    readonly "text/javascript": {
        readonly source: "iana";
        readonly compressible: true;
    };
    readonly "text/jcr-cnd": {
        readonly source: "iana";
    };
    readonly "text/jsx": {
        readonly compressible: true;
        readonly extensions: readonly ["jsx"];
    };
    readonly "text/less": {
        readonly compressible: true;
        readonly extensions: readonly ["less"];
    };
    readonly "text/markdown": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["markdown", "md"];
    };
    readonly "text/mathml": {
        readonly source: "nginx";
        readonly extensions: readonly ["mml"];
    };
    readonly "text/mdx": {
        readonly compressible: true;
        readonly extensions: readonly ["mdx"];
    };
    readonly "text/mizar": {
        readonly source: "iana";
    };
    readonly "text/n3": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["n3"];
    };
    readonly "text/parameters": {
        readonly source: "iana";
        readonly charset: "UTF-8";
    };
    readonly "text/parityfec": {
        readonly source: "iana";
    };
    readonly "text/plain": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["txt", "text", "conf", "def", "list", "log", "in", "ini"];
    };
    readonly "text/provenance-notation": {
        readonly source: "iana";
        readonly charset: "UTF-8";
    };
    readonly "text/prs.fallenstein.rst": {
        readonly source: "iana";
    };
    readonly "text/prs.lines.tag": {
        readonly source: "iana";
        readonly extensions: readonly ["dsc"];
    };
    readonly "text/prs.prop.logic": {
        readonly source: "iana";
    };
    readonly "text/raptorfec": {
        readonly source: "iana";
    };
    readonly "text/red": {
        readonly source: "iana";
    };
    readonly "text/rfc822-headers": {
        readonly source: "iana";
    };
    readonly "text/richtext": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rtx"];
    };
    readonly "text/rtf": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["rtf"];
    };
    readonly "text/rtp-enc-aescm128": {
        readonly source: "iana";
    };
    readonly "text/rtploopback": {
        readonly source: "iana";
    };
    readonly "text/rtx": {
        readonly source: "iana";
    };
    readonly "text/sgml": {
        readonly source: "iana";
        readonly extensions: readonly ["sgml", "sgm"];
    };
    readonly "text/shaclc": {
        readonly source: "iana";
    };
    readonly "text/shex": {
        readonly source: "iana";
        readonly extensions: readonly ["shex"];
    };
    readonly "text/slim": {
        readonly extensions: readonly ["slim", "slm"];
    };
    readonly "text/spdx": {
        readonly source: "iana";
        readonly extensions: readonly ["spdx"];
    };
    readonly "text/strings": {
        readonly source: "iana";
    };
    readonly "text/stylus": {
        readonly extensions: readonly ["stylus", "styl"];
    };
    readonly "text/t140": {
        readonly source: "iana";
    };
    readonly "text/tab-separated-values": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["tsv"];
    };
    readonly "text/troff": {
        readonly source: "iana";
        readonly extensions: readonly ["t", "tr", "roff", "man", "me", "ms"];
    };
    readonly "text/turtle": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly extensions: readonly ["ttl"];
    };
    readonly "text/ulpfec": {
        readonly source: "iana";
    };
    readonly "text/uri-list": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["uri", "uris", "urls"];
    };
    readonly "text/vcard": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["vcard"];
    };
    readonly "text/vnd.a": {
        readonly source: "iana";
    };
    readonly "text/vnd.abc": {
        readonly source: "iana";
    };
    readonly "text/vnd.ascii-art": {
        readonly source: "iana";
    };
    readonly "text/vnd.curl": {
        readonly source: "iana";
        readonly extensions: readonly ["curl"];
    };
    readonly "text/vnd.curl.dcurl": {
        readonly source: "apache";
        readonly extensions: readonly ["dcurl"];
    };
    readonly "text/vnd.curl.mcurl": {
        readonly source: "apache";
        readonly extensions: readonly ["mcurl"];
    };
    readonly "text/vnd.curl.scurl": {
        readonly source: "apache";
        readonly extensions: readonly ["scurl"];
    };
    readonly "text/vnd.debian.copyright": {
        readonly source: "iana";
        readonly charset: "UTF-8";
    };
    readonly "text/vnd.dmclientscript": {
        readonly source: "iana";
    };
    readonly "text/vnd.dvb.subtitle": {
        readonly source: "iana";
        readonly extensions: readonly ["sub"];
    };
    readonly "text/vnd.esmertec.theme-descriptor": {
        readonly source: "iana";
        readonly charset: "UTF-8";
    };
    readonly "text/vnd.familysearch.gedcom": {
        readonly source: "iana";
        readonly extensions: readonly ["ged"];
    };
    readonly "text/vnd.ficlab.flt": {
        readonly source: "iana";
    };
    readonly "text/vnd.fly": {
        readonly source: "iana";
        readonly extensions: readonly ["fly"];
    };
    readonly "text/vnd.fmi.flexstor": {
        readonly source: "iana";
        readonly extensions: readonly ["flx"];
    };
    readonly "text/vnd.gml": {
        readonly source: "iana";
    };
    readonly "text/vnd.graphviz": {
        readonly source: "iana";
        readonly extensions: readonly ["gv"];
    };
    readonly "text/vnd.hans": {
        readonly source: "iana";
    };
    readonly "text/vnd.hgl": {
        readonly source: "iana";
    };
    readonly "text/vnd.in3d.3dml": {
        readonly source: "iana";
        readonly extensions: readonly ["3dml"];
    };
    readonly "text/vnd.in3d.spot": {
        readonly source: "iana";
        readonly extensions: readonly ["spot"];
    };
    readonly "text/vnd.iptc.newsml": {
        readonly source: "iana";
    };
    readonly "text/vnd.iptc.nitf": {
        readonly source: "iana";
    };
    readonly "text/vnd.latex-z": {
        readonly source: "iana";
    };
    readonly "text/vnd.motorola.reflex": {
        readonly source: "iana";
    };
    readonly "text/vnd.ms-mediapackage": {
        readonly source: "iana";
    };
    readonly "text/vnd.net2phone.commcenter.command": {
        readonly source: "iana";
    };
    readonly "text/vnd.radisys.msml-basic-layout": {
        readonly source: "iana";
    };
    readonly "text/vnd.senx.warpscript": {
        readonly source: "iana";
    };
    readonly "text/vnd.si.uricatalogue": {
        readonly source: "iana";
    };
    readonly "text/vnd.sosi": {
        readonly source: "iana";
    };
    readonly "text/vnd.sun.j2me.app-descriptor": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly extensions: readonly ["jad"];
    };
    readonly "text/vnd.trolltech.linguist": {
        readonly source: "iana";
        readonly charset: "UTF-8";
    };
    readonly "text/vnd.wap.si": {
        readonly source: "iana";
    };
    readonly "text/vnd.wap.sl": {
        readonly source: "iana";
    };
    readonly "text/vnd.wap.wml": {
        readonly source: "iana";
        readonly extensions: readonly ["wml"];
    };
    readonly "text/vnd.wap.wmlscript": {
        readonly source: "iana";
        readonly extensions: readonly ["wmls"];
    };
    readonly "text/vtt": {
        readonly source: "iana";
        readonly charset: "UTF-8";
        readonly compressible: true;
        readonly extensions: readonly ["vtt"];
    };
    readonly "text/x-asm": {
        readonly source: "apache";
        readonly extensions: readonly ["s", "asm"];
    };
    readonly "text/x-c": {
        readonly source: "apache";
        readonly extensions: readonly ["c", "cc", "cxx", "cpp", "h", "hh", "dic"];
    };
    readonly "text/x-component": {
        readonly source: "nginx";
        readonly extensions: readonly ["htc"];
    };
    readonly "text/x-fortran": {
        readonly source: "apache";
        readonly extensions: readonly ["f", "for", "f77", "f90"];
    };
    readonly "text/x-gwt-rpc": {
        readonly compressible: true;
    };
    readonly "text/x-handlebars-template": {
        readonly extensions: readonly ["hbs"];
    };
    readonly "text/x-java-source": {
        readonly source: "apache";
        readonly extensions: readonly ["java"];
    };
    readonly "text/x-jquery-tmpl": {
        readonly compressible: true;
    };
    readonly "text/x-lua": {
        readonly extensions: readonly ["lua"];
    };
    readonly "text/x-markdown": {
        readonly compressible: true;
        readonly extensions: readonly ["mkd"];
    };
    readonly "text/x-nfo": {
        readonly source: "apache";
        readonly extensions: readonly ["nfo"];
    };
    readonly "text/x-opml": {
        readonly source: "apache";
        readonly extensions: readonly ["opml"];
    };
    readonly "text/x-org": {
        readonly compressible: true;
        readonly extensions: readonly ["org"];
    };
    readonly "text/x-pascal": {
        readonly source: "apache";
        readonly extensions: readonly ["p", "pas"];
    };
    readonly "text/x-processing": {
        readonly compressible: true;
        readonly extensions: readonly ["pde"];
    };
    readonly "text/x-sass": {
        readonly extensions: readonly ["sass"];
    };
    readonly "text/x-scss": {
        readonly extensions: readonly ["scss"];
    };
    readonly "text/x-setext": {
        readonly source: "apache";
        readonly extensions: readonly ["etx"];
    };
    readonly "text/x-sfv": {
        readonly source: "apache";
        readonly extensions: readonly ["sfv"];
    };
    readonly "text/x-suse-ymp": {
        readonly compressible: true;
        readonly extensions: readonly ["ymp"];
    };
    readonly "text/x-uuencode": {
        readonly source: "apache";
        readonly extensions: readonly ["uu"];
    };
    readonly "text/x-vcalendar": {
        readonly source: "apache";
        readonly extensions: readonly ["vcs"];
    };
    readonly "text/x-vcard": {
        readonly source: "apache";
        readonly extensions: readonly ["vcf"];
    };
    readonly "text/xml": {
        readonly source: "iana";
        readonly compressible: true;
        readonly extensions: readonly ["xml"];
    };
    readonly "text/xml-external-parsed-entity": {
        readonly source: "iana";
    };
    readonly "text/yaml": {
        readonly compressible: true;
        readonly extensions: readonly ["yaml", "yml"];
    };
    readonly "video/1d-interleaved-parityfec": {
        readonly source: "iana";
    };
    readonly "video/3gpp": {
        readonly source: "iana";
        readonly extensions: readonly ["3gp", "3gpp"];
    };
    readonly "video/3gpp-tt": {
        readonly source: "iana";
    };
    readonly "video/3gpp2": {
        readonly source: "iana";
        readonly extensions: readonly ["3g2"];
    };
    readonly "video/av1": {
        readonly source: "iana";
    };
    readonly "video/bmpeg": {
        readonly source: "iana";
    };
    readonly "video/bt656": {
        readonly source: "iana";
    };
    readonly "video/celb": {
        readonly source: "iana";
    };
    readonly "video/dv": {
        readonly source: "iana";
    };
    readonly "video/encaprtp": {
        readonly source: "iana";
    };
    readonly "video/ffv1": {
        readonly source: "iana";
    };
    readonly "video/flexfec": {
        readonly source: "iana";
    };
    readonly "video/h261": {
        readonly source: "iana";
        readonly extensions: readonly ["h261"];
    };
    readonly "video/h263": {
        readonly source: "iana";
        readonly extensions: readonly ["h263"];
    };
    readonly "video/h263-1998": {
        readonly source: "iana";
    };
    readonly "video/h263-2000": {
        readonly source: "iana";
    };
    readonly "video/h264": {
        readonly source: "iana";
        readonly extensions: readonly ["h264"];
    };
    readonly "video/h264-rcdo": {
        readonly source: "iana";
    };
    readonly "video/h264-svc": {
        readonly source: "iana";
    };
    readonly "video/h265": {
        readonly source: "iana";
    };
    readonly "video/iso.segment": {
        readonly source: "iana";
        readonly extensions: readonly ["m4s"];
    };
    readonly "video/jpeg": {
        readonly source: "iana";
        readonly extensions: readonly ["jpgv"];
    };
    readonly "video/jpeg2000": {
        readonly source: "iana";
    };
    readonly "video/jpm": {
        readonly source: "apache";
        readonly extensions: readonly ["jpm", "jpgm"];
    };
    readonly "video/jxsv": {
        readonly source: "iana";
    };
    readonly "video/mj2": {
        readonly source: "iana";
        readonly extensions: readonly ["mj2", "mjp2"];
    };
    readonly "video/mp1s": {
        readonly source: "iana";
    };
    readonly "video/mp2p": {
        readonly source: "iana";
    };
    readonly "video/mp2t": {
        readonly source: "iana";
        readonly extensions: readonly ["ts"];
    };
    readonly "video/mp4": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["mp4", "mp4v", "mpg4"];
    };
    readonly "video/mp4v-es": {
        readonly source: "iana";
    };
    readonly "video/mpeg": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["mpeg", "mpg", "mpe", "m1v", "m2v"];
    };
    readonly "video/mpeg4-generic": {
        readonly source: "iana";
    };
    readonly "video/mpv": {
        readonly source: "iana";
    };
    readonly "video/nv": {
        readonly source: "iana";
    };
    readonly "video/ogg": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["ogv"];
    };
    readonly "video/parityfec": {
        readonly source: "iana";
    };
    readonly "video/pointer": {
        readonly source: "iana";
    };
    readonly "video/quicktime": {
        readonly source: "iana";
        readonly compressible: false;
        readonly extensions: readonly ["qt", "mov"];
    };
    readonly "video/raptorfec": {
        readonly source: "iana";
    };
    readonly "video/raw": {
        readonly source: "iana";
    };
    readonly "video/rtp-enc-aescm128": {
        readonly source: "iana";
    };
    readonly "video/rtploopback": {
        readonly source: "iana";
    };
    readonly "video/rtx": {
        readonly source: "iana";
    };
    readonly "video/scip": {
        readonly source: "iana";
    };
    readonly "video/smpte291": {
        readonly source: "iana";
    };
    readonly "video/smpte292m": {
        readonly source: "iana";
    };
    readonly "video/ulpfec": {
        readonly source: "iana";
    };
    readonly "video/vc1": {
        readonly source: "iana";
    };
    readonly "video/vc2": {
        readonly source: "iana";
    };
    readonly "video/vnd.cctv": {
        readonly source: "iana";
    };
    readonly "video/vnd.dece.hd": {
        readonly source: "iana";
        readonly extensions: readonly ["uvh", "uvvh"];
    };
    readonly "video/vnd.dece.mobile": {
        readonly source: "iana";
        readonly extensions: readonly ["uvm", "uvvm"];
    };
    readonly "video/vnd.dece.mp4": {
        readonly source: "iana";
    };
    readonly "video/vnd.dece.pd": {
        readonly source: "iana";
        readonly extensions: readonly ["uvp", "uvvp"];
    };
    readonly "video/vnd.dece.sd": {
        readonly source: "iana";
        readonly extensions: readonly ["uvs", "uvvs"];
    };
    readonly "video/vnd.dece.video": {
        readonly source: "iana";
        readonly extensions: readonly ["uvv", "uvvv"];
    };
    readonly "video/vnd.directv.mpeg": {
        readonly source: "iana";
    };
    readonly "video/vnd.directv.mpeg-tts": {
        readonly source: "iana";
    };
    readonly "video/vnd.dlna.mpeg-tts": {
        readonly source: "iana";
    };
    readonly "video/vnd.dvb.file": {
        readonly source: "iana";
        readonly extensions: readonly ["dvb"];
    };
    readonly "video/vnd.fvt": {
        readonly source: "iana";
        readonly extensions: readonly ["fvt"];
    };
    readonly "video/vnd.hns.video": {
        readonly source: "iana";
    };
    readonly "video/vnd.iptvforum.1dparityfec-1010": {
        readonly source: "iana";
    };
    readonly "video/vnd.iptvforum.1dparityfec-2005": {
        readonly source: "iana";
    };
    readonly "video/vnd.iptvforum.2dparityfec-1010": {
        readonly source: "iana";
    };
    readonly "video/vnd.iptvforum.2dparityfec-2005": {
        readonly source: "iana";
    };
    readonly "video/vnd.iptvforum.ttsavc": {
        readonly source: "iana";
    };
    readonly "video/vnd.iptvforum.ttsmpeg2": {
        readonly source: "iana";
    };
    readonly "video/vnd.motorola.video": {
        readonly source: "iana";
    };
    readonly "video/vnd.motorola.videop": {
        readonly source: "iana";
    };
    readonly "video/vnd.mpegurl": {
        readonly source: "iana";
        readonly extensions: readonly ["mxu", "m4u"];
    };
    readonly "video/vnd.ms-playready.media.pyv": {
        readonly source: "iana";
        readonly extensions: readonly ["pyv"];
    };
    readonly "video/vnd.nokia.interleaved-multimedia": {
        readonly source: "iana";
    };
    readonly "video/vnd.nokia.mp4vr": {
        readonly source: "iana";
    };
    readonly "video/vnd.nokia.videovoip": {
        readonly source: "iana";
    };
    readonly "video/vnd.objectvideo": {
        readonly source: "iana";
    };
    readonly "video/vnd.radgamettools.bink": {
        readonly source: "iana";
    };
    readonly "video/vnd.radgamettools.smacker": {
        readonly source: "iana";
    };
    readonly "video/vnd.sealed.mpeg1": {
        readonly source: "iana";
    };
    readonly "video/vnd.sealed.mpeg4": {
        readonly source: "iana";
    };
    readonly "video/vnd.sealed.swf": {
        readonly source: "iana";
    };
    readonly "video/vnd.sealedmedia.softseal.mov": {
        readonly source: "iana";
    };
    readonly "video/vnd.uvvu.mp4": {
        readonly source: "iana";
        readonly extensions: readonly ["uvu", "uvvu"];
    };
    readonly "video/vnd.vivo": {
        readonly source: "iana";
        readonly extensions: readonly ["viv"];
    };
    readonly "video/vnd.youtube.yt": {
        readonly source: "iana";
    };
    readonly "video/vp8": {
        readonly source: "iana";
    };
    readonly "video/vp9": {
        readonly source: "iana";
    };
    readonly "video/webm": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["webm"];
    };
    readonly "video/x-f4v": {
        readonly source: "apache";
        readonly extensions: readonly ["f4v"];
    };
    readonly "video/x-fli": {
        readonly source: "apache";
        readonly extensions: readonly ["fli"];
    };
    readonly "video/x-flv": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["flv"];
    };
    readonly "video/x-m4v": {
        readonly source: "apache";
        readonly extensions: readonly ["m4v"];
    };
    readonly "video/x-matroska": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["mkv", "mk3d", "mks"];
    };
    readonly "video/x-mng": {
        readonly source: "apache";
        readonly extensions: readonly ["mng"];
    };
    readonly "video/x-ms-asf": {
        readonly source: "apache";
        readonly extensions: readonly ["asf", "asx"];
    };
    readonly "video/x-ms-vob": {
        readonly source: "apache";
        readonly extensions: readonly ["vob"];
    };
    readonly "video/x-ms-wm": {
        readonly source: "apache";
        readonly extensions: readonly ["wm"];
    };
    readonly "video/x-ms-wmv": {
        readonly source: "apache";
        readonly compressible: false;
        readonly extensions: readonly ["wmv"];
    };
    readonly "video/x-ms-wmx": {
        readonly source: "apache";
        readonly extensions: readonly ["wmx"];
    };
    readonly "video/x-ms-wvx": {
        readonly source: "apache";
        readonly extensions: readonly ["wvx"];
    };
    readonly "video/x-msvideo": {
        readonly source: "apache";
        readonly extensions: readonly ["avi"];
    };
    readonly "video/x-sgi-movie": {
        readonly source: "apache";
        readonly extensions: readonly ["movie"];
    };
    readonly "video/x-smv": {
        readonly source: "apache";
        readonly extensions: readonly ["smv"];
    };
    readonly "x-conference/x-cooltalk": {
        readonly source: "apache";
        readonly extensions: readonly ["ice"];
    };
    readonly "x-shader/x-fragment": {
        readonly compressible: true;
    };
    readonly "x-shader/x-vertex": {
        readonly compressible: true;
    };
};
export default _default;
